   ==================================================================
   ===                                                            ===
   ===           GENESIS Distributed Memory Benchmarks            ===
   ===                                                            ===
   ===                            LPM1                            ===
   ===                                                            ===
   ===             Local Particle-Mesh Device Simulation          ===
   ===                                                            ===
   ===               Author:   Roger Hockney                      ===
   ===     Department of Electronics and Computer Science         ===
   ===               University of Southampton                    ===
   ===               Southampton SO9 5NH, U.K.                    ===
   ===     fax.:+44-703-593045   e-mail:rwh@uk.ac.soton.ecs       ===
   ===                                                            ===
   ===     Copyright: SNARC, University of Southampton            ===
   ===                                                            ===
   ===          Last update: March 1992; Release: 2.0             ===
   ===                                                            ===
   ==================================================================


1. Description
--------------

This benchmark is the simulation of an electronic device using a 
particle-mesh (PM) method, often also called a particle-in-cell (PIC)
simulation. In each timestep the electric and magnetic fields on an 
(LMAX x MMAX) mesh are advanced explicitly in time using Maxwell's
equations, and the particles (electrons) are advanced in the fields 
using Newton's equations.

The benchmark is described as local because the time scale is such that
the fields may be computed explicitly, using fields only local to each 
mesh point. The number of particles at the end of the run of 1 picosecond
is given empirically by

                       628*alpha**1.172  

As the number of mesh-points increases for the same physical dimension,
the time-step must be reduced to satisfy the CFL stability criterion.  
This effect has an important influence on the meaning of the performance
metrics. The performance is expressed in several different metrics (and
units) for comparison purposes.  As well as the traditional Speedup and
Efficiency, we give the Temporal (tstep/s), Simulation (sim-ps/s), and
Benchmark (mflop/s(lpm1)) performance, which are much more meaningful and
useful measures.

Parallelisation is by one-dimensional domain decomposition, in the first 
coordinate. Each processor is responsible for a slab of space, and stores
the mesh-ponts and coordinates of particles in its region of space. During
each timestep, particle coordinates are transferred between processors as
the particles move from region to region.

Temporal Performance

Temporal performance is the inverse of the execution time, here expressed
in units of timestep per second (tstep/s).  This is the fundamental metric
of performance, because it is in absolute units and one can guarantee that
the code with the highest temporal performance executes in the least time.

Speedup and Efficiency

Speedup, Sp, has the traditional definition of the ratio of 1-proc to 
n-proc. execution time, and Efficiency, Ep, is Speedup per processor. 
Because Speedup is a relative measure, the program with the highest 
Speedup may not execute in the least time! Be warned.

Simulation Performance

This metric measures the amount of simulated time computed in one real 
wall-clock second. It is the most meaningful metric for a simulation, 
because it is what the user actually wishes to maximise. For this 
benchmark, the units are simulated picosecond per second (sim-ps/s). 
In this metric larger problems with more mesh points run slower (which 
in fact they do), although they generate more Speedup and Mflop/s! This 
metric also includes the fact that problems with a smaller space step 
often must use a smaller timestep, and therefore take more timesteps to
cover the same amount of simulated time. 

Benchmark Performance

This metric is calculated from the nominal number of floating-point 
operations needed to perform the benchmark on a single processor.  For 
the one-nanosecond benchmark setup here, the average number of floating-
point operations per timestep is defined to be:

             F_b(alpha) = 46*75*33*alpha + 58*628*alpha**1.172

where the size factor alpha=1,2,4,8 for cases NBEN3=1,2,3,4. The first 
term above is the work to update the fields on the mesh, and the second
term is the work to move the particles.  Then the benchmark performance is
	
              R_b(alpha,p) = F_b(alpha)/Tp(alpha,p)

Performance calculated in this way has the units Mflop/s(LPM1). Different
parallel implementations may, in fact, perform more or fewer operations
than the above, but they are only credited with the number given by the
formula.  Because F_b is fixed for all codes, we can quarantee that the
code with the highest benchmark performance executes in the least time.


2. Operating Instructions
-------------------------

Changing problem size and numbers of processes:

Most of the parameters are internally fixed. The user has to specify 
only the number of processors and the number of particles. These are 
input from the standard input on cannel 5.

Suggested Problem Sizes :

Four benchmark cases are provided (NBEN3=1,2,3,4), giving four problem 
sizes described by the size factor alpha=1,2,4,8 and mesh numbers
(75*alpha,33).


Compiling and running the benchmark:
 
1) To compile and link the benchmark type:   make
  
2) To run the benchmark type:     host
   
3) Input parameters from the standard input:

    -Number of nodes for mimd run is at maximum one less than
     the number of nodes allocated by getcube (4 in above example)
     because one node is always used to perform a 1-processor
     check calculation.

    -For every problem size, the 1-processor calculation must be
     performed once. The results are stored in the four check 
     result files: res1p.size1, ... , res1p.size4. After that
     benchmark runs can be performed without waiting for the
     1-processor run, which is slow for the largest problem size.
     To omit the 1-processor run answer 0 to the second question.

The results for the four problem sizes, cases 1,2,3 and 4, and
different number of processors are put automatically in different 
output files, with notation (for example):

  lpm1c3p25 - output for lpm1 benchmark, case 3 for 25 processors

If you wish to put the files elsewhere there is a prompt to tell you
when to do it with a Unix cp command.

Files

      host.u      - host program, contains PARMACS for host.
      node.u      - node main program and all communication interface
                    routines, therefore all node PARMACS calls are here.
      benctl.f    - benchmark control, may be changed to modify
                    output, but usually left alone. No PARMACS here.
      lpm1bk.f    - body of benchmark code. Not to be touched.
      res1p.size1 - correct results on one processor for standard
                    size problem, case1, (75x33) mesh.
      res1p.size2 - results for case2 problem (150x33) mesh.
      res1p.size3 - results for case3 problem (300x33) mesh.
      res1p.size4 - results for case4 problem (600x33) mesh.
      secowa.f    - LPM1 program second timer, which calls
                    the standard benchmark system timer
      header.f    - standard header information
      pm1c4p100   - etc, output files generated by program

3. Accuracy Check
-----------------
Because the simulation uses random numbers, the multi-processor
calculation cannot be expected to give identical results to the
uni-processor calculation. however, the percentage difference in
particle number, NP, and average B-field, BAV, in the last timestep,
should not exceed a few percent.  Calculations are accepted if
differences < 10%

   ==================================================================
   ===                                                            ===
   ===           GENESIS Distributed Memory Benchmarks            ===
   ===                                                            ===
   ===                           PDE1                             ===
   ===                                                            ===
   ===   3-Dimensional Poisson Solver Using Red-Black Relaxation  ===
   ===                                                            ===
   ===     Original authors:        J. Klose, M. Lemke            ===
   ===     PARMACS macros  :        Clemens-August Thole          ===
   ===              PALLAS GmbH                                   ===
   ===              Hermulheimer Str. 10                          ===
   ===              5040 Bruhl, GERMANY                           ===
   ===     tel.:+49-2232-18960   e-mail:karls@pallas-gmbh.de      ===
   ===                                                            ===
   ===     Copyright: PALLAS GmbH                                 ===
   ===                                                            ===
   ===          Last update: April 1992; Release: 2.0             ===
   ===                                                            ===
   ==================================================================


1. Description
--------------
The benchmark solves the Poisson-Equation on a 3-dimensional
grid by parallel red-black relaxation.

Many problems in the area of scientific computing are formulated in
terms of partial differential equations. Typical application areas are
Computational Fluid Dynamics, Meteorology, Climate Research, Oil
Reservoir simulation and others. The resulting PDEs are discretized
on some grid structure. The PDE is then represented by a large set of
(non)linear equations, each of which couples values at neighbouring grid
point with each other. For time-dependent problems, this set of
equations has to be determined (integration phase) and solved (solution
phase) at each time step.

This benchmark is an extreme example of the class of PDE solvers, as
due to the simplicity of the discretization of Poisson's equation the
number of floating point operations per gridpoint is quite small relative
to more complex PDEs. The ratio of computation to communication is
thus rather low.

The parallelization is performed by grid splitting. A part of the
computational grid is assigned to each processor. After each
computational step, values at the boundary of the subgrids are exchanged
with nearest neighbours.


2) Operating Instructions
-------------------------

A. Sequential version

The sequential version automatically produces results for a range of
problem sizes. The problem size is determined by the grid size, which
is related to the parameter N. The number of grid points in each
direction is 2**N + 1, giving (2**N + 1)**3 points in 3 dimensions.

The parameter N is varied from 3 to MMAX within the benchmark and
the benchmark performance calculated for each resulting problem size.
The value of MMAX can be changed by editing the PARAMETER statement
in the file pde1.inc. The maximum value of MMAX which is consistent with 
the available processor memory should be chosen.
The memory required is of the order { 2 * (2**MMAX + 1)**3 } * 8 bytes
For the largest problem size the relative sizes of the grid in each
dimension is varied whilst keeping the overall problem size roughly
constant. This variation in the shape of the grid for the same problem
size can increase performance by allowing more efficient vectorization.

For each problem size, the benchmark gives the performance firstly for the
standard implementation and then for potential optimisations using
loop unrolling to depth 2 in each dimension and also for a single loop
in 2 dimensions.

Compiling and running the sequential benchmark:

1) Change value of MMAX in file pde1.inc, if appropriate, to give maximum 
   problem size compatible with the available memory. (see above)

2) To compile and link the benchmark type:   make  

3) To run the benchmark type:     pde1
 
   Output from the benchmark is written to the file "result"


B) Distributed Version

In the distributed version of the program the problem size and the
number of processes are input from the standard input on channel 5.

The total lattice size is determined by the parameter NN. 
The number of grid points in each direction is 2**NN + 1, 
giving (2**NN + 1)**3 points in 3 dimensions.
This lattice is distributed over a 3-dimensional processes array of
dimensions  NXPROC * NYPROC * NZPROC,
Where NXPROC, NYPROC, NZPROC are greater than or equal to 1

The size of the local lattice determines the size of the workspace
required in the node program. The size of this workspace is determined
by a PARAMETER statement in the file node.u of the form:

       PARAMETER (NWORKD = 10000)

The size of NWORKD should be changed if necessary to ensure that it is
greater than or equal to (2**NN + 4)**3/(NPROCX * NPROCY *NPROCZ)
The maximum size of NWORKD, and hence of the local lattice size, is
constrained by the available node memory. The node memory required
will be of the order 3 * NWORKD * 8 bytes. The maximum value of NN is 
likely to be 6 or 7.


Compiling and running the distributed benchmark:

1) Change value of NWORKD in file node.u, if appropriate, to give maximum 
   work space compatible with the available memory. (see above)

2) To compile and link the benchmark type:   make  

3) To run the benchmark type:     host
 
4) Input parameters NN, NXPROC, NYPROC, NZPROC (see above) on standard
   input.

   Output from the benchmark is written to the file "result"

   ==================================================================
   ===                                                            ===
   ===           GENESIS Distributed Memory Benchmarks            ===
   ===                                                            ===
   ===                           QCD2                             ===
   ===                                                            ===
   ===     Conjugate Gradient iteration in SU(3) lattice gauge    ===
   ===              theory with Kogut-Susskind fermions           ===
   ===                                                            ===
   ===     Original author:        John Merlin                    ===
   ===     Modified by    :        Ivan Wolton                    ===
   ===     PARMACS macros :        Vladimir Getov                 ===
   ===     Department of Electronics and Computer Science         ===
   ===               University of Southampton                    ===
   ===               Southampton SO9 5NH, U.K.                    ===
   ===     fax.:+44-703-593045   e-mail:icw@uk.ac.soton.ecs       ===
   ===                                  vsg@uk.ac.soton.ecs       ===
   ===                                                            ===
   ===     Copyright: SNARC, University of Southampton            ===
   ===                                                            ===
   ===          Last update: October 1991; Release: 2.0           ===
   ===                                                            ===
   ==================================================================


1. Description
--------------
This benchmark consists of solving a large, sparse system of linear
equations using conjugate gradient iteration. The equations are
derived from a lattice gauge theory simulation using dynamical Kogut-Susskind
fermions. Conjugate gradient methods form the core of several
important algorithms for lattice gauge theory with fermions.
Supercomputer performance is essential for such problems as the
inclusion of dynamical fermions increases the computational effort
required by several orders of magnitude over the 'quenched'
approximation. (The quenched approximation is used in the QCD1
benchmark)

Simulations are defined on four-dimensional lattices which are
discrete approximations to continuum space-time. The basic variables
are 3 by 3 complex matrices. Four such matrices are associated with
every lattice site.

The benchmark takes the common approach of updating the variables on
all even sites, and then on all odd sites, on alternate steps. Updating a
site variable requires a number of matrix multiplications
and involves matrices from neighbouring sites. Almost all
the arithmetic operations are vectorizable. However, in order to
achieve this vectorization an overhead is incurred in internal shifts
of neighbouring matrices, which can become a significant part of the 
execution time.

The parallel version of the program distibutes the spatial
dimension of the lattice over a cuboidal process grid.
Communications involve both the shifting of matrices from neighbouring
processors and a global summation followed by a broadcast. 


2. Operating Instructions
-------------------------

Changing problem size and number of processors:

The lattice size is based on a 4-dimensional space-time lattice of
size:  N = Nt * Nx**3, where Nt & Nx are even integers.
The parallel version of the program is distributed over the spatial
dimensions in a cuboidal process grid of size:  P = Px * Py * Pz
The local lattice size on each processor is then: 

    n = Nt * (Nx/Px) * (Nx/Py) * Nx/Pz)

There is no input data file. The lattice and processor grid dimensions
are specified by PARAMETER statements in an INCLUDE file (qcd2.inc). 
The values of Nt, Nx, Px, Py & Pz should be chosen such that the 
dimensions of the local lattice size are even integers. All other
parameters are set explicitly in a call to the subroutine setpar.


Suggested Problem Sizes :

The smallest possible local lattice size is 2 * 2**3 
- 2**4 lattice points per processor. Though in this case the granularity is 
too small to give either efficient distribution or vectorization.

A more reasonable minimum lattice size per processor is 2**6 lattice points,
ie. 8 * 4**3 on an 8 proccessor grid or 4* 8**3 on 32 processors.

The likely maximum local lattice size that will fit into node memory is
around 2**11 local lattice points, ie 32 * 8**3 on an 8 processor grid

It is suggested that the benchmark is run for a range of problem sizes
from the suggested miminmum to the maximum possible lattice size over
the range of number of available processors.


Compiling and Running the Benchmark:

1) Choose problem size and number of processors, edit the include file 
   qcd2.inc to set the appropriate parameters.

2) To expand the PARMACS macros, compile and link the code
   with the appropriate libraries, Type:    make 

3) If any of the parameters in the include files are changed,
   the code has to be recompiled. The make-file will automatically
   send to the compiler only affected files, Type   make

4) On some systems it may be necessary to allocate the appropriate
   resources before running the benchmark, eg. on the iPSC/860
   to reserve a cube of 8 processors, type:    getcube -t8

5a) To run the sequential benchmark , type:    qcd2

5b) To run the distributed benchmark , type:   host

   This will automatically load both host and node programs. 

   The progress of the benchmark execution can be monitored via
   the standard output, whilst a permanent copy of the benchmark output
   is written to a file called 'result'.

6) If the run is successful and a permanent record is required, the
   file 'result' should be copied to another file before the next run
   overwrites it.


3. Hints for Optimisation (Blockshift versus indirect addressing)
-----------------------------------------------------------------
Two routines are provided for the shift operation, blockshift and
shiftvec. Blockshift shifts coherent blocks corresponding to a given
lattice direction. The problem is that the block length is rather
small for the t & x directions and so with large vector startups
the vector efficiency is poor. Hence in these directions it is more 
efficient to use the indirect addressing version of the shift routine 
shiftvec. 

The shift routines are called from the routine dvec which by default 
uses shiftvec in the t and x directions and blockshift in the y & z 
directions. For best performance with smaller lattices, blockshift should 
be used in the y direction.



4. Accuracy Check
-----------------
The output results are best characterised by the total energy per
lattice point (output in columnn 3). The program can be considered to
have run successfully if the following two conditions are met.

1) The total energy should be constant to 5 decimal places for each
   iteration (a small variation in the final 6th place is allowable). 

2) This constant value should be close to 3.0 

Unfortunately it is difficult to be more precise as the fermion and gauge 
fields are initialised by a random number generator. Consequently the exact
value of the total energy is then dependent on the number of processors and 
the problem size. 

   ==================================================================
   ===                                                            ===
   ===           GENESIS Distributed Memory Benchmarks            ===
   ===                                                            ===
   ===                           COMMS2                           ===
   ===                                                            ===
   ===                      Message Exchange                      ===
   ===                                                            ===
   ===               Author:   Roger Hockney                      ===
   ===     Department of Electronics and Computer Science         ===
   ===               University of Southampton                    ===
   ===               Southampton SO9 5NH, U.K.                    ===
   ===     fax.:+44-703-593045   e-mail:rwh@uk.ac.soton.ecs       ===
   ===                                                            ===
   ===     Copyright: SNARC, University of Southampton            ===
   ===                                                            ===
   ===          Last update: March 1992; Release: 2.0             ===
   ===                                                            ===
   ==================================================================


1. Description
--------------
This benchmark measures the message exchange properties of a
computer network, and makes use of bidirectional links if they
are present. A pair of nodes send a message of varying length,
n, to each other and then wait to receive the message from the other 
of the pair.  One quarter of the time for this exchange is recorded 
as the time, t, to send a message, because four messages are sent 
during the exchange. This time is fitted by least-squares to the 
straight-line relation:

                     t = (n + nhalf) / rinf                   (1)

where  rinf  = the asymptotic stream rate (Byte/s), and
       nhalf = the message length (Byte) giving half the 
               asymptotic performance

This corresponds to an average performance, r, as a function of 
message length, n,
                            rinf
                    r = -------------                          (2)
                        (1 + nhalf/n)

In the above formula rinf is the asymptotic stream rate to use with the
value of nhalf in order to calculate the average bandwidth. For short
messages the values of rinf may be high but they will not be achieved
because of the effect of nhalf via equation (2).

The benchmark is restricted to asynchronous communication. Asynchronous,
here, means that a send returns to the calling program when the user 
data array being sent may be safely reused.  This, however, may be 
before the message has been received by the receiving node.  The 
receiving node program stops (i.e. blocks) until the data is available 
for use by the user's program.


2. Operating Instructions
-------------------------
The program asks for the destination node number, so that the message
time can be studied as a function of the distance between the nodes.
The default case, obtained by answering <CR> gives an exchange between
nearest-neighbour nodes.

Many message-passing computers have different timing for short and
long messages. This benchmark also asks for the longest short-message
in order to select suitable message lengths, and fits a separate
straight line for short and long messages.

To expand the PARMACS macros, compile and link the code with the
appropriate libraries enter the directory d77 and type:     make

On some systems it may be necessary to allocate the appropriate
resources before running the benchmark, eg. on the iPSC/860 to reserve
a cube of 2 processors, type:    getcube -t2

To run the benchmark executable, type:    host

This will automatically load both host and node programs. The progress
of the benchmark execution can be monitored via the standard output,
whilst a permanent copy of the benchmark is written to a file called
'result'. If the run is successful and a permanent record is required,
the file 'result' should be copied to another file before the next run
overwrites it.

The whole test takes about 2 1/2 minutes on the Intel iPSC/860.

   ==================================================================
   ===                                                            ===
   ===           GENESIS Distributed Memory Benchmarks            ===
   ===                                                            ===
   ===                           COMMS1                           ===
   ===                                                            ===
   ===                      Nearest Pingpong                      ===
   ===                                                            ===
   ===               Author:   Roger Hockney                      ===
   ===     Department of Electronics and Computer Science         ===
   ===               University of Southampton                    ===
   ===               Southampton SO9 5NH, U.K.                    ===
   ===     fax.:+44-703-593045   e-mail:rwh@uk.ac.soton.ecs       ===
   ===                                                            ===
   ===     Copyright: SNARC, University of Southampton            ===
   ===                                                            ===
   ===          Last update: November 1991; Release: 2.0          ===
   ===                                                            ===
   ==================================================================


1. Description
--------------
This benchmark measures the basic communication properties of a
computer network by performing the 'pingpong' experiment between
a neighbouring pair of nodes.  A message of varying length is sent
to a neighbouring node, and immediately returned after the data
has become available to the receiving user program. Half the time 
for this pingpong exchange is recorded as the time to send a 
message from one node to a neighbour.  This time is fitted by 
least-squares to the straight line relation:

                     tn = (n + nhalf) / rinf                   (1)

where  rinf  = the asymptotic stream rate (Byte/s), and
       nhalf = the message length (Byte) giving half the 
               asymptotic performance

This corresponds to an average performance, r, as a function of 
message length, n,
                            rinf
                    r = -------------                          (2)
                        (1 + nhalf/n)

In the above formula rinf is the asymptotic stream rate to use with the
value of nhalf in order to calculate the average bandwidth. For short
messages the values of rinf may be high but they will not be achieved
because of the effect of nhalf via equation (2).

The benchmark has been deliberately kept simple by restricting the
test to neighbouring nodes and asynchronous communication. This is
the most favourable case and gives a lower bound on the time for
the communication of a message. Asynchronous, here, means that a send
returns to the calling program when the user data array being sent 
may be safely reused.  This, however, may be before the message has
been received by the receiving node.  The receiving node program
stops (i.e. blocks) until the data is available for use by the user's
program.


2. Operating Instructions
-------------------------
Many message-passing computers have different timing for short and
long messages. This benchmark assumes by default that the break between 
the two types of message occurs between 99 and 100 Byte. If this is
not the case, then the user has to enter the actual value during the
benchmark initialisation.

To expand the PARMACS macros, compile and link the code with the
appropriate libraries enter the directory d77 and type:     make

On some systems it may be necessary to allocate the appropriate
resources before running the benchmark, eg. on the iPSC/860 to reserve
a cube of 2 processors, type:    getcube -t2

To run the benchmark executable, type:    host

This will automatically load both host and node programs. The progress
of the benchmark execution can be monitored via the standard output, 
whilst a permanent copy of the benchmark is written to a file called 
'result'. If the run is successful and a permanent record is required,
the file 'result' should be copied to another file before the next run
overwrites it.

  The whole test takes about 2 1/2 minutes on the Intel iPSC/860


3. Modifications
----------------
  The program may trivially be modified to perform the pingpong test
between any pair of nodes, in order to study the time variation with
separation within the network. Change the size of TORUS requested in
host.u, and the node process id's in the program node.u.

   ==================================================================
   ===                                                            ===
   ===           GENESIS Distributed Memory Benchmarks            ===
   ===                                                            ===
   ===                           QCD1                             ===
   ===                                                            ===
   ===    Monte-Carlo Simulation of the (3+1)-Dimensional Pure    ===
   ===                 SU(3) Lattice Gauge Theory                 ===
   ===                                                            ===
   ===              Author:    Eckardt Kehl                       ===
   ===              PALLAS GmbH                                   ===
   ===              Hermulheimer Str. 10                          ===
   ===              5040 Bruhl, GERMANY                           ===
   ===     tel.:+49-2232-18960   e-mail:karls@pallas-gmbh.de      ===
   ===                                                            ===
   ===     Copyright: PALLAS GmbH                                 ===
   ===                                                            ===
   ===          Last update: April 1992; Release: 2.0             ===
   ===                                                            ===
   ==================================================================


1. Description
--------------
This benchmark is based on a 'pure gluon' SU(3) lattice gauge theory 
simulation, using the Monte-Carlo heatbath technique. It differs from
the QCD2 benchmark in that it uses the 'quenched' approximation which
neglects dynamical fermions. 

The simulation is defined on a four-dimensional lattice which is a
discrete approximations to continuum space-time. The basic variables
are 3 by 3 complex matrices. Four such matrices are associated with
every lattice site. The lattice update is performed using a multi-hit
Metropolis algorithm.

In the parallel version of the program, the lattice can be distributed
in any one or more of the four lattice directions. 


2. Operating Instructions
-------------------------

File I/O :

The main program routine reads an input file, "qcd1.dat".
Additional information about the meaning of the different input 
parameters is given within the input file. The only parameters that should 
normally be changed to run the standard benchmark are the spatial and
temporal lattice size parameters and the number of processes in the 
distributed version. A permanent record of the benchmark run is saved
in a file called "result". This contains information on the lattice
size and its distribution over processes, plus timing information
and some information on the physical solution for each iteration.
Error messages and some temporary information is output to the
standard output on channel 6.


Changing problem size and numbers of processes:

The lattice size is based on a 4-dimensional space-time lattice of
size:  N = NS **3 * NT, where NT & NS are even integers.

In the sequential version of the program the lattice size is set by changing 
the PARAMETER statements in the include file qcd1.inc

The parallel version of the program is distributed over the spatial
dimensions in a 4-D process grid of size:  

      NP = NPX * NPY * NPZ * NPT

The local lattice size on each processor is then: 

      n = (NS/NPX) * (NS/NPY) * (NS/NPZ) * (NT/NPT)

The parameters NS, NT, NPX, NPY, NPZ & NPT are set in the input data file 
qcd1.dat. 
The values should be chosen such that the dimensions of the local lattice 
are even integers. The maximum number of processes in each dimension
are specified by PARAMETER statements in the include file `qcd1h.inc', if
any of these values (normally 4) are exceeded the program prints an error
message and the program terminates. Similarly the maximum local lattice
dimensions are specified by PARAMETER statements in the include file 
`qcd1n.inc', an error is again notified if any of these maximum dimensions
is exceeded. These maximum values can be changed by altering the PARAMETER
statements, but care must be taken not to exceed the available node memory
as a consequence.


Suggested Problem Sizes :

The smallest possible local lattice size is 2 * 2**3 
- 2**4 lattice points per processor. Though in this case the granularity is 
too small to give efficient distribution or vectorization.

A more reasonable minimum lattice size per processor is 2**6 lattice points,
ie. 8 * 4**3 on an 8 proccessor grid or 4* 8**3 on 32 processors.

The likely maximum local lattice size that will fit into node memory is
around 2**11 local lattice points, ie 32 * 8**3 on an 8 processor grid

It is suggested that the benchmark is run for a range of problem sizes
from the suggested mininmum to the maximum possible lattice size over
the range of number of available processors.


Compiling and Running The Benchmark:

1) Choose problem size and number of processes. In the sequential
   version this is done by editing PARAMETER statements in the file
   qcd1.inc. In the distributed version the problem size and number
   of processes in each dimension is set in the input data file
   qcd1.dat. Upper limits for the numbers of processes are set in the
   include file qcd1h.inc. Similarly the upper limits for the local
   lattice size are set in the file qcd1n.inc. These upper limits may
   be changed but care should be taken not to exceed the available
   node memory.

2) To expand the PARMACS macros, compile and link the code
   with the appropriate libraries, Type:    make

3) If any of the parameters in the include files are changed,
   the code has to be recompiled. The make-file will automatically
   send to the compiler only affected files, Type   make

4) On some systems it may be necessary to allocate the appropriate
   resources before running the benchmark, eg. on the iPSC/860
   to reserve a cube of 8 processors, type:    getcube -t8

5a) To run the sequential benchmark , type:    qcd1

5b) To run the distributed benchmark , type:   host

   This will automatically load both host and node programs. 

   The progress of the benchmark execution can be monitored via
   the standard output, whilst a permanent copy of the benchmark
   output is written to a file called 'result'.

6) If the run is successful and a permanent record is required, the
   file 'result' should be copied to another file before the next run
   overwrites it.




Vectorization:
-------------
The program has been written completely in a vectorizable form.
The vector length equals half the lattice volume. 
The most important subroutines for vectorization are: PRO, STAPLE,
MERTRO, ADD, GATHER, SCATTER and ACCEPT.

   ==================================================================
   ===                                                            ===
   ===           GENESIS Distributed Memory Benchmarks            ===
   ===                                                            ===
   ===                            MD1                             ===
   ===                                                            ===
   ===    Molecular Dynamics for a Lennard Jones fluid - 3D ver.  ===
   ===                                                            ===
   ===               Author:   Mark Pinches                       ===
   ===             Modified:   Vladimir Getov                     ===
   ===     Department of Electronics and Computer Science         ===
   ===               University of Southampton                    ===
   ===               Southampton SO9 5NH, U.K.                    ===
   ===     fax.:+44-703-593045   e-mail:mrsp@uk.ac.soton.ecs      ===
   ===                                   vsg@uk.ac.soton.ecs      ===
   ===                                                            ===
   ===     Copyright: SNARC, University of Southampton            ===
   ===                                                            ===
   ===          Last update: April 1992; Release: 2.0             ===
   ===                                                            ===
   ==================================================================


1. Description
--------------
Molecular dynamics essentially involves solution of the equations of
motion for a system of a large number of interacting particles, i.e.
solving second order differential equations. The problem is solved
numerically by calculating approximate solutions at a large number of
time steps with interval dt, where dt is small in comparison with the
time taken for a molecule with average velocity to travel a typical
interatomic distance. The particles are usually considered to interact
through an effective pair potential which is often adjusted to reproduce
experimental results and is used to model the exact many-body potential.
For monatomic neutral atoms the form of pair potential most often
employed is the Lennard-Jones potential, which is characterised by a
steep repulsive term and a long-range tail. When modelling homogeneous
bulk phases, periodic boundary conditions are usually applied, so the
`box' containing the system to be studied can be considered to be
replicated by an infinite `lattice'.

A typical MD calculation for N particles involves, for each time step:

	- calculating the forces on the N particles;
	- calculating their new positions;
	- calculating properties of interest, such as energies and
          radial distribution functions.

In addition, diagnostic output and perhaps particle coordinates (the
latter involving a large amount of output for large systems) may be
required at intervals of tens or hundreds of time steps. A simulation
usually proceeds in two phases:

	- Equilibration - the atoms in an initially static lattice are
	given random velocities, sampled from a Gaussian distribution
	scaled to give the correct temperature, and an equilibrium (i.e.
	minimum free energy) configuration is determined by running the
	simulation, rescaling the kinetic energies at each timestep to
	maintain the required temperature.

	- Simulation - the coordinates from the previous step are used
	in a simulation, run at constant energy, from which information
	on the system being studied is produced. The period of this
	simulation must be sufficient to obtain good statistical
	averages of the required properties.

For many systems, the number of terms can be limited because the short
range nature of the Lennard-Jones potential means that reasonable
accuracy can be obtained by considering only atom pairs with interatomic
distances within a cutoff range, which is of the order of a few atomic
diameters. Long range corrections are used in the calculation of
thermodynamic properties. For small systems this strategy is sufficient
to ensure that the forces are evaluated efficiently. For large systems,
however, the number of interatomic terms required to evaluate the force
is small compared with the total number of atom pairs, and the time
taken to decide whether the separation of a given pair is less than
r_{c} is itself highly significant. An algorithm has been developed by
Hockney et al, the linked-list algorithm, which minimises the
time taken to find atomic pairs that contribute significantly to the
potential. This algorithm subdivides the system into a number of cells,
which may be 1, 2 or 3 dimensional. Cubic cells are the most appropriate
for large bulk systems. At each timestep each atom is allocated to a
cell, and one atom from each cell is selected as the first atom in
that cell. Provided that the cell size is chosen properly, the
interatomic distances need only be calculated for atoms in the current
and nearest neighbour cells. Note however that for edge and corner
cells, those at the opposite edges and corners are involved because of the
periodic boundary conditions.

Implementation of this algorithm on a parallel machine involves the
allocation of a number of adjacent cells to one processor. Cells at the
edges and corners of the processor must communicate with neighbouring
processors and each cell must communicate with a `driver' which is
responsible for input/output and supervision of the process, which is
synchronised once per timestep.


2. Operating instructions
-------------------------

Changing problem size and numbers of processes:

Most of the parameters are internally fixed for the case of the gas
Krypton. The user has to specify only the number of processors in
each direction and the number of latice cells NC, which will result in
4*NC*NC*NC atoms. These are read from the standard input on channel 5.


Suggested Problem Sizes :

For realistic simulation at least 2000 atoms per node is recommended,
which means that

			NC**3 > 500*NP

where NP is the total number of processors (NP = NPX*NPY*NPZ). This is in
fact the limit for the smallest possible problem size. The upper limit
depends on the amount of local memory.


Compiling and running the benchmark:

1) To compile and link the benchmark type:   make

2) To run the benchmark type:     host

3) Input parameters NPX, NPY, NPZ and NC (see above) on standard input.

   Output from the benchmark is written to the file "result"


3. Accuracy check
-----------------

After the equilibration phase the total energy should be conserved, i.e.
the first few digits should remain constant and there should certainly
be no net drift in the values. The temperature and total potential
energy should not vary too much, if they do the equilibration time has
to be increased by increasing the number of equilbration steps, NEQUIL, 
in the host-program.

      SUBROUTINE SOLVE (X, B)
C     -----------------------

      INCLUDE 'qcd2.inc'

      DOUBLE PRECISION  X(VSIZE), B(VSIZE)

C     -------------------------------------------------------------------
C     |  Uses the CG algorithm to solve :                               |
C     |                        [F] {x} = {b}                            |
C     |  for {x}, given {b}.                                            |
C     |                                                                 |
C     |  {}    denotes a fermion vector (defined on even sites)         |
C     |  [F] = (- [D][D] + msq),  where [D] is the Dirac matrix.        |
C     |                                                                 |
C     |  At start, {x} has the initial trial solution.                  |
C     -------------------------------------------------------------------

      INTEGER  NSWEEP, MAXIT, SIGFIG
      DOUBLE PRECISION     H,  HALFH,  MQUARK,  MSQ
      COMMON / PARAMS / H,HALFH,MQUARK,MSQ,NSWEEP,MAXIT,SIGFIG

      INTEGER  FLOPS, NITER
      DOUBLE PRECISION   RSQ,  RSQTOL,  SCPROD, TSTART, TEND, TIME
      COMMON / RESULT /  TIME, FLOPS, NITER

      DOUBLE PRECISION   P( VSIZE ), R( VSIZE )
      DOUBLE PRECISION   FV(VSIZE), DV(VSIZE)
 
C     ---------------------------------------------------
C     |  Initialise {p}, {r}, rsq, rsqtol  and  niter   |
C     |                                                 |
C     |     {p}  =  {r}  =  {b} - {Fx}                  |
C     |     rsq  =  {r}.{r}                             |
C     ---------------------------------------------------

      CALL FVEC ( X, R, DV )
      CALL SUBVEC ( R, B, R )
      CALL COPVEC ( P, R )
      RSQTOL  =  SCPROD (B, B)  * (1.0D-02 ** (SIGFIG))
      RSQ     =  SCPROD (R, R)
      NITER   =  0

C     ------------------------------------------
C     |  Do CG iterations until {x} converged  |
C     ------------------------------------------

      CALL TIMER (TSTART)

 1    CONTINUE
        NITER  =  NITER + 1
        CALL CGITER ( X, P, R, FV, DV, RSQ )
      IF  ((RSQ .GT. RSQTOL)  .AND.  (NITER .LT. MAXIT)) GO TO 1

      CALL TIMER (TEND)

C------ 'time'   = average time (in secs) per CG iteration.

      TIME  =  (TEND - TSTART) / DBLE (NITER)
      IF (TIME .LE. 0.0) TIME   =  - 1.0D20

      IF (NCOLOR .EQ. 2) THEN
         FLOPS = 280 * NSITES
      ELSE IF (NCOLOR .EQ. 3) THEN
         FLOPS = 612 * NSITES
      ENDIF

      FLOPS = FLOPS * PROCX * PROCY * PROCZ

      END

      DOUBLE PRECISION FUNCTION RAND (SEED)
C     -------------------------
      INTEGER SEED

C------ Random number generator (uses the INMOS algorithm)

        DOUBLE PRECISION A, IRANGE, MOSPOS
        PARAMETER (     A =    1664525.0D0,
     1             IRANGE = 4294967296.0D0,
     2             MOSPOS = 2147483647.0D0)
        DOUBLE PRECISION RSEED

        RSEED = SEED
        IF (SEED .LT. 0) RSEED = RSEED + IRANGE
        RSEED = MOD ((A * RSEED) + 1.0, IRANGE)
        RAND  = RSEED / IRANGE
        IF (RSEED .GT. MOSPOS) RSEED = RSEED - IRANGE
        SEED  = RSEED

      END

      DOUBLE PRECISION FUNCTION NORMAL(DUMMY)
C     ---------------------------------------

      DOUBLE PRECISION     DUMMY

C     ----------------------------------------------------------------------
C     |  Returns a random REAL value, normally distributed with standard   |
C     |   deviation = SQRT (2).                                            |
C     |  The algorithm actually generates 2 independent normals at once -  |
C     |   so the second is saved and returned at the next call.            |
C     ----------------------------------------------------------------------

      INTEGER  SEED
      DOUBLE PRECISION     N2,  RAND
      LOGICAL  STORED
      COMMON / RANDOM / N2, SEED, STORED

      DOUBLE PRECISION        TWOPI
      PARAMETER  (TWOPI = 6.28318531D0)
      DOUBLE PRECISION     LLOG, THETA, N1, X, Y

      IF  (STORED)  THEN
          NORMAL = N2
          STORED = .FALSE.

C------... else generate another 2 normals, 'n1' and 'n2'  (and return 'n1')

        ELSE
  10      CONTINUE
            X = RAND (SEED)
            Y = RAND (SEED)
          IF  (X  .EQ.  0.0D0) GO TO 10
          LLOG    = SQRT (- LOG (X))
          THETA  = TWOPI * Y
          N1     = LLOG * SIN (THETA)
          N2     = LLOG * COS (THETA)
          NORMAL = N1
          STORED = .TRUE.
      ENDIF
      END

      SUBROUTINE INISU3
C     ------------------

      INCLUDE 'qcd2.inc'

      INTEGER     NDIR
      PARAMETER ( NDIR = 4 )

      INTEGER     TDIR,  XDIR,  YDIR,  ZDIR,  EVEN,  ODD,
     *            PSENSE,  NSENSE,  PLUS,  MINUS,  RE,  IM
      PARAMETER ( TDIR = 1,    XDIR = 2,    YDIR = 3,    ZDIR = 4,
     *            EVEN = 0,     ODD = 1, PSENSE= 0, NSENSE= 1,
     *            PLUS = 0,   MINUS = 1,      RE = 1,      IM = 2 )

      INTEGER  PARITY, DIR, SITE, I, J, K
      DOUBLE PRECISION    U (NCOLOR, NCMPLX), 
     *                    V (NCOLOR, NCMPLX),
     *                    W (NCOLOR, NCMPLX),
     *            GAUGE( NSITES/2, NCOLOR, NCOLOR, NCMPLX, NDIR, 0:1)

      COMMON / LINKS / GAUGE
C     --------------------------------------------------------------------
C     |  The gauge fields (on the links) are initialised to randomly     |
C     |  distributed SU(3) matrices.  All the elements of the SU(3)      |
C     |  matrix are stored.  The matrices are parameterised as follows:  |
C     |                                                                  |
C     |       SU(3) matrix = [ u  v  w ]                                 |
C     |                                                                  |
C     |  where u, v, w are complex 3-component column vectors subject    |
C     |  to the following conditions:                                    |
C     |                                                                  |
C     |       (u,u) = 1;   (v,v) = 1;   (u,v) = 0;                       |
C     |                                                                  |
C     |       w = complex.conj (u /\ v)                                  |
C     --------------------------------------------------------------------


      DO 102  PARITY = 0, 1
        DO 101  DIR = 1, NDIR
          DO 100  SITE = 1, NSITES / 2

C     -------------------------------------------------------------------------
C     |  First column of SU(3) matrix = u   (a complex 3-vector, st (u,u) = 1)|
C     -------------------------------------------------------------------------
            CALL RANDS5 ( U )
            DO 10  I = 1, 3
              GAUGE (SITE, I, 1, RE, DIR, PARITY) = U (I, RE)
              GAUGE (SITE, I, 1, IM, DIR, PARITY) = U (I, IM)
 10         CONTINUE

C     --------------------------------------------------------
C     |  Second column of SU(3) matrix = v                   |
C     | ( a complex 3-vector, st (v,v) = 1 and (u,v) = 0 ).  |
C     --------------------------------------------------------
            CALL ORTHS5 ( U, V )
            DO 20  I = 1, 3
              GAUGE (SITE, I, 2, RE, DIR, PARITY) = V (I, RE)
              GAUGE (SITE, I, 2, IM, DIR, PARITY) = V (I, IM)
 20         CONTINUE

C     -----------------------------------------------------------------
C     |  Third column of SU3 matrix  =  w  =  complex conj. (u /\ v)  |
C     -----------------------------------------------------------------
            DO 30  I = 1, 3
              J = MOD (I, 3) + 1
              K = MOD ((I+1), 3) + 1
              W (I, RE) = 
     *                 ( U (J,RE) * V (K,RE) - U (K,RE) * V (J,RE) )
     *               - ( U (J,IM) * V (K,IM) - U (K,IM) * V (J,IM) )
 
              W (I, IM) = 
     *               - ( U (J,RE) * V (K,IM) - U (K,RE) * V (J,IM) )
     *               - ( U (J,IM) * V (K,RE) - U (K,IM) * V (J,RE) )
 30         CONTINUE

C------ w should have length 1, but renormalise it anyway to correct
C------ for rounding errors:

            CALL RENORM (W)

            DO 40  I = 1, 3
              GAUGE (SITE, I, 3, RE, DIR, PARITY) = W (I, RE)
              GAUGE (SITE, I, 3, IM, DIR, PARITY) = W (I, IM)
 40         CONTINUE

 100      CONTINUE
 101    CONTINUE
 102  CONTINUE
      END

C     ****************
      SUBROUTINE CRTPG(
C     ****************
     >                 NS,NT,NP,
     >                 NPX,NPY,NPZ,NPT,
     >                 LPX,LPY,LPZ,LPT,
     >                 ICCOS            )
C
C
      INTEGER    LPX(0:NPX),LPY(0:NPY),LPZ(0:NPZ),LPT(0:NPT),
     >           ICCOS(NP)
C
C
C     PARTITION THE LATTICE
C
C
      DO 1 I=1,NPX
      LPX(I) = NS / NPX
    1 CONTINUE
      DO 2 J=1,NPY
      LPY(J) = NS / NPY
    2 CONTINUE
      DO 3 K=1,NPZ
      LPZ(K) = NS / NPZ
    3 CONTINUE
      DO 4 L=1,NPT
      LPT(L) = NT / NPT
    4 CONTINUE
C
      NRX = NS - LPX(1) * NPX
      NRY = NS - LPY(1) * NPY
      NRZ = NS - LPZ(1) * NPZ
      NRT = NT - LPT(1) * NPT
C
      DO 10 IX = 1,NRX
      LPX(IX) = LPX(IX) + 1
   10 CONTINUE
C
      DO 20 IY = 1,NRY
      LPY(IY) = LPY(IY) + 1
   20 CONTINUE
C
      DO 30 IZ = 1,NRZ
      LPZ(IZ) = LPZ(IZ) + 1
   30 CONTINUE
C
      DO 40 IT = 1,NRT
      LPT(IT) = LPT(IT) + 1
   40 CONTINUE
C
C
C     CALCULATE THE CHESS BOARD COLOUR OFFSET
C
C
      LPX(0) = 0
      LPY(0) = 0
      LPZ(0) = 0
      LPT(0) = 0
C
C
C     LATTICE COORDINATES
C
C
      LPTS = 1
      DO 50 IT = 1,NPT
      LPTS = LPTS + LPT( IT-1 )
C
      LPZS = 1
      DO 60 IZ = 1,NPZ
      LPZS = LPZS + LPZ( IZ-1 )
C
      LPYS = 1
      DO 70 IY = 1,NPY
      LPYS = LPYS + LPY( IY-1 )
C
      LPXS = 1
      DO 80 IX = 1,NPX
      LPXS = LPXS + LPX( IX-1 )
C
C
C     EVEN OR ODD
C
C
      LPS  = LPXS + LPYS + LPZS + LPTS
      LPC  = LPS  / 2
      LPC  = LPC  * 2
C
      IP = IX + ( IY - 1 ) * NPX + ( IZ - 1 ) * NPX * NPY
     >                           + ( IT - 1 ) * NPX * NPY * NPZ
C
      IF( LPC .EQ. LPS ) THEN
          ICCOS(IP) = 0
      ELSE
          ICCOS(IP) = 1
      ENDIF
C
   80 CONTINUE
   70 CONTINUE
   60 CONTINUE
   50 CONTINUE
C
C
      RETURN
      END

       PROGRAM QCD2
C   ==================================================================
C   ===                                                            ===
C   ===           GENESIS Distributed Memory Benchmarks            ===
C   ===                                                            ===
C   ===            Conjugate Gradient Kernel from QCD              ===
C   ===          Single Node Standard Fortran77 version            ===
C   ===                                                            ===
C   ===     Original author:        John Merlin                    ===
C   ===     Mofified by    :        Ivan Wolton                    ===
C   ===     Department of Electronics and Computer Science         ===
C   ===               University of Southampton                    ===
C   ===               Southampton SO9 5NH, U.K.                    ===
C   ===     fax.:+44-703-593045   e-mail:icw@uk.ac.soton.ecs       ===
C   ===                                                            ===
C   ===          Last update: April 1991; Release: 2.0             ===
C   ===                                                            ===
C   ==================================================================
      INCLUDE 'qcd2.inc'

      INTEGER  NSWEEP
      DOUBLE PRECISION     H,  HALFH,  MQUARK,  MSQ
      COMMON / PARAMS / H,  HALFH,  MQUARK,  MSQ,  NSWEEP

      DOUBLE PRECISION  PSI( VSIZE ), PSIDOT( VSIZE )
      COMMON / SITES / PSI, PSIDOT

      INTEGER CVSIZE
      COMMON /VECLEN/ CVSIZE

      DOUBLE PRECISION   RHS(VSIZE), TEMP(VSIZE), DVWORK(VSIZE)
      INTEGER  ISWEEP, NLATT
      LOGICAL LASTSW
      DATA  LASTSW /.FALSE./

      CVSIZE = VSIZE
      NLATT = NSITES

C     --------------------------------------      
C     |  Input and initialise fields :     |
C     --------------------------------------      
      CALL SETPAR
      CALL HEAD
      CALL INIT( PSI, PSIDOT, TEMP, NCOLOR)
      CALL OUTPUT( PSI, PSIDOT, TEMP, DVWORK, NLATT, LASTSW)

      DO 1088   ISWEEP = 1, NSWEEP
C       ---------------------------------------------------------------
C       |  Update the vector {psi} :                                  |
C       |                                                             |
C       |     {psi (1/2)} = {psi (-1/2)} + h {psidot (0)}             |
C       |                                                             |
C       |  (The numbers in brackets represent the timestep).          |
C       ---------------------------------------------------------------
        CALL ADDSCV ( PSI, PSI, H, PSIDOT )


C       ---------------------------------------------------------------
C       |  To update the vector {psidot}, solve                       |
C       |                                                             |
C       |     [F] {psidot (1)} = [F] {psidot (0)} - h * psi (1/2)}    |
C       |                                                             |
C       |  (using the CG algorithm)                                   |
C       ---------------------------------------------------------------
        CALL FVEC   ( PSIDOT, RHS, DVWORK)
        CALL ADDSCV ( RHS, RHS, - H, PSI )
        CALL SOLVE  ( PSIDOT, RHS)

        IF( ISWEEP .EQ. NSWEEP ) LASTSW = .TRUE.
        CALL OUTPUT( PSI, PSIDOT, TEMP, DVWORK, NLATT, LASTSW)

 1088 CONTINUE
      STOP
      END

C *******************************************************************
C    ** WORKER PROGRAM                                                **
C    ** MOLECULAR DYNAMICS FOR A LENNARD JONES FLUID                  **
C    ** 3D VERSION PASSING EDGES IN X,Y,Z DIRECTIONS                  **
C    **                                                               **
C    ** AS FAR AS WE ARE AWARE THIS PROGRAM WORKS CORRECTLY, BUT WE   **
C    ** CAN ACCEPT NO RESPONSIBILITY FOR THE CONSEQUNCES OF ANY       **
C    ** ERRORS, AND WOULD BE GRATEFUL TO HEAR FROM YOU IF YOU FIND    **
C    ** ANY. YOU SHOULD ALWAYS CHECK A PROGRAM OR SUBROUTINE FOR YOUR **
C    ** PARTICULAR APPLICATION.                                       **
C    **                                                               **
C    ** THIS PROGRAM, WHEN USED IN CONJUNCTION ITS CONTROLLER         **
C    ** PROGRAM, WILL SIMULATE A THREE DIMENSIONAL LENNARD-JONES      **
C    ** FLUID. THE PROGRAM USES A THREE DIMENSIONAL SPATIAL           **
C    ** DECOMPOSITION OF THE SIMULATION SPACE INTO SUB-CUBES.         **
C    **                                                               **
C    ** SUBROUTINES CALLED:                                           **
C    **                                                               **
C    ** COUNT     SENDS THERMODYNAMIC DATA BACK TO MASTER PROGRAM FOR **
C    **           ACCUMULATION.                                       **
C    ** FORCE     CALCULATES THE  FORCES AND POTENTIAL USING THE      **
C    **           LINKED LIST.                                        **
C    ** INPARS    RECEIVES SIMULATION DATA FROM MASTER PROGRAM AND    **
C    **           INITIALISES VARIOUS VARIBLES                        **
C    ** MAPS      CREATES NEIGHBOUR LIST OF CELLS USED BY FORCE.      **
C    ** MOVEA     PERFORMS FIRST PART OF VELOCITY VERLET ALGORITHM.   **
C    ** MOVEB     PERFORMS SECOND PART OF VELOCITY VERLET ALGORITHM.  **
C    ** MOVOUT    CREATES LINKED LIST. SENDS ATOMS THAT HAVE MOVED    **
C    **           OUT OF A PROCESSORS SIMULATION SPACE TO THE         **
C    **           RELEVANT NEW HOME PROCESSOR. PERFORMS THE           **
C    **           COMMUNICATIONS REQUIRED TO CREATE THE EDGE CELLS    **
C    **           NEEDED TO COMPLETE THE FORCE CALCULATIONS.          **
C    ** OUTCON    SENDS THE PROCESSORS CURRENT CONFIGURATIONAL        **
C    **           INFORMATION BACK TO THE MASTER PROGRAM.             **
C    ** SCALET    SCALES THE VELOCITIES TO ENABLE EQUILIBRATION TO A  **
C    **           PARTICULAR TEMPERATURE.                             **
C    **                                                               **
C    ** PRINCIPAL VARIABLES:                                          **
C    **                                                               **
C    ** INTEGER VARIABLES:                                            **
C    **                                                               **
C    ** HEAD(NCELL)                  ARRAY HOLDING INITIAL POINTER FOR**
C    **                              EACH LINK-CELL.                  **
C    ** ISAVE                        NUMBER OF TIMESTEPS BETWEEN SAVES**
C    **                              OF CONFIGURATIONAL INFORMATION.  **
C    ** LIST(NMAX)                   ARRAY HOLDING LINKED LIST.       **
C    ** MAP(MAPSIZ)                  ARRAY CONTAINING NEIGHBOUR LIST  **
C    **                              OF CELLS CONSIDERED IN FORCE     **
C    **                              CALCULATION.                     **
C    ** MAPSIZ                       SIZE OF ARRAY MAP.               **
C    ** MMX,MMY,MMZ                  MAXIMUM NUMBER OF LINK-CELLS IN  **
C    **                              EACH COORDINATE DIRECTION.       **
C    ** MX,MY,MZ                     NUMBER OF LINK CELLS IN EACH     **
C    **                              COORDINATE DIRECTION.            **
C    ** NATM                         NUMBER OF REAL ATOMS CURRENTLY   **
C    **                              CONTROLLED BY THIS PROCESSOR.    **
C    ** NCELL                        MAXIMUM TOTAL NUMBER OF LINK-CELLS*
C    ** NMAX                         SIZE OF COORDINATE ARRAYS AND    **
C    **                              LIST ARRAY. N.B. SHOULD BE LARGE **
C    **                              ENOUGH TO HOLD ALL REAL AND EDGE **
C    **                              COORDINATES.                     **
C    ** NEQUIL                       NUMBER OF EQUILIBRATION TIMESTEPS**
C    **                              TO PERFORM.                      **
C    ** NSTEP                        NUMBER OF TIMESTEPS TO PERFORM.  **
C    **                                                               **
C    ** REAL VARIABLES:                                               **
C    **                                                               **
C    ** CELLIX,CELLIY,CELLIZ         REAL VALUES OF MX, MY, AND MZ    **
C    ** DT                           TIMESTEP.                        **
C    ** EQTEMP                       TEMPERATURE TO WHICH THE SYSTEM  **
C    **                              IS BEING EQUILIBRATED.           **
C    ** RX(NMAX),RY(NMAX),RZ(NMAX)   ARRAYS WHICH HOLD COORDINATES.   **
C    ** RCUT                         CUTOFF                           **
C    ** SFX,SFY,SFZ                  SCALE FACTORS TO ENABLE LINKED   **
C    **                              LIST CALCULATION FROM PROCESSOR  **
C    **                              COORDINATE SYSTEM.               **
C    ** SIGMA                        SIGMA FOR LENNARD-JONES POTENTIAL**
C    ** VX(NMAX),VY(NMAX),VZ(NMAX)    ARRAYS WHICH HOLD VELOCITIES.   **
C    ** V,K,W                        TOTAL POTENTIAL AND KINETIC ENERGY*
C    **                              AND VIRIAL FOR ATOMS CONTROLLED  **
C    **                              BY THIS PROCESSOR.               **
C    **                                                               **
C    ** PASSING CONVENTIONS:                                          **
C    ** EAST      DIRECTION OF INCREASING X COORDINATE                **
C    ** WEST      DIRECTION OF DECREASING X COORDINATE                **
C    ** NORTH     DIRECTION OF INCREASING Y COORDINATE                **
C    ** SOUTH     DIRECTION OF DECREASING Y COORDINATE                **
C    ** UP        DIRECTION OF INCREASING Z COORDINATE                **
C    ** DOWN      DIRECTION OF DECREASING Z COORDINATE                **
C    **                                                               **
C    *******************************************************************

      PROGRAM NODE

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ
      COMMON/STEPS/DT
      COMMON/LJPAR/SIGMA
      COMMON/ATOMS/NATM
      COMMON/CUTOFF/RCUT
      COMMON/TEMPER/EQTEMP
      COMMON/ENERGY/V,K,W
      COMMON/ESHIFT/VRCUT,DVRCUT,DVRC12
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ
      COMMON/CONTRL/NSTEP,NEQUIL,ISAVE
      COMMON/FORCES/FX,FY,FZ
      COMMON/PROCS/NPROSX, NPROSY, NPROSZ

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ
      INTEGER     NW1

      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )
      PARAMETER(NW1 = 11)

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)
      REAL        RCUT, DT, SIGMA
      REAL        VRCUT,DVRCUT,DVRC12
      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ
      REAL        DENS, DENLJ, EQTEMP
      REAL        MASS, FREE, PI, TEMP
      REAL        E, V, K, W
      REAL        EN, VN, KN, PRES
      REAL        ACE, ACV, ACK, ACP
      REAL        ACESQ, ACVSQ, ACKSQ, ACPSQ
      REAL        AVE, AVV, AVK, AVP, AVT
      REAL        FLE, FLV, FLK, FLP, FLT

      DOUBLE PRECISION TSTART, TEND, TIME

      INTEGER     HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ),MX,MY,MZ
      INTEGER     NC,M
      INTEGER     STEP, NSTEP, ISAVE, IPRINT, NORM, NATM
      INTEGER     NEQUIL, ISCALE, NPROSX, NPROSY, NPROSZ

      NATM = 0

      PI = ACOS(-1.)

C    ** READ INPUT DATA **

      WRITE(*,'(1H1,'' **** PROGRAM MDLJ ****                   '')')
      WRITE(*,'('' MOLECULAR DYNAMICS SIMULATION                '')')
      WRITE(*,'('' WITH LINKED LIST                             '')')
C      WRITE(*,'('' ENTER NUMBER OF PROCESSORS IN X DIRECTION    '')')
C      READ (*,*) NPROSX
C      WRITE(*,'('' ENTER NUMBER OF PROCESSORS IN Y DIRECTION    '')')
C      READ (*,*) NPROSY
C      WRITE(*,'('' ENTER NUMBER OF PROCESSORS IN Z DIRECTION    '')')
C      READ (*,*) NPROSZ
C  ENTER NUMBER OF TIME STEPS
      NSTEP = 600
C  ENTER NUMBER OF EQUILIBRATION TIME STEPS
      NEQUIL = 500
C  ENTER NUMBER OF STEPS BETWEEN DATA SAVES
      ISAVE = 2*NSTEP
C  ENTER NUMBER OF STEPS BETWEEN OUTPUT
      IPRINT = 100
C  ENTER THE FOLLOWING IN LENNARD-JONES UNITS
C  ENTER THE TEMPERATURE
      EQTEMP = 0.8
C  ENTER THE DENSITY
      DENS = 0.75
C  ENTER THE POTENTIAL CUTOFF DISTANCE
      RCUT = 2.0**(1.0/6.0)
C  ENTER THE TIMESTEP
      DT = 0.01
C  REDUNDANT VARIABLES ....
      ISCALE = 0
      NPROSX = 1
      NPROSY = 1
      NPROSZ = 1

C    ** WRITE INPUT DATA **
      OPEN (NW1,FILE='result')
      REWIND(NW1)

C**   READ NUMBER OF FCC SUBLATTICES TO USE IN ALL THREE
C**   COORDINATE DIRECTIONS
C**   AT THIS POINT THE NUMBER OF ATOMS WOULD BE READ FROM A FILE
C**   IF SUBROUTINE INCON OR INCONB WERE BEING USED

      WRITE(*,'('' ENTER NC '')')
      READ(*,*) NC

      IF (4*NC*NC*NC.GT.NMAX) STOP ' Too many atoms...'

      CALL FCC(NC)

      WRITE(*,'('' NUMBER OF ATOMS BEING USED '',I8)')NATM

      CALL HEADER(NW1,NPROSX,NPROSY,NPROSZ,NC,NATM)

      CALL PARAM(NW1,NSTEP,NEQUIL,IPRINT,ISCALE,EQTEMP,DENS,RCUT,DT)

C    ** CONVERT INPUT DATA TO PROGRAM UNITS **

      SIGMA  = (DENS/REAL(NATM))**(1.0/3.0)
      RCUT   = RCUT*SIGMA
      M      = INT(1./RCUT)
      MASS   = 1.0
      DENLJ  = DENS
      DENS   = DENS/(SIGMA**3)
      DT     = DT*SIGMA
      FREE   = REAL(3*(NATM-1))

C**   CHECK TO SEE WHETHER SYSTEM CAN BE SIMULATED

      IF (M.LT.1)  STOP 'SYTEM TOO SMALL FOR ARRAY'

C    ** ZERO ACCUMULATORS **

      ACE    = 0.0
      ACV    = 0.0
      ACK    = 0.0
      ACP    = 0.0

      ACESQ  = 0.0
      ACVSQ  = 0.0
      ACKSQ  = 0.0
      ACPSQ  = 0.0

      FLE    = 0.0
      FLV    = 0.0
      FLK    = 0.0
      FLP    = 0.0
      FLT    = 0.0

C    ** WRITE OUT SOME USEFUL INFORMATION **

      WRITE(*,'('' SIGMA/BOX              =  '',F10.4)')  SIGMA
      WRITE(*,'('' RCUT/BOX               =  '',F10.4)')  RCUT
      WRITE(*,'('' DT                     =  '',F10.4)')  DT


C**   CALL SUBROUTINE TO RECEIVE SIMULATION PARAMETERS FROM MASTER

      CALL INPARS

C**   CALL SUBROUTINE TO RECEIVE CONFIGURATIONAL INFORMATION FROM MASTER
C    ** LOOPS OVER ALL STEPS **

      WRITE(*,'(/'' ** MOLECULAR DYNAMICS BEGINS ** ''/ )')
      WRITE(*,10001)
      WRITE(NW1,'(/'' ** MOLECULAR DYNAMICS BEGINS ** ''/ )')
      WRITE(NW1,10001)

C**   START OF MD CYCLE

      DO 1000 STEP=1,MIN(NSTEP,NEQUIL)
        V = 0
        K = 0
        W = 0
        PRES = 0

C**     CALL SUBROUTINE TO PERFORM FIRST
C**     PART OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

	CALL MOVEA

C**     CALL SUBROUTINE TO CREATE LINKED LIST AND PASS EDGES
C**     BETWEEN PROCESSORS
C**     THIS ROUTINE DOES ALL THE COMMUNICATIONS

	CALL MOVOUT

C**     CALL SUBROUTINE TO CALCULATE FORCES AND POTENTIAL
C**     USING LINKED
C**     SCALAR ROUTINE MORE THAN 95% OF CPU TIME

	CALL FORCE

C**     CALL SUBROUTINE TO PERFORM SECOND PART
C**     OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

	CALL MOVEB

        E    = K+V
        EN   = E/REAL(NATM)
        VN   = V/REAL(NATM)
        KN   = K/REAL(NATM)
        TEMP = 2.0*K/FREE
        PRES = DENS*TEMP+W
        PRES = PRES*SIGMA**3

C       ** OPTIONALLY PRINT INFORMATION **
        IF ( MOD ( STEP, IPRINT ) .EQ. 0 ) THEN
             WRITE(*,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
             WRITE(NW1,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
          ENDIF


C**     IF STILL EQUILIBRATING CALL SUBROUTINE TO SCALE VELOCITIES

	CALL SCALET

1000    CONTINUE

C**   START OF PRODUCTION MD CYCLE ** TIME THIS LOOP **

      CALL TIMER(TSTART)

      DO 2000 STEP=NEQUIL+1,NSTEP

        V = 0
        K = 0
        W = 0
        PRES = 0

C**     CALL SUBROUTINE TO PERFORM FIRST
C**     PART OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

        CALL MOVEA

C**     CALL SUBROUTINE TO CREATE LINKED LIST AND PASS EDGES
C**     BETWEEN PROCESSORS
C**     THIS ROUTINE DOES ALL THE COMMUNICATIONS

        CALL MOVOUT

C**     CALL SUBROUTINE TO CALCULATE FORCES AND POTENTIAL
C**     USING LINKED
C**     SCALAR ROUTINE MORE THAN 95% OF CPU TIME

        CALL FORCE

C**     CALL SUBROUTINE TO PERFORM SECOND PART
C**     OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

        CALL MOVEB

C**     CALL SUBROUTINE TO PASS THERMODYNAMIC VARIABLES TO MASTER

C**     CALCULATE AND ACCUMULATE GLOBAL DATA

        E    = K+V
        EN   = E/REAL(NATM)
        VN   = V/REAL(NATM)
        KN   = K/REAL(NATM)
        TEMP = 2.0*K/FREE
        PRES = DENS*TEMP+W
        PRES = PRES*SIGMA**3

        ACE    = ACE  +EN
        ACV    = ACV  +VN
        ACK    = ACK  +KN
        ACP    = ACP  +PRES
        ACESQ  = ACESQ+EN*EN
        ACVSQ  = ACVSQ+VN*VN
        ACKSQ  = ACKSQ+KN*KN
        ACPSQ  = ACPSQ+PRES*PRES

C       ** OPTIONALLY PRINT INFORMATION **
        IF ( MOD ( STEP, IPRINT ) .EQ. 0 ) THEN
             WRITE(*,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
             WRITE(NW1,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
          ENDIF

2000  CONTINUE

      CALL TIMER(TEND)

      TIME = TEND-TSTART

C    *******************************************************************
C    ** ENDS THE LOOP OVER CYCLES                                     **
C    *******************************************************************

      WRITE(*,'(/'' ** MOLECULAR DYNAMICS ENDS  ** ''///)')

C    ** WRITE OUT FINAL AVERAGES **

      NORM = REAL(NSTEP-NEQUIL)
      AVE  = ACE/NORM
      AVK  = ACK/NORM
      AVV  = ACV/NORM
      AVP  = ACP/NORM

      ACESQ = (ACESQ/NORM)-AVE**2
      ACKSQ = (ACKSQ/NORM)-AVK**2
      ACVSQ = (ACVSQ/NORM)-AVV**2
      ACPSQ = (ACPSQ/NORM)-AVP**2

      IF (ACESQ.GT.0.0) FLE = SQRT(ACESQ)
      IF (ACKSQ.GT.0.0) FLK = SQRT(ACKSQ)
      IF (ACVSQ.GT.0.0) FLV = SQRT(ACVSQ)
      IF (ACPSQ.GT.0.0) FLP = SQRT(ACPSQ)

      AVT = AVK/1.5
      FLT = FLK/1.5

      WRITE(*,'('' AVERAGES'',5(2X,F10.5))')
     :             AVE, AVK, AVV, AVP, AVT
      WRITE(*,'('' FLUCTS  '',5(2X,F10.5))')
     :             FLE, FLK, FLV, FLP, FLT

      CALL FLOPS(NW1,NC,NSTEP-NEQUIL,RCUT,TIME)

      CLOSE(NW1)

      STOP
10001 FORMAT(/1X,'TIMESTEP  ..ENERGY..  ..KINETIC..',
     :          '  ..POTENT..  .PRESSURE.  ..TEMPER..  ')

      END




      SUBROUTINE INPARS

      IMPLICIT CHARACTER ( A-Z )

      COMMON/ATOMS/NATM
      COMMON/STEPS/DT
      COMMON/CUTOFF/RCUT
      COMMON/LJPAR/SIGMA
      COMMON/TEMPER/EQTEMP
      COMMON/ESHIFT/VRCUT,DVRCUT,DVRC12
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ
      COMMON/CONTRL/NSTEP,NEQUIL,ISAVE

C    *******************************************************************
C    ** SUBROUTINE TO READ IN L-J PARAMETERS, INITIALISE COUNTERS ETC **
C    *******************************************************************

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ
      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )

      REAL         DT, RCUT, SIGMA, EQTEMP
      REAL         SR6,VRCUT,DVRCUT,DVRC12
      REAL         SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      INTEGER      HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ),MX,MY,MZ
      INTEGER      NATM
      INTEGER      NSTEP,NEQUIL,ISAVE

C**   CALCULATE DIMENSIONS OF PROCESSORS LINK-CELL STRUCTURE

      MX    = MIN(MMX,INT(1.0/RCUT)+2)
      MY    = MIN(MMY,INT(1.0/RCUT)+2)
      MZ    = MIN(MMZ,INT(1.0/RCUT)+2)

C**   CALCULATE SCALE FACTORS TO ENSURE EDGE CELLS ARE INCLUDED
C**   IN LINKED LIST

      SFX = (REAL(MX)-2.)/REAL(MX)
      SFY = (REAL(MY)-2.)/REAL(MY)
      SFZ = (REAL(MZ)-2.)/REAL(MZ)

C**   REAL VALUES OF NUMBER OF CELLS IN EACH COORDINATE DIRECTION

      CELLIX = REAL(MX)
      CELLIY = REAL(MY)
      CELLIZ = REAL(MZ)

C**   CALL SUBROUTINE TO CALCULATE NEIGHBOUR LIST OF NEIGHBOURING
C**   CELLS THAT WE WISH TO CONSIDER IN FORCE LOOP

      CALL MAPS

C**   CALCULATE VALUES FOR SHIFTED FORCE POTENTIAL

      SR6    = (SIGMA/RCUT)**6
      VRCUT  = SR6*(SR6-1.0)
      DVRCUT = -1.0*SR6*(SR6-0.5)/RCUT
      DVRC12 = 12.0*DVRCUT

      RETURN
      END



      SUBROUTINE FCC(NC)

C*********************************************************************
C**   ROUTINE TO CREATE AN FCC CONFIGUATION 
C*********************************************************************

      IMPLICIT CHARACTER ( A - Z )

      INTEGER     NMAX

      PARAMETER ( NMAX = 60000 )

      COMMON/ATOMS/NATM
      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)

      INTEGER     IS,NC
      INTEGER     NATM
      INTEGER     LX,LY,LZ

      NATM = 0
C**   SEED FOR RANDOM NUMBER GENERATOR

      IS = 2215

C**   TRIPLE LOOP TO CREATE LATTICE

      DO 40 LZ=0,NC-1
        DO 50 LY=0,NC-1
          DO 60 LX=0,NC-1

C**   COORDINATES S.T. THEY WITHIN SIMULATION BOX
C**   RANDOM VELICITIES

            NATM = NATM+1
            RX(NATM) = REAL(LX)/REAL(NC)+1.0E-6-0.5
            RY(NATM) = REAL(LY)/REAL(NC)+1.0E-6-0.5
            RZ(NATM) = REAL(LZ)/REAL(NC)+1.0E-6-0.5

            CALL SRAND(IS,VX(NATM))
            CALL SRAND(IS,VY(NATM))
            CALL SRAND(IS,VZ(NATM))

            NATM = NATM+1
            RX(NATM) = (REAL(LX)+0.5)/REAL(NC)-1.0E-6-0.5
            RY(NATM) = REAL(LY)/REAL(NC)+1.0E-6-0.5
            RZ(NATM) = (REAL(LZ)+0.5)/REAL(NC)-1.0E-6-0.5
            VX(NATM) = 0.0-VX(NATM-1)
            VY(NATM) = 0.0-VY(NATM-1)
            VZ(NATM) = 0.0-VZ(NATM-1)

            NATM = NATM+1
            RX(NATM) = (REAL(LX)+0.5)/REAL(NC)-1.0E-6-0.5
            RY(NATM) = (REAL(LY)+0.5)/REAL(NC)-1.0E-6-0.5
            RZ(NATM) = REAL(LZ)/REAL(NC)+1.0E-6-0.5
            CALL SRAND(IS,VX(NATM))
            CALL SRAND(IS,VY(NATM))
            CALL SRAND(IS,VZ(NATM))

            NATM = NATM+1
            RX(NATM) = REAL(LX)/REAL(NC)+1.0E-6-0.5
            RY(NATM) = (REAL(LY)+0.5)/REAL(NC)-1.0E-6-0.5
            RZ(NATM) = (REAL(LZ)+0.5)/REAL(NC)-1.0E-6-0.5
            VX(NATM) = 0.0-VX(NATM-1)
            VY(NATM) = 0.0-VY(NATM-1)
            VZ(NATM) = 0.0-VZ(NATM-1)

 60         CONTINUE
 50       CONTINUE
 40     CONTINUE

      RETURN
      END



      SUBROUTINE SRAND(IS,C)

C*********************************************************************
C**   ROUTINE TO GENERATE RANDOM NUMBERS.                           **
C**   THIS GENERATOR HAS NOT BEEN TESTED AND SHOULD NOT BE RELIED   **
C**   UPON TO PRODUCE GENUINLY RANDOM NUMBERS!!                     **
C*********************************************************************

      REAL*8 SCALE

      INTEGER IS,IMULT,IMOD,IS1,IS2,ISS2

      DATA IMULT/16807/, IMOD/2147483647/, SCALE/4.656612875D-10/

      IF (IS.LE.0) IS = 1
      IS2 = MOD(IS,32768)
      IS1 = (IS-IS2)/32768
      ISS2 = IS*IMULT
      IS2 = MOD(ISS2,32768)
      IS1 = MOD(IS1*IMULT+(ISS2-IS2)/32768,65536)
      IS = MOD(IS1*32768+IS2,IMOD)
      C = 2.0*(SCALE*FLOAT(IS)-0.5)*1.0e-6

      RETURN
      END





      SUBROUTINE MOVOUT

C************************************************************
C**                                                        **
C** PASSES EDGE OF SIMULATION BOX TO NEIGHBOURS AND ADDS   **
C** THOSE PASSED TO IT TO THE ARRAYS OF COORDINATES.       **
C** DURING THIS PROCESS ATOMS THAT HAVE MOVED INTO OTHER   **
C** PROCESSOR'S SIMULATION SPACE ARE PASSED TO THEIR       **
C** NEW HOME PROCESSOR.                                    **
C**                                                        **
C************************************************************

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ
      COMMON/ATOMS/NATM
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ

      INTEGER     NMAX, MMX, MMY, MMZ,  NCELL, MAPSIZ

      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      INTEGER     HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ), MX, MY,MZ
      INTEGER     NATM, I, J, K, ICELL, NEDGE

C**   ZERO LINKED LIST

      DO 5 ICELL = 1, MX*MY*MZ
        HEAD(ICELL) = 0
 5      CONTINUE

      DO 10 I = 1, NATM
        ICELL = 1+INT((RX(I)*SFX+0.5)*CELLIX)
     &           +INT((RY(I)*SFY+0.5)*CELLIY)*MX
     &           +INT((RZ(I)*SFZ+0.5)*CELLIZ)*MX*MY
        LIST(I) = HEAD(ICELL)
        HEAD(ICELL) = I
 10     CONTINUE

      NEDGE = NMAX+1

C**   CREATE WEST FACE OF BOX

      DO 20 K = 0,MZ-1
        DO 20 I= MX-1,MX*MY-1,MX
          J=HEAD(I+K*MX*MY)
 21       IF (J.EQ.0) GOTO 20
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)-1.0
          RY(NEDGE) = RY(J)
          RZ(NEDGE) = RZ(J)
          ICELL = 1+INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
     &             +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 21
 20       CONTINUE

C**   CREATE EAST FACE OF BOX

      DO 30 K = 0,MZ-1
        DO 30 I = 2, MX*(MY-1)+2,MX
          J=HEAD(I+K*MX*MY)
 31       IF (J.EQ.0) GOTO 30
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)+1.0
          RY(NEDGE) = RY(J)
          RZ(NEDGE) = RZ(J)
          ICELL = MX+INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
     &              +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 31
 30       CONTINUE

C**   CREATE SOUTH FACE OF BOX

      DO 100 K = 0,MZ-1
        DO 100 I= MX*(MY-2)+1,MX*(MY-1)
          J=HEAD(I+K*MX*MY)
 101      IF (J.EQ.0) GOTO 100
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)
          RY(NEDGE) = RY(J)-1.0
          RZ(NEDGE) = RZ(J)
          ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)
     &             +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 101
 100      CONTINUE

C**   CREATE NORTH FACE OF BOX

      DO 130 K = 0,MZ-1
        DO 130 I = MX+1,2*MX
          J=HEAD(I+K*MX*MY)
 131      IF (J.EQ.0) GOTO 130
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)
          RY(NEDGE) = RY(J)+1.0
          RZ(NEDGE) = RZ(J)
          ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)+MX*(MY-1)
     &             +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 131
 130      CONTINUE

C**   CREATE DOWN FACE OF BOX

      DO 220 K = MX*MY*(MZ-2)+1,MX*MY*(MZ-1)
        J=HEAD(K)
 221    IF (J.EQ.0) GOTO 220
        NEDGE = NEDGE-1
        RX(NEDGE) = RX(J)
        RY(NEDGE) = RY(J)
        RZ(NEDGE) = RZ(J)-1.0
        ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)
     &           +INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
        LIST(NEDGE) = HEAD(ICELL)
        HEAD(ICELL) = NEDGE

        J = LIST(J)
        GOTO 221
 220    CONTINUE


C**   CREATE UP FACE OF BOX

      DO 270 K = MX*MY+1,2*MX*MY
        J=HEAD(K)
 271    IF (J.EQ.0) GOTO 270
        NEDGE = NEDGE-1
        RX(NEDGE) = RX(J)
        RY(NEDGE) = RY(J)
        RZ(NEDGE) = RZ(J)+1.0
        ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)
     &           +INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
     &           +(MZ-1)*MX*MY
        LIST(NEDGE) = HEAD(ICELL)
        HEAD(ICELL) = NEDGE

        J = LIST(J)
        GOTO 271
 270    CONTINUE

C**   TEST TO SEE IF WE HAVE TOO MANY EDGE ATOMS FOR ARRAYS

      IF (NEDGE.LT.NATM) WRITE(*,*) ' LINKED LIST RECURSIVE '

      RETURN
      END




      SUBROUTINE MAPS

      IMPLICIT CHARACTER ( A-Z )

      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ

C    *******************************************************************
C    ** ROUTINE TO SET UP A LIST OF NEIGHBOURING CELLS                **
C    *******************************************************************

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ
      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )

      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      INTEGER     LIST(NMAX), HEAD(NCELL), MAP(MAPSIZ), MX, MY,MZ
      INTEGER     IX, IY, IZ, IMAP, ICELL

C    ** STATEMENT FUNCTION TO GIVE CELL INDEX **
      ICELL(IX,IY,IZ) = 1+MOD(IX-1+MX,MX)+MOD(IY-1+MY,MY)*MX
     &                   +MOD(IZ-1+MZ,MZ)*MX*MY

C    ** FIND HALF THE NEAREST NEIGHBOURS OF EACH CELL **
      DO 40 IX = 1, MX
        DO 40 IY = 1, MY
          DO 40 IZ = 1, MZ
            IMAP = (ICELL(IX,IY,IZ)-1)*13
            MAP(IMAP+1 ) = ICELL(IX+1,IY  ,IZ)
            MAP(IMAP+2 ) = ICELL(IX+1,IY+1,IZ)
            MAP(IMAP+3 ) = ICELL(IX  ,IY+1,IZ)
            MAP(IMAP+4 ) = ICELL(IX-1,IY+1,IZ)
            MAP(IMAP+5 ) = ICELL(IX+1,IY  ,IZ-1)
            MAP(IMAP+6 ) = ICELL(IX+1,IY+1,IZ-1)
            MAP(IMAP+7 ) = ICELL(IX  ,IY+1,IZ-1)
            MAP(IMAP+8 ) = ICELL(IX-1,IY+1,IZ-1)
            MAP(IMAP+9 ) = ICELL(IX+1,IY  ,IZ+1)
            MAP(IMAP+10) = ICELL(IX+1,IY+1,IZ+1)
            MAP(IMAP+11) = ICELL(IX  ,IY+1,IZ+1)
            MAP(IMAP+12) = ICELL(IX-1,IY+1,IZ+1)
            MAP(IMAP+13) = ICELL(IX  ,IY  ,IZ+1)
40          CONTINUE

      RETURN
      END



      SUBROUTINE MOVEA

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ
      COMMON/STEPS/DT
      COMMON/ATOMS/NATM
      COMMON/FORCES/FX,FY,FZ

C    *******************************************************************
C    ** FIRST PART OF THE VELOCITY VERLET ALGORITHM                   **
C    *******************************************************************

      INTEGER     NMAX
      PARAMETER ( NMAX = 60000 )

      REAL        DT, DT2, DTSQ2
      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)

      INTEGER     I, NATM

      DT2   = DT/2.0
      DTSQ2 = DT*DT2

      DO 100 I = 1, NATM

C**     INTEGRATE COORDINATES A COMPLETE TIMESTEP

         RX(I) = RX(I)+DT*VX(I)+DTSQ2*FX(I)
         RY(I) = RY(I)+DT*VY(I)+DTSQ2*FY(I)
         RZ(I) = RZ(I)+DT*VZ(I)+DTSQ2*FZ(I)

         RX(I) = RX(I)-AINT(RX(I)+RX(I))
         RY(I) = RY(I)-AINT(RY(I)+RY(I))
         RZ(I) = RZ(I)-AINT(RZ(I)+RZ(I))

C**     INTEGRATE VELOCITIES HALF A TIMESTEP

         VX(I) = VX(I)+DT2*FX(I)
         VY(I) = VY(I)+DT2*FY(I)
         VZ(I) = VZ(I)+DT2*FZ(I)
100   CONTINUE

      RETURN
      END




      SUBROUTINE MOVEB

      IMPLICIT CHARACTER ( A-Z )

      COMMON/VELOC/VX,VY,VZ
      COMMON/STEPS/DT
      COMMON/ATOMS/NATM
      COMMON/ENERGY/V,K,W
      COMMON/FORCES/FX,FY,FZ

      INTEGER     NMAX
      PARAMETER ( NMAX = 60000 )

      REAL        DT, DT2
      REAL        V,K,W
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)

      INTEGER     I, NATM

C    *******************************************************************
C     SECOND PART OF VELOCITY VERLET ALGORITHM
C    *******************************************************************

      DT2   = DT/2.0
      K   = 0.0

      DO 100 I = 1, NATM

C**     INTEGRATE VELOCITIES HALF A TIMESTEP

        VX(I) = VX(I)+DT2*FX(I)
        VY(I) = VY(I)+DT2*FY(I)
        VZ(I) = VZ(I)+DT2*FZ(I)

C**     SUM KINETIC ENERGY

        K = K+VX(I)*VX(I)+VY(I)*VY(I)+VZ(I)*VZ(I)
100     CONTINUE

      K = 0.5*K

      RETURN
      END



      SUBROUTINE FORCE

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ
      COMMON/ENERGY/V,K,W
      COMMON/ATOMS/NATM
      COMMON/LJPAR/SIGMA
      COMMON/ESHIFT/VRCUT,DVRCUT,DVRC12
      COMMON/CUTOFF/RCUT
      COMMON/FORCES/FX,FY,FZ

C    *******************************************************************
C    ** ROUTINE TO COMPUTE FORCS AND POTENTIAL USING A LINK LIST     **
C    *******************************************************************

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ

      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL)

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)
      REAL        RCUT, SIGMA
      REAL        VRCUT,DVRCUT,DVRC12
      REAL        V,K,W
      REAL        RXI, RYI, RZI, FXIJ, FYIJ, FZIJ, FIJ, RCUTSQ
      REAL        SIGSQ, FXI, FYI, FZI, SR2, SR6, VIJ, WIJ
      REAL        RIJ, RIJSQ, RXIJ, RYIJ, RZIJ
      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      LOGICAL     EDGEI, EDGEJ

      INTEGER     HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ), MX, MY,MZ
      INTEGER     ICELL, JCELL0, JCELL, I, J, NABOR, NATM

      SIGSQ  = SIGMA**2
      RCUTSQ = RCUT**2

C    ** ZERO FORCS AND POTENTIAL **
      DO 10 I = 1, NATM
        FX(I) = 0.0
        FY(I) = 0.0
        FZ(I) = 0.0
10      CONTINUE

      V = 0.0
      W = 0.0

C    ** LOOP OVER ALL CELLS **

      DO 5000 ICELL = 1 , MX*MY*MZ

        I = HEAD(ICELL)

C**     TEST TO SEE IF CURRENT CELL IS AN EDGE CELL

        EDGEI=(I.GT.NATM)

C       ** LOOP OVER ALL MOLECULES IN THE CELL **

1000    IF ( I .GT. 0 ) THEN
          RXI = RX(I)
          RYI = RY(I)
          RZI = RZ(I)

C**       IF AN EDGE CELL OMIT FORCE CALCULATIONS BETWEEN ATOMS WITHIN
C**       CURRENT CELL

          IF (EDGEI) GOTO 2200
          FXI = FX(I)
          FYI = FY(I)
          FZI = FZ(I)
C          ** LOOP OVER ALL MOLECULES BELOW I IN THE CURRENT CELL **
          J = LIST(I)
2000      IF ( J .GT. 0 ) THEN
            RXIJ  = RXI-RX(J)
            RYIJ  = RYI-RY(J)
            RZIJ  = RZI-RZ(J)
            RIJSQ = RXIJ*RXIJ+RYIJ*RYIJ+RZIJ*RZIJ
            IF (RIJSQ.LT.RCUTSQ) THEN
              RIJ   = SQRT(RIJSQ)
              SR2   = SIGSQ/RIJSQ
              SR6   = SR2*SR2*SR2
              VIJ   = SR6*(SR6-1.0)-VRCUT-DVRC12*(RIJ-RCUT)
              WIJ   = SR6*(SR6-0.5)+DVRCUT*RIJ
              V     = V+VIJ
              W     = W+WIJ
              FIJ   = WIJ/RIJSQ
              FXIJ  = FIJ*RXIJ
              FYIJ  = FIJ*RYIJ
              FZIJ  = FIJ*RZIJ
              FXI   = FXI+FXIJ
              FYI   = FYI+FYIJ
              FZI   = FZI+FZIJ
              FX(J) = FX(J)-FXIJ
              FY(J) = FY(J)-FYIJ
              FZ(J) = FZ(J)-FZIJ
              ENDIF
            J = LIST(J)
            GO TO 2000
            ENDIF
 2200     CONTINUE

C          ** LOOP OVER NEIGHBOURING CELLS **

        JCELL0 = 13*(ICELL-1)
        DO 4000 NABOR = 1, 13

C             ** LOOP OVER ALL MOLECULES IN NEIGHBOURING CELLS **

          JCELL = MAP(JCELL0+NABOR)
          J = HEAD(JCELL)

C**     TEST TO SEE IF NEIGHBOURING CELL IS AN EDGE CELL

          EDGEJ=(J.GT.NATM)

C**       IF BOTH EDGE CELLS OMIT FORCE CALCULATIONS BETWEEN PAIRS
C**       OF EDGE CELLS

          IF ((EDGEI).AND.(EDGEJ)) GOTO 4000
3000      IF (J.NE.0) THEN
            RXIJ  = RXI-RX(J)
            RYIJ  = RYI-RY(J)
            RZIJ  = RZI-RZ(J)
            RIJSQ = RXIJ*RXIJ+RYIJ*RYIJ+RZIJ*RZIJ
            IF (RIJSQ.LT.RCUTSQ) THEN
              RIJ   = SQRT(RIJSQ)
              SR2   = SIGSQ/RIJSQ
              SR6   = SR2*SR2*SR2
              VIJ   = (SR6*(SR6-1.0)-VRCUT-DVRC12*(RIJ-RCUT))*0.5
              WIJ   = SR6*(SR6-0.5)+DVRCUT*RIJ
              FIJ   = WIJ/RIJSQ
              WIJ   = 0.5*WIJ
              FXIJ  = FIJ*RXIJ
              FYIJ  = FIJ*RYIJ
              FZIJ  = FIJ*RZIJ

C**   IF CURRENT CELL IS NOT AN EDGE CELL SUM FORCES AND POTENTIAL

              IF (.NOT.(EDGEI)) THEN
                V     = V+VIJ
                W     = W+WIJ
                FXI   = FXI+FXIJ
                FYI   = FYI+FYIJ
                FZI   = FZI+FZIJ
                ENDIF

C**   IF NEIGBOURING CELL IS NOT AN EDGE CELL SUM FORCES AND POTENTIAL

              IF (.NOT.(EDGEJ)) THEN
                V     = V+VIJ
                W     = W+WIJ
                FX(J) = FX(J)-FXIJ
                FY(J) = FY(J)-FYIJ
                FZ(J) = FZ(J)-FZIJ
                ENDIF
              ENDIF
            J = LIST(J)
            GO TO 3000
            ENDIF
4000      CONTINUE

C**   IF CURRENT CELL IS NOT AN EDGE CELL RETURN SUMMED FORCES TO ARRAYS

          IF(.NOT.EDGEI)THEN
            FX(I) = FXI
            FY(I) = FYI
            FZ(I) = FZI
            ENDIF
          I = LIST(I)
          GO TO 1000
          ENDIF
5000    CONTINUE

C    ** INCORPORATE ENERGY FACTORS **

      V = 4.0 *V
      W = 48.0*W/3.0

      DO 50 I = 1, NATM
        FX(I) = 48.0*FX(I)
        FY(I) = 48.0*FY(I)
        FZ(I) = 48.0*FZ(I)
50      CONTINUE

      RETURN
      END




      SUBROUTINE SCALET

      IMPLICIT CHARACTER ( A-Z )

      COMMON/VELOC/VX,VY,VZ
      COMMON/TEMPER/EQTEMP
      COMMON/ENERGY/V,K,W
      COMMON/ATOMS/NATM

      INTEGER     NMAX
      PARAMETER ( NMAX = 60000 )

      REAL         VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL         EQTEMP,V,K,W
      REAL         SCALEF

      INTEGER      NATM, I

      SCALEF = SQRT(EQTEMP/(2.0*K/(3.0*REAL(NATM-1))))

C**   SCALE VELOCITIES

      DO 10 I = 1,NATM
        VX(I) = VX(I)*SCALEF
        VY(I) = VY(I)*SCALEF
        VZ(I) = VZ(I)*SCALEF
 10     CONTINUE

      RETURN
      END

      SUBROUTINE SETPAR
C     -----------------

C    Sets parameters connected with convegence criteria and rate of
C    convergence. These parameters do not affect performance.

      INTEGER  NSWEEP, MAXIT, SIGFIG
      DOUBLE PRECISION     H,  HALFH,  MQUARK,  MSQ 
      COMMON / PARAMS / H,HALFH,MQUARK,MSQ,NSWEEP,MAXIT,SIGFIG

      MAXIT = 150
C  maxit is the maximum number of CG iterations allowed to achieve convergence

      SIGFIG = 7
C  sigfig is the number of significant figures used in the convergence test

      NSWEEP = 8
C  nsweep is the number of timed sweeps (an initial untimed sweep is also made)

      H = 0.01D0
      MQUARK = 0.2D0
C  mquark is the quark mass
 
      HALFH = H / 2.0D0
      MSQ = MQUARK * MQUARK

      END

      PROGRAM PDE1
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     MAIN PROGRAM FOR PDE1 BENCHMARK - SIMD/VECTOR VERSION
C
C     SUPPLIED BY   PALLAS GmbH
C
C     AUTHOR:  GENESIS BENCHMARK VERSION:
C		  M. LEMKE (1989, PALLAS GMBH)
C
C     FOR NUMERICAL VERIFICATION:
C	 THE AVERAGE CONVERGENCE RATE SHOULD BE SOMEWHERE BETWEEN
C	 0.7 AND 0.98
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     THE TIMER (DOUBLE PRECISION IN SECONDS) IS CALLED IN MAIN PROGRAM.
C     THE MACHINE DEPENDENT TIMING ROUTINE HAS TO BE INCLUDED.
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      INCLUDE 'pde1.inc'
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PARAMETER (NPMAX=2**(MMAX+6)+1)
      PARAMETER (NPMIN=2**(MMAX-3)+1)
      PARAMETER (IDIM=NPMAX*NPMIN**2)
      PARAMETER(NW1=11)

      DOUBLE PRECISION U(IDIM),F(IDIM)
      COMMON U,F
      ITER = MAXIT

      OPEN(NW1,FILE='result')
      CALL HEADER(NW1)
      WRITE(NW1,91000)
91000 FORMAT(' ***** 3D RED BLACK RELAXATION BENCHMARK ************* '/
     *    )
C
C---> LOOP OVER THE FINEST GRIDS IN ORDER TO GET RESULTS FOR DIFFERENT
C     PROBLEM SIZES
      DO 1 N=3,MMAX
        NP=2**N+1
        CALL TESTA(U,F,NP,NP,NP,ITER,NW1)
        CALL TESTB(U,F,NP,NP,NP,ITER,NW1)
        CALL TESTC(U,F,NP,NP,NP,ITER,NW1)
        ITER = MAX(ITER/8,5)
C
1     CONTINUE
      NX = NP-1
      NY = NP-1
      NZ = NP-1
      DO 2 N=1,3
         NX = NX * 4
         NY = NY / 2
         NZ = NZ / 2
         IF (NY.GE.3.AND.NZ.GE.3) THEN
            CALL TESTA(U,F,NX+1,NY+1,NZ+1,ITER,NW1)
            CALL TESTB(U,F,NX+1,NY+1,NZ+1,ITER,NW1)
            CALL TESTC(U,F,NX+1,NY+1,NZ+1,ITER,NW1)
         ENDIF
2     CONTINUE
C
      CLOSE(NW1)

      STOP
      END
C
C     ONE TESTCASE  STANDARD IMPLEMENTATION
C
      SUBROUTINE TESTA(U,F,NX,NY,NZ,ITER,NW1)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NX,NY,NZ), F(NX,NY,NZ)
C
        H=1./(NX-1)
        CALL INIT(U,F,NX,NY,NZ)
        RES1=RES(U,F,NX,NY,NZ,H)
C----------------> TIMER IN SECONDS
        CALL TIMER(SEC1)
        DO 2 NREL=1,ITER
          CALL RELAXA(U,F,NX,NY,NZ,H)
2       CONTINUE
        CALL TIMER(SEC2)
C----------------> TIMER IN SECONDS (IN SEC2)
        RES2=RES(U,F,NX,NY,NZ,H)
        CONVR=(RES2/RES1)**(0.1)
        WRITE(NW1,91100)
        WRITE(NW1,9100)NX,NY,NZ,NX*NY*NZ, ITER, CONVR
C
        NOP = (NX-2)*(NY-2)*(NZ-2)*8
C
        RMFLOP = (NOP/1000000.)/(SEC2-SEC1)*ITER
        WRITE(NW1,900) (SEC2-SEC1)/ITER,NOP, RMFLOP
        WRITE(NW1,91100)
91100 FORMAT(' +++++++++   STANDARD IMPLEMENTATION  ++++++++++++++++ '/
     *     )
 9100 FORMAT (/' NUMBER OF POINTS PER DIRECTION = ', 3I12 /
     *        ' GRIDSIZE OF CUBIC  GRID =        ', I12/
     *        ' AVERAGE CONV. RATE (', I6, 'ITER.)  = ', D12.4/)
900    FORMAT(/' TIME FOR 1 RELAX (SEC.):', E15.8/
     *           ' NUMBER OF OPERATIONS:   ',I15/
     *           ' PERFORMANCE IN MFLOP/S: ',F15.5/)
      END
      DOUBLE PRECISION FUNCTION RES(U,F,NX,NY,NZ,H)
C
C	COMPUTES THE MAXIMUM NORM OF THE DEFECT
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX,NY,NZ), F(NX,NY,NZ)
C
      RES = 0.
      FAC=1/(H*H)
      DO 30 K=2,NZ-1
        DO 20 J=2,NY-1
          DO 10 I=2,NX-1
            D = F(I,J,K)+FAC*(-6.0*U(I,J,K)+U(I-1,J,K)+U(I+1,J,K)
     *                                     +U(I,J-1,K)+U(I,J+1,K)
     *                                     +U(I,J,K-1)+U(I,J,K+1))
               RES = MAX(ABS(D),RES)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
      END
C
C.......................................................................
C
      SUBROUTINE INIT(U,F,NX,NY,NZ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX,NY,NZ),F(NX,NY,NZ)
      DO 10 K = 1, NZ-1
        DO 20 J = 1, NY-1
          DO 30 I = 1, NX-1
            U(I,J,K) = 0.
30        CONTINUE
20      CONTINUE
10    CONTINUE
C
      DO 11 K = 2, NZ-1
        DO 21 J = 2, NY-1
          DO 31 I = 2, NX-1
            U(I,J,K) = 1000.
            F(I,J,K) = 10.
31        CONTINUE
21      CONTINUE
11    CONTINUE
C
      END
      SUBROUTINE TESTB(U,F,NX,NY,NZ,ITER,NW1)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NX,NY,NZ), F(NX,NY,NZ)
C
        H=1./(NX-1)
        CALL INIT(U,F,NX,NY,NZ)
        RES1=RES(U,F,NX,NY,NZ,H)
C----------------> TIMER IN SECONDS
        CALL TIMER(SEC1)
        DO 2 NREL=1,ITER
          CALL RELAXB(U,F,NX,NY,NZ,H)
2       CONTINUE
        CALL TIMER(SEC2)
C----------------> TIMER IN SECONDS (IN SEC2)
        RES2=RES(U,F,NX,NY,NZ,H)
        CONVR=(RES2/RES1)**(0.1)
        WRITE(NW1,91100)
        WRITE(NW1,9100)NX,NY,NZ,NX*NY*NZ, ITER, CONVR
C
        NOP = (NX-2)*(NY-2)*(NZ-2)*8
C
        RMFLOP = (NOP/1000000.)/(SEC2-SEC1)*ITER
        WRITE(NW1,900) (SEC2-SEC1)/ITER,NOP, RMFLOP
        WRITE(NW1,91100)
91100 FORMAT(' +++++++++   UNROLLING OF DEPTH 2 IN EACH DIMENSION  + '/
     *     )
 9100 FORMAT (/' NUMBER OF POINTS PER DIRECTION = ', 3I12 /
     *        ' GRIDSIZE OF CUBIC  GRID =        ', I12/
     *        ' AVERAGE CONV. RATE (', I6, 'ITER.)  = ', D12.4/)
900     FORMAT(/' TIME FOR 1 RELAX (SEC.):', E15.8/
     *         ' NUMBER OF OPERATIONS:   ',I15/
     *         ' PERFORMANCE IN MFLOP/S: ',F15.5/)
      END
C
C     ONE TESTCASE  SINGLE LOOP IN TWO DIMENSION
C
      SUBROUTINE TESTC(U,F,NX,NY,NZ,ITER,NW1)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NX,NY,NZ), F(NX,NY,NZ)
C
        H=1./(NX-1)
        CALL INIT(U,F,NX,NY,NZ)
        RES1=RES(U,F,NX,NY,NZ,H)
C----------------> TIMER IN SECONDS
        CALL TIMER(SEC1)
        DO 2 NREL=1,ITER
          CALL RELAXC(U,F,NX,NY,NZ,H)
2       CONTINUE
        CALL TIMER(SEC2)
C----------------> TIMER IN SECONDS (IN SEC2)
        RES2=RES(U,F,NX,NY,NZ,H)
        CONVR=(RES2/RES1)**(0.1)
        WRITE(NW1,91100)
        WRITE(NW1,9100)NX,NY,NZ,NX*NY*NZ, ITER, CONVR
C
        NOP = (NX-2)*(NY-2)*(NZ-2)*8
C
        RMFLOP = (NOP/1000000.)/(SEC2-SEC1)*ITER
        WRITE(NW1,900) (SEC2-SEC1)/ITER,NOP, RMFLOP
        WRITE(NW1,91100)
91100 FORMAT(' +++++++++   SINGLE LOOP IN 2 DIMENSIONS  +++++++++++ '/
     *     )
 9100 FORMAT (/' NUMBER OF POINTS PER DIRECTION = ', 3I12 /
     *        ' GRIDSIZE OF CUBIC  GRID =        ', I12/
     *        ' AVERAGE CONV. RATE (', I6, 'ITER.)  = ', D12.4/)
900     FORMAT(/' TIME FOR 1 RELAX (SEC.):', E15.8/
     *        ' NUMBER OF OPERATIONS:   ',I15/
     *          ' PERFORMANCE IN MFLOP/S: ',F15.5/)
      END
C
C
C
      SUBROUTINE RELAXA(U,F,NX,NY,NZ,H)
C
C     3D RED BLACK RELAXATION    STANDARD IMLEMENTATION
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX,NY,NZ),F(NX,NY,NZ)
      H2 = H*H
      FACTOR = 1.0D0/6.0D0
C
C     RELAXATION OF THE RED POINTS
C
      IA = 0
      DO 10 K = 2, NZ-1
        DO 20 J = 2, NY-1
          DO 30 I = 2 + IA, NX-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
30        CONTINUE
        IA = MOD (IA+1,2)
20      CONTINUE
10    CONTINUE
C
C     RELAXATION OF THE BLACK POINTS
C
      IA = 1
      DO 11 K = 2, NZ-1
        DO 21 J = 2, NY-1
          DO 31 I = 2 + IA, NX-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
31        CONTINUE
        IA = MOD (IA+1,2)
21      CONTINUE
11    CONTINUE
      END
C
C.......................................................................
C
      SUBROUTINE RELAXB(U,F,NX,NY,NZ,H)
C
C     3D RED BLACK RELAXATION    STANDARD IMLEMENTATION
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX,NY,NZ),F(NX,NY,NZ)
      INTEGER COLOR
      H2 = H*H
      FACTOR = 1.0D0/6.0D0
      DO 1 COLOR = 0,1
      NZ1 = NZ
      IF (MOD(NZ,2).EQ.1) THEN
        K = NZ-1
        DO 120 J = 2, NY-1
          IINC = MOD( K+J+2+COLOR,2)
          DO 130 I = 2 + IINC, NX-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
130       CONTINUE
120     CONTINUE
        NZ1 = NZ1 - 1
      ENDIF
      NY1 = NY
      IF (MOD(NY,2).EQ.1) THEN
        J = NY-1
        DO 210 K = 2, NZ1-1
          IINC = MOD( K+J+2+COLOR,2)
          DO 230 I = 2 + IINC, NX-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
230       CONTINUE
210     CONTINUE
        NY1 = NY1 - 1
      ENDIF
      NX1 = NX
      IF (MOD(NX,2).EQ.1) THEN
        I = NX-1
        DO 310 K = 2, NZ1-1
          JINC = MOD( K+2+I+COLOR,2)
          DO 320 J = 2 + JINC, NY1-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
320       CONTINUE
310     CONTINUE
        NX1 = NX1 - 1
      ENDIF
      IF (COLOR.EQ.0) THEN
      DO 10 K = 2, NZ1-1,2
        DO 20 J = 2, NY1-1,2
          DO 30 I = 2 , NX1-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
            U(I+1,J+1,K) = FACTOR*(H2*F(I+1,J+1,K) +
     *                    (U(I,J+1,K) + U(I+2,J+1,K) +
     *                     U(I+1,J,K) + U(I+1,J+2,K) +
     *                     U(I+1,J+1,K-1) + U(I+1,J+1,K+1)))
            U(I,J+1,K+1) = FACTOR*(H2*F(I,J+1,K+1) +
     *                    (U(I-1,J+1,K+1) + U(I+1,J+1,K+1) +
     *                     U(I,J,K+1) + U(I,J+2,K+1) +
     *                     U(I,J+1,K) + U(I,J+1,K+2)))
            U(I+1,J,K+1) = FACTOR*(H2*F(I+1,J,K+1) +
     *                    (U(I,J,K+1) + U(I+2,J,K+1) +
     *                     U(I+1,J-1,K+1) + U(I+1,J+1,K+1) +
     *                     U(I+1,J,K) + U(I+1,J,K+2)))
30        CONTINUE
20      CONTINUE
10    CONTINUE
      ELSE
      DO 1010 K = 2, NZ1-1,2
        DO 1020 J = 2, NY1-1,2
          DO 1030 I = 2 , NX1-1, 2
            U(I+1,J,K) = FACTOR*(H2*F(I+1,J,K) +
     *                    (U(I,J,K) + U(I+2,J,K) +
     *                     U(I+1,J-1,K) + U(I+1,J+1,K) +
     *                     U(I+1,J,K-1) + U(I+1,J,K+1)))
            U(I,J+1,K) = FACTOR*(H2*F(I,J+1,K) +
     *                    (U(I-1,J+1,K) + U(I+1,J+1,K) +
     *                     U(I,J,K) + U(I,J+2,K) +
     *                     U(I,J+1,K-1) + U(I,J+1,K+1)))
            U(I,J,K+1) = FACTOR*(H2*F(I,J,K+1) +
     *                    (U(I-1,J,K+1) + U(I+1,J,K+1) +
     *                     U(I,J-1,K+1) + U(I,J+1,K+1) +
     *                     U(I,J,K) + U(I,J,K+2)))
            U(I+1,J+1,K+1) = FACTOR*(H2*F(I+1,J+1,K+1) +
     *                    (U(I,J+1,K+1) + U(I+2,J+1,K+1) +
     *                     U(I+1,J,K+1) + U(I+1,J+2,K+1) +
     *                     U(I+1,J+1,K) + U(I+1,J+1,K+2)))
1030      CONTINUE
1020    CONTINUE
1010  CONTINUE
      ENDIF
 1    CONTINUE
      END
C
C.......................................................................
C
      SUBROUTINE RELAXC(U,F,NX,NY,NZ,H)
C
C     3D RED BLACK RELAXATION    SINGLE LOOP IN 2 DIMENSIONS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX*NY,NZ),F(NX*NY,NZ)
      INTEGER COLOR
      INTEGER COLOR1
      IK(I,J) = I + (J-1) * NX
      H2 = H*H
      FACTOR = 1.0D0/6.0D0
      IF (MOD(NX,2).NE.1) THEN
         WRITE(6,*) 'WRONG NUMBER OF GRIDPOINTS FOR TESTC'
      ENDIF
      DO 1 COLOR=0,1
      DO 10 K = 2, NZ-1
        COLOR1 = MOD(K+COLOR,2)
        I = 1
        DO 21 J = 2 + 1-COLOR1, NY-1
           F(I+(J-1)*NX,K) = U( I+(J-1)*NX,K)
 21     CONTINUE
        I = NX
        DO 22 J = 2 + 1-COLOR1, NY-1
          F(I+(J-1)*NX,K) = U( I+(J-1)*NX,K)
 22     CONTINUE
          DO 30 I = 2 + COLOR1+NX , NX-1+(NY-2)*NX, 2
            U(I,K) = FACTOR*(H2*F(I,K) +
     *                    (U(I-1,K) + U(I+1,K) +
     *                     U(I-NX,K) + U(I+NX,K) +
     *                     U(I,K-1) + U(I,K+1)))
30        CONTINUE
20      CONTINUE
        I = 1
        DO 23 J = 2 + 1-COLOR1, NY-1
           U(I+(J-1)*NX,K) = F( I+(J-1)*NX,K)
 23     CONTINUE
        I = NX
        DO 24 J = 2 + 1-COLOR1, NY-1
           U(I+(J-1)*NX,K) = F(I+(J-1)*NX,K)
 24     CONTINUE
10    CONTINUE
1     CONTINUE 	
      END

      SUBROUTINE INITND 
C     -----------------
C     -----------------------------------------------------------------------
C     |       Initialise the processor numbers of the host and nodes        |
C     |  (which are stored in COMMON block /nodes/).   The process id's     |
C     |  (PID's) are initialised in block data (host = 0, node = 1).        |
C     |                                                                     |
C     |  In this program three dimensions of the lattice are distributed,   |
C     |  and the nodes are connected in a 3 dimensional array of size       |
C     |  (procx, procy, procz).  If the coordinates of a node in this       |
C     |  array are (X,Y,Z), then the mapping onto the linear node number is:|
C     |                                                                     |
C     |   nodenum = X + (procx * Y) + (procx * procy * Z)                   |
C     |                                                                     |
C     |       The following linear node numbers are stored in COMMON :      |
C     |                                                                     |
C     |  'thisnode', 'PosXnode', etc.                                       |
C     |     - this node and its neighbours in the  +/- x, y and z dirns.    |
C     |                                                                     |
C     |  'X0node', 'Y0node', 'Z0node'                                       |
C     |     - the nodes at (0,Y,Z), (X,0,Z) and (X,Y,0) respectively,       |
C     |       where this node is (X,Y,Z)                                    |
C     -----------------------------------------------------------------------
      INCLUDE 'qcd2.inc'

      INTEGER   MTASK, TASKND
      INTEGER   POSXND, POSYND, POSZND, NEGXND, NEGYND,
     *          NEGZND, X0NODE, Y0NODE, Z0NODE,  THISND
      COMMON / TASKS / MTASK, TASKND(0:PROCX-1, 0:PROCY-1, 0:PROCZ-1)
      COMMON / NODES /  POSXND, POSYND, POSZND,
     *                  NEGXND, NEGYND, NEGZND,
     *                  X0NODE,   Y0NODE,   Z0NODE,  THISND

      INTEGER SEED, INNODE 
      DOUBLE PRECISION N2
      LOGICAL  STORED   
      COMMON / RANDOM / N2, SEED, INNODE, STORED

      INTEGER  X, Y, Z, XP, YP, ZP, XM, YM, ZM


C------ Processor numbers of the host;  this node;  its neighbours in
C------ the +/- x, y and z dirns; and the 'edge' nodes (0,Y,Z), etc.

      X   =  MOD (INNODE, PROCX)
      Y   =  MOD ((INNODE / PROCX), PROCY)
      Z   =  INNODE / (PROCX * PROCY)

      XP  =  MOD ((X + 1), PROCX)
      YP  =  MOD ((Y + 1), PROCY)
      ZP  =  MOD ((Z + 1), PROCZ)
      XM  =  MOD ((X + PROCX - 1), PROCX)
      YM  =  MOD ((Y + PROCY - 1), PROCY)
      ZM  =  MOD ((Z + PROCZ - 1), PROCZ)

      POSXND  =  TASKND ( XP, Y,  Z  )
      POSYND  =  TASKND ( X,  YP, Z  )
      POSZND  =  TASKND ( X,  Y,  ZP )
      NEGXND  =  TASKND ( XM, Y,  Z  )
      NEGYND  =  TASKND ( X,  YM, Z  )
      NEGZND  =  TASKND ( X,  Y,  ZM )

      X0NODE  =  TASKND ( 0, Y, Z )
      Y0NODE  =  TASKND ( X, 0, Z )
      Z0NODE  =  TASKND ( X, Y, 0 )
      THISND  =  TASKND ( X, Y, Z )

      END

      SUBROUTINE SHIFTV (U, UPAR, DIR, SENSE, USHIFT)
C     ------------------------------------------------------

      INCLUDE 'qcd2.inc'

      INTEGER  UPAR, DIR, SENSE
      DOUBLE PRECISION   U( VSIZE ), USHIFT( VSIZE )

C     -----------------------------------------------------------------------
C     |       Shifts the fermion vector {u}  by one lattice spacing in      |
C     |  a given direction and sense (given by 'dir', 'sense').  The        |
C     |  shifted vector is returned in  {ushift}.                           |
C     |                                                                     |
C     |  'usites' = the sites on which the original {u} is defined  (i.e.   |
C     |             'even' or 'odd').                                       |
C     |  Note that if {u} is 'even' then {ushift} is 'odd', & vice versa.   |
C     -----------------------------------------------------------------------
      INTEGER     TDIR,  XDIR,  YDIR,  ZDIR,  EVEN,  ODD,
     *            PSENSE,  NSENSE,  PLUS,  MINUS,  RE,  IM
      PARAMETER ( TDIR = 1,    XDIR = 2,    YDIR = 3,    ZDIR = 4,
     *            EVEN = 0,     ODD = 1, PSENSE= 0, NSENSE= 1,
     *            PLUS = 0,   MINUS = 1,      RE = 1,      IM = 2 )

      INTEGER     XSIZE,  YSIZE,  ZSIZE
      PARAMETER ( XSIZE  =  SEGT * SEGY * SEGZ * NCOLOR,
     *            YSIZE  =  SEGT * SEGX * SEGZ * NCOLOR,
     *            ZSIZE  =  SEGT * SEGX * SEGY * NCOLOR )

      INTEGER  POST (2*VSIZE),  NEGT (2*VSIZE), 
     *         POSX (VSIZE),      NEGX (VSIZE),
     *         POSY (VSIZE),      NEGY (VSIZE),
     *         POSZ (VSIZE),      NEGZ (VSIZE)
      COMMON / ISHIFT / POST, POSX, POSY, POSZ, NEGT, NEGX, NEGY, NEGZ 

      INTEGER    SHIFT, I


      IF  (SENSE  .EQ.  PSENSE)  THEN
C     ---------------------------------
          IF  (DIR  .EQ.  TDIR)  THEN
C         ---------------------------

           SHIFT = UPAR * VSIZE

           DO 100 I =1, VSIZE
            USHIFT( POST(I+SHIFT) ) = U(I)
100        CONTINUE


            ELSEIF  (DIR  .EQ.  XDIR)  THEN
C           -------------------------------

           DO 200 I =1, VSIZE
            USHIFT( POSX(I) ) = U(I)
200        CONTINUE

            ELSEIF  (DIR  .EQ.  YDIR)  THEN
C           -------------------------------

           DO 300 I =1, VSIZE
            USHIFT( POSY(I) ) = U(I)
300        CONTINUE

            ELSE
C           ----

           DO 400 I =1, VSIZE
            USHIFT( POSZ(I) ) = U(I)
400        CONTINUE

          ENDIF
C         -----
        ELSEIF  (SENSE  .EQ.  NSENSE)  THEN
C       -------------------------------------
          IF  (DIR  .EQ.  TDIR)  THEN
C         ---------------------------

           SHIFT = UPAR * VSIZE

           DO 500 I =1, VSIZE
            USHIFT( NEGT(I+SHIFT) ) = U(I)
500        CONTINUE

            ELSEIF  (DIR  .EQ.  XDIR)  THEN
C           -------------------------------

           DO 600 I =1, VSIZE
            USHIFT( NEGX(I) ) = U(I)
600        CONTINUE

            ELSEIF  (DIR  .EQ.  YDIR)  THEN
C           -------------------------------

           DO 700 I =1, VSIZE
            USHIFT( NEGY(I) ) = U(I)
700        CONTINUE

            ELSE
C           ----

           DO 800 I =1, VSIZE
            USHIFT( NEGZ(I) ) = U(I)
800        CONTINUE

          ENDIF
C         -----
      ENDIF
C     -----

      END

          SUBROUTINE SECOWA(PTIME,PTARR)
C         ------------------------------
C
C         PTIME = Total time, which equals
C           PTARR(1) user time plus
C           PTARR(2) system time.
C
          DIMENSION PTARR(2)
          DOUBLE PRECISION TDBL
C
          CALL TIMER(TDBL)
          PTARR(1)=TDBL
          PTARR(2)=0.0
          PTIME=PTARR(1)
C
          END

      SUBROUTINE BLSHFT (SOURCE, PARITY, DIR, SENSE, DEST)
C     ------------------------------------------------------
      INTEGER     PARITY, DIR, SENSE

      INCLUDE 'qcd2.inc'

C     -----------------------------------------------------------------------
C     |       Shifts the fermion vector {source}  by one lattice spacing    |
C     |  in a given direction and sense (given by 'dir', 'sense').  The     |
C     |  shifted vector is returned in  {dest}.                             |
C     |                                                                     |
C     |  'parity' = the sites on which the original {source} is defined     |
C     |             (i.e. 'even' or 'odd').                                 |
C     |  Note that if {source} is 'even' then {dest} is 'odd', & vice versa.|
C     -----------------------------------------------------------------------
      INTEGER     TDIR,  XDIR,  YDIR,  ZDIR,  EVEN,  ODD,
     *            PSENSE,  NSENSE,  PLUS,  MINUS,  RE,  IM
      PARAMETER ( TDIR = 1,    XDIR = 2,    YDIR = 3,    ZDIR = 4,
     *            EVEN = 0,     ODD = 1, PSENSE= 0, NSENSE= 1,
     *            PLUS = 0,   MINUS = 1,      RE = 1,      IM = 2 )

      INTEGER  LEN, INTLEN, BLKLEN, NBLOCK, 
     *         A, B, X, Y, Z, I, TPAR

      DOUBLE PRECISION  SOURCE (0 : VSIZE-1), DEST (0 : VSIZE-1)


C------ work out parameters for shifts:

      IF  (DIR  .EQ.  TDIR)  THEN
          INTLEN  = (SEGT / 2) - 1
          BLKLEN  = (SEGT / 2)
          NBLOCK =  VSIZE / BLKLEN

        ELSEIF  (DIR  .EQ.  XDIR)  THEN
          LEN     =  SEGT / 2
          INTLEN  = (SEGX - 1) * LEN
          BLKLEN  =  SEGX * LEN
          NBLOCK =  VSIZE / BLKLEN

        ELSEIF  (DIR  .EQ.  YDIR)  THEN
          LEN     = (SEGT / 2) * SEGX
          INTLEN  = (SEGY - 1) * LEN
          BLKLEN  =  SEGY * LEN
          NBLOCK =  VSIZE / BLKLEN

        ELSEIF  (DIR  .EQ.  ZDIR)  THEN
          LEN     = (SEGT / 2) * SEGX * SEGY
          INTLEN  = (SEGZ - 1) * LEN
          BLKLEN  =  SEGZ * LEN
          NBLOCK =  VSIZE / BLKLEN
      ENDIF

C------ do shifts:

      IF  (DIR  .EQ.  TDIR)  THEN

          IF  (SENSE  .EQ.  PSENSE)  THEN
              DO 1 I = 0, (NBLOCK - 1) * BLKLEN, BLKLEN
                A = I / (SEGT / 2)
                X = MOD (A, SEGX)
                B = A / SEGX
                Y = MOD (B, SEGY)
                Z = B / SEGY
                TPAR = MOD (X + Y + Z + PARITY, 2)
                IF  (TPAR  .EQ.  EVEN)  THEN
                  DO 100 J = I, I + BLKLEN - 1
 100                DEST (J) = SOURCE (J)

C                 dest (i: i + blklen - 1) = source (i: i + blklen - 1)
                  ELSE
                  DO 150 J = I, I + INTLEN - 1
 150                DEST(J + 1) = SOURCE(J)

C                 dest(i + 1: i  + intlen) = source(i: i + intlen - 1)
                  DEST(I) = SOURCE(I + INTLEN)
                ENDIF
 1            CONTINUE

            ELSEIF  (SENSE  .EQ.  NSENSE)  THEN

              DO 2 I = 0, (NBLOCK - 1) * BLKLEN, BLKLEN
                A = I / (SEGT / 2)
                X = MOD (A, SEGX)
                B = A / SEGX
                Y = MOD (B, SEGY)
                Z = B / SEGY
                TPAR = MOD (X + Y + Z + PARITY, 2)
                IF  (TPAR  .EQ.  EVEN)  THEN
                  DO 200 J = I, I + INTLEN - 1
 200                DEST(J) = SOURCE(J + 1)

                  DEST(I + INTLEN) = SOURCE(I)
C                 dest(i: i + intlen - 1) = source(i + 1: i + intlen)
                ELSE
                  DO 250 J = I, I + BLKLEN - 1
 250                DEST (J) = SOURCE (J)

C                 dest (i: i + blklen - 1) = source (i: i + blklen - 1)
                ENDIF
 2            CONTINUE
          ENDIF

        ELSEIF  (DIR  .NE.  TDIR)  THEN

          IF  (SENSE  .EQ.  PSENSE)  THEN
            DO 3 I = 0, (NBLOCK - 1) * BLKLEN, BLKLEN
              DO 300 J = I, I + INTLEN - 1
 300            DEST(J + LEN) = SOURCE(J) 

C             dest(i + len: i + len + intlen -1) = 
C    *                                      source(i: i + intlen - 1)
             DO 350 J = I, I + LEN - 1
 350           DEST(J) = SOURCE(J + INTLEN)

C              dest(i: i + len - 1) =
C    *                        source(i + intlen: i + intlen + len - 1)
 3           CONTINUE

           ELSEIF  (SENSE  .EQ.  NSENSE)  THEN
             DO 4 I = 0, (NBLOCK - 1) * BLKLEN, BLKLEN
               DO 400 J = I, I + LEN - 1
 400           DEST(J + INTLEN) = SOURCE(J)

C              dest(i + intlen: i + intlen + len - 1) =
C    *                                          source(i: i + len - 1)
               DO 450 J = I, I + INTLEN - 1
 450             DEST(J) = SOURCE(J + LEN) 

C              dest(i: i + intlen - 1) =
C    *                           source(i + len: i + len + intlen - 1)
 4           CONTINUE
          ENDIF

      ENDIF

      END

C     ***************
      SUBROUTINE HEAD(
C     ***************
     >                NS,NT,NPX,NPY,NPZ,NPT,NP,NW1,
     >                START,IAVG,IAVGDD,SEED,ITEMAX,
     >                METHIT,ITBLUP,ORDEXP,BETA,SIGMA )
C
C
C     SUBROUTINE HEAD PRINTS THE HEADING OF THE OUTPUT FILE
C
C
C     LATEST REVISION - NOV. 1989; E.KEHL
C
C
      DOUBLE PRECISION  BETA,SIGMA
C
C
      INTEGER   ORDEXP,SEED,START
C
C
      CHARACTER*10 PST(0:1)
C
C
      DATA PST /'DISORDERED',
     >          '   ORDERED'/
C
C
      CALL HEADER(NW1)
C
      WRITE( NW1, 1010)
      WRITE( NW1, 1020) NS,NT
      WRITE( NW1, 1030) NPX,NPY,NPZ,NPT,NP
      WRITE( NW1, 1040) PST(START)
      WRITE( NW1, 1050) ITEMAX
      WRITE( NW1, 1055) METHIT
      WRITE( NW1, 1060) IAVGDD
      WRITE( NW1, 1070) IAVG
      WRITE( NW1, 1080) SEED
      WRITE( NW1, 1090) ITBLUP
      WRITE( NW1, 1100) SIGMA
      WRITE( NW1, 1110) BETA
      WRITE( NW1, 1120)
C
C
 1010 FORMAT(2(/),15X,
     >'INPUT PARAMETER:'/15X,
     >'--------------- '     )
C
 1020 FORMAT(//5X,
     >'LATTICE SIZE                            :'
     >,I3,' CUBED TIMES ',I3)
C
 1030 FORMAT(5X,
     >'NUMBER OF PROCESSES IN X-DIMENSION      :',9X,I10/5X,
     >'NUMBER OF PROCESSES IN Y-DIMENSION      :',9X,I10/5X,
     >'NUMBER OF PROCESSES IN Z-DIMENSION      :',9X,I10/5X,
     >'NUMBER OF PROCESSES IN T-DIMENSION      :',9X,I10/5X,
     >'TOTAL NUMBER OF PROCESSES               :',9X,I10)
C
 1040 FORMAT(5X,
     >'START CONFIGURATION                     :',9X,A10)
C
 1050 FORMAT(5X,
     >'TOTAL NUMBER OF ITERATION               :',9X,I10)
C
 1055 FORMAT(5X,
     >'NUMBER OF METROPOLIS-HITS               :',9X,I10)
 1060 FORMAT(5X,
     >'DISCARDED ITERATIONS FOR THERMALIZATION :',9X,I10)
C
 1070 FORMAT(5X,
     >'MODUL FOR TAKING AVERAGES               :',9X,I10)
C
 1080 FORMAT(5X,
     >'START VALUE OF RANDOM NUMBER GENERATOR  :',9X,I10)
C
 1090 FORMAT(5X,
     >'SU3 MATRIX TABLE UPDATE MODUL           :',9X,I10)
C
 1100 FORMAT(5X,
     >'STANDARD DEVIATION OF GAUSSIAN RAND. NO.:',4X,E15.6)
C
 1110 FORMAT(5X,
     >'BARE COUPLING CONSTANT                  :',4X,E15.6)
C
 1120 FORMAT(2(/),15X,
     >'RESULTS:'/15X,
     >'------- '     )
C
C
      END

C                        lpm1 - parmacs version
C                        ----------------------
C            benctl.f - benchmark control, running on all nodes,
C                  
C                       master processor (mynum .eq. 0)
C                       slave processors (mynum .ne. 0)
C
C ----------------------------------------------------------------------
C
C
      SUBROUTINE MASTPROG()
C
      COMMON /GRAFIX/ MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,
     1       IBLK,IWHT,IRED,IGRN,IBLU,IYEL,IMAG,ICYA,SRPORT
      INTEGER MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,SRPORT
      COMMON /MTINY/ MYNUM,NSLAV,NTASK,ISLMIN(128),ISLMAX(128)
C
      IF(MYNUM .EQ. 0) THEN
C  code for master
C  continuous loop, exit by control c. avoids waiting for reload
 100  CONTINUE
C
      CALL CLEAR_SCREEN(IBLK)
C
      IY0=910
      CALL DRAW_DISC(500,IY0,10,ICYA)
C
      PRINT *,'immediately before  call lpm1ma'
      CALL LPM1MA
      PRINT *,'immediately after   call lpm1ma'
C
      CALL DRAW_DISC(550,IY0,10,IRED)
C
C  make sure all processors finish together
C  quit or start new case
      CALL BENTIM(4)
C
C  temporarilly remove for testing, make true for running
C     if(.true.) goto 100
C
C  end code for master
      ELSE
C  code for slaves
C  continuousloop to avoid program reload for new cases
 1001 CONTINUE
C
C  lpm1ma called instead of lpm1sl because there is no i/o
      CALL LPM1MA
C
C  make sure all processors finish together 
C  quit or start new case
      CALL BENTIM(4)
C
C  temporarily remove for testing, continuous loop for running
C     if(.true.) goto 1001
C
C  end code for slaves
      ENDIF
C
      END
C
       SUBROUTINE SNDATA(K)
C  reads data from keyboard of
C
C---------------------------------------------------------------------
Cl                  c2.2     physical state
       COMMON/COMSTT/
     R   B3    ,   BAV   ,   CD1   ,   CD2   ,   E1    ,   E2    ,
     R   P1    ,   P2    ,   Q1    ,   Q2    ,   REALTN,   TIMRUN
       DIMENSION
     R   B3(605,40),        BAV(605,40),       CD1(605,40),
     R   CD2(605,40),       E1(605,40),        E2(605,40),
     R   P1(20000),          P2(20000),          Q1(20000),
     R   Q2(20000)
C---------------------------------------------------------------------
Cl                  c3.1     numerical parameters
       COMMON/COMNUM/
     R   C1    ,   C2    ,   CD0   ,   CURANT,   DT    ,   DX1   ,
     R   DX1DX2,   DX1OX2,   DX2   ,   DX2OX1,   ELPERP,   HLFDX1,
     R   HLFDX2,   TCACO ,
     I   LMAX  ,   LMAXP ,   LMAXP2,   MMAX  ,   MMAXP ,   MMAXP2,
     I   NEMIT ,   NP
C
C---------------------------------------------------------------------
       COMMON/COMBAS/
     +   ALTIME,   CPTIME,   NLEDGE,   NLEND,    NLRES,    NONLIN,
     +   NOUT,     NPRINT,   NREAD,    NREC,     NRESUM,   NSTEP,
     +   STIME,    LABEL1,   LABEL2,   LABEL3,   LABEL4,   LABEL5,
     +   LABEL6,   LABEL7,   LABEL8,   NDIARY,   NIN,      NPUNCH,
     +   NRUN
       REAL        ALTIME,   CPTIME,   STIME
       LOGICAL     NLEND,    NLRES
       DIMENSION
     H   LABEL1(12),         LABEL2(12),         LABEL3(12),
     H   LABEL4(12),         LABEL5(12),         LABEL6(12),
     H   LABEL7(12),         LABEL8(12)
C
C       include 'comdev.inc'
C---------------------------------------------------------------------
Cl                  c2.3     device description
       COMMON/COMDEV/
     R   B3RHS ,   B3RHSD,   BAPLY ,   BAPLYD,   CAVEAM,   CAVEFR,
     R   CAVIC ,   CAVRES,   CAVTC ,   DEPTH ,   DEVHYT,   DEVLEN,
     R   DEVRAD,   EAPLYD,   EEMIT ,   EEMITD,   ENIT  ,   ENITD ,
     R   GAP   ,   RESAX ,   RESE  ,   RESN  ,   RESS  ,   RESW  ,
     R   RINNER,   SPACE ,   VOLTAG,   WIDTH ,
     I   LCATH ,   LCAV  ,   LLEFT ,   LWVANE,   MDEPTH,   MGAP  ,
     I   NBCAX ,   NBCCAV,   NBCE  ,   NBCN  ,   NBCS  ,   NBCW  ,
     I   NCAV  ,   NDEV
       DIMENSION
     R   CAVEAM(100),        CAVEFR(100),        CAVIC(4,100),
     R   CAVRES(100),        CAVTC(100),
     I   NBCCAV(100)
C---------------------------------------------------------------------
C       include 'c:\tinyv2r0\include\tiny.inc'
C
      COMMON /GRAFIX/ MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,
     1       IBLK,IWHT,IRED,IGRN,IBLU,IYEL,IMAG,ICYA,SRPORT
      INTEGER MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,SRPORT
      COMMON /MTINY/ MYNUM,NSLAV,NTASK,ISLMIN(128),ISLMAX(128)
      COMMON/BENINT/NBENSW,NBENOR,NBENCL,NBEN1,NBEN2,NBEN3,NBEN4,NBEN5
     1 ,NBEN6,NBEN7,NBEN8,NBEN9
C
      INTEGER IBUFF(256)
      REAL BUFF(256)
      EQUIVALENCE(IBUFF(1),BUFF(1))
C
      IF(MYNUM .EQ. 0) THEN
      IF(K .EQ. 1) THEN
       PRINT *,'new run setup'
       I=0
       IF(I .EQ. 0) NLRES=.FALSE.
       IF(I .EQ. 1) NLRES=.TRUE.
C  broadcast i to slaves
       IBUFF(1)=I
       CALL BRDCINT(MSPORT,IBUFF,1)
C
      ELSEIF(K .EQ. 2) THEN
C  setoff benchmark timing
       CALL BENTIM(0)
       NRUN=10
       TIMRUN=1.0
       IF(NBENSW .LT. 1 .OR. NBENSW .GT. 4) THEN
       PRINT *,'type nanosec to be simulated this run'
       PRINT *,'     1.0 is a good value'
       PRINT *,'type 0.0 to specify number of steps instead'
       READ *,TIMRUN
       ENDIF
       IF(TIMRUN .EQ. 0.0) THEN
         PRINT *,'type number of extra timesteps in this run'
         READ *,NEXTRA
         NRUN=NSTEP+NEXTRA
       ENDIF
C
       IFAC=1
       IF(NBEN3 .GE. 2 .AND. NBEN3 .LE. 4) THEN
C  scale problem for different benchmark sizes
         IFAC=2**(NBEN3-1)
       ENDIF
C  broadcast values to slaves
       IBUFF(1)=NRUN
       IBUFF(2)=IFAC
       BUFF(3)=TIMRUN
       CALL BRDCINT(MSPORT,IBUFF,3)
C  scale down 'electrons per superparticle'
         ELPERP=ELPERP/IFAC
C  scale up injection rate
         NEMIT=NEMIT*IFAC
C  scale up number of mesh cells in one direction
         LMAX=LMAX*IFAC
C  scale up device dimensions in cell widths
         LLEFT=LLEFT*IFAC
         LCAV=LCAV*IFAC
         LWVANE=LWVANE*IFAC
         LCATH=LCATH*IFAC
C  initialise boundary indices for sections of device
C  one section per processor
       DO 210 I=1,128
         ISLMIN(I)=1
         ISLMAX(I)=LMAX
 210   CONTINUE
C
       ZFLEN=FLOAT(LMAX)/FLOAT(NSLAV)
       IF(ZFLEN .LT. 1.0) THEN
         PRINT *,' too many processors for problem size'
         PRINT *,' maximum processors allowed is ',LMAX
         STOP
       ENDIF
       ISLMIN(1)=1
       DO 212 J=1,NSLAV-1
         ISLMAX(J)=J*ZFLEN
         ISLMIN(J+1)=ISLMAX(J)+1
 212   CONTINUE
       ISLMAX(NSLAV)=LMAX
C
C  broadcast values to slaves
       DO 300 I=1,128
         IBUFF(I)=ISLMIN(I)
 300   CONTINUE
       CALL BRDCINT(MSPORT,IBUFF,128)
       DO 301 I=1,128
         IBUFF(I)=ISLMAX(I)
 301   CONTINUE
       CALL BRDCINT(MSPORT,IBUFF,128)
C
       IF(NBENSW .GE. 1 .AND. NBENSW .LE. 4) GOTO 250
C  insert some test particles to test boundary exchange
C  calc boundary values for this processor (mynum=its taskid)
       JMIN=ISLMIN(MYNUM+1)
       JMAX=ISLMAX(MYNUM+1)
C  jmin,jmax are mesh point numbers; zxmin,zxmax are cell boundaries
       ZXMIN=JMIN
       ZXMAX=JMAX+1.0
       ZMID=(ZXMAX+ZXMIN)/2.0
       ZXPTC=ZXMIN+4.0
       IF(ZXPTC .GT. ZMID) ZXPTC=ZMID
C
       NP=NP+1
       Q1(NP)=ZXPTC
       Q2(NP)=12.5+0.4*MYNUM
       P1(NP)=-2.0
       P2(NP)=0.0
C
       ZXPTC=ZXMAX-4.0
       IF(ZXPTC .LT. ZMID) ZXPTC=ZMID
       NP=NP+1
       Q1(NP)=ZXPTC
       Q2(NP)=13.5+0.4*MYNUM
       P1(NP)=2.0
       P2(NP)=0.0
C
 250   CONTINUE
      ENDIF
C
C  end of master program
      ELSE
C  program for slaves
C
C  isrc is a dummy place to hold the received source number
      ISRC=3
C ............................................................
      IF(K .EQ. 1) THEN
C  default of initial run
       IBUFF(1)=0
C  receive i from master
       CALL RECVINT(MSPORT,0,IBUFF,1)
       I=IBUFF(1)
       IF(I .EQ. 0) NLRES=.FALSE.
       IF(I .EQ. 1) NLRES=.TRUE.
C ..............................................................
      ELSEIF(K .EQ. 2) THEN
C  start and initialise benchmark
       CALL BENTIM(0)
       IF(NBENSW .EQ. 99) NBENSW=0
C  receive values from master
       IBUFF(1)=10
       CALL RECVINT(MSPORT,0,IBUFF,4)
       NRUN=IBUFF(1)
       IFAC=IBUFF(2)
       TIMRUN=BUFF(3)
       IRUN1=IBUFF(4)
       IF(TIMRUN .EQ. 0.0 .AND. MYNUM .EQ. NSLAV) NRUN=IRUN1
C  scale down 'electrons per superparticle'
         ELPERP=ELPERP/IFAC
C  scale up injection rate 
         NEMIT=NEMIT*IFAC 
C  scale up number of mesh cells in one direction
         LMAX=LMAX*IFAC  
C  scale up device dimensions in cell widths 
         LLEFT=LLEFT*IFAC
         LCAV=LCAV*IFAC 
         LWVANE=LWVANE*IFAC 
         LCATH=LCATH*IFAC 
C
C  initialise boundary indices for sections of device
C  one section per processor
C  receive boundary indices from master
       CALL RECVINT(MSPORT,0,IBUFF,128)
       DO 3001 I=1,128
         ISLMIN(I)=IBUFF(I)
 3001  CONTINUE
       CALL RECVINT(MSPORT,0,IBUFF,128)
       DO 3011 I=1,128
         ISLMAX(I)=IBUFF(I)
 3011   CONTINUE
C
       IF(NBENSW .GE. 1 .AND. NBENSW .LE. 4) GOTO 2501
       IF(.TRUE.) GOTO 2501
C  insert some test particles to test boundary exchange
C  calc boundary values for this processor (mynum=its taskid)
       JMIN=ISLMIN(MYNUM+1)
       JMAX=ISLMAX(MYNUM+1)
C  jmin,jmax are mesh point numbers; zxmin,zxmax are cell boundaries
       ZXMIN=JMIN
       ZXMAX=JMAX+1.0
       ZMID=(ZXMAX+ZXMIN)/2.0
       ZXPTC=ZXMIN+4.0
       IF(ZXPTC .GT. ZMID) ZXPTC=ZMID
C
       NP=NP+1
       Q1(NP)=ZXPTC
       Q2(NP)=12.5+0.4*MYNUM
       P1(NP)=-2.0
       P2(NP)=0.0
C
       ZXPTC=ZXMAX-4.0
       IF(ZXPTC .LT. ZMID) ZXPTC=ZMID
       NP=NP+1
       Q1(NP)=ZXPTC
       Q2(NP)=13.5+0.4*MYNUM
       P1(NP)=2.0
       P2(NP)=0.0
C
 2501  CONTINUE
      ENDIF
C
C  end of slave program
       ENDIF
C
       END
C
C/ module c0s5
C
         SUBROUTINE RECORD(KLEDGE,KCALL,KRET)
C
C 0.5  read and write restart records
C
C
       IMPLICIT COMPLEX(C),  DOUBLE PRECISION(D), LOGICAL(L)
C
       CHARACTER S1148(16)*48,S118(5)*8
C
       COMMON/CHABAS/ S1148,S118
       COMMON/COMBAS/ R11(3),I11(108),L11(2)
       COMMON/COMDDP/ I19(65),L19(161)
       COMMON/COMCON/ R21(8)
       COMMON/COMSTT/ R22(225202)
       COMMON/COMDEV/ R23(823),I23(113)
       COMMON/COMDIA/ R24(327),I24(202)
       COMMON/COMKLY/ R25(4)
       COMMON/COMNUM/ R31(14),I31(8)
       COMMON/COMSCA/ R32(16)
       COMMON/COMHOK/ R41(36),I41(10)
       COMMON/COMGEO/ R42(13312),I42(21506)
       COMMON/COMOUT/ R51(17),I51(9)
C
C
      COMMON /GRAFIX/ MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,
     1       IBLK,IWHT,IRED,IGRN,IBLU,IYEL,IMAG,ICYA,SRPORT
      INTEGER MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,SRPORT
      COMMON /MTINY/ MYNUM,NSLAV,NTASK,ISLMIN(128),ISLMAX(128)
C
      DIMENSION BR11(113)
      EQUIVALENCE(R11(1),BR11(1))
C---------------------------------------------------------------------
         IF(.TRUE.) RETURN
         GO TO (100,200),KCALL
C---------------------------------------------------------------------
Cl              1.         write record
C
  100    CONTINUE
         WRITE(KLEDGE)
     .   S1148,S118,
     .   R11,I11,L11,I19,L19,R21,R22,R23,I23,R24,I24,R25,R31,I31,R32,
     .   S1148,S118,
     .   R41,I41,R42,I42,R51,I51
         RETURN
C
C---------------------------------------------------------------------
Cl              2.         read record
C
  200    CONTINUE
         READ(KLEDGE,END=202,ERR=203)
     .   S1148,S118,
     .   R11,I11,L11,I19,L19,R21,R22,R23,I23,R24,I24,R25,R31,I31,R32,
     .   S1148,S118,
     .   R41,I41,R42,I42,R51,I51
C
       IF(MYNUM .EQ. 0) THEN
C  master program
C  broadcast restart information to slaves
         CALL BRDCINT(MSPORT,R25,4)
       ELSE
C  slave program
C  receive restart information from master
         CALL RECVINT(MSPORT,ISRC,R25,4)
      ENDIF
C
C     success
  201    KRET=1
         RETURN
C
C     end of file
  202    KRET=2
         RETURN
C
C     error condition
  203    KRET=3
         RETURN
C
         END
C
         SUBROUTINE TMANAL
C-----------------------------------------------------------------------
       COMMON/COMBAS/
     +   ALTIME,   CPTIME,   NLEDGE,   NLEND,    NLRES,    NONLIN,
     +   NOUT,     NPRINT,   NREAD,    NREC,     NRESUM,   NSTEP,
     +   STIME,    LABEL1,   LABEL2,   LABEL3,   LABEL4,   LABEL5,
     +   LABEL6,   LABEL7,   LABEL8,   NDIARY,   NIN,      NPUNCH,
     +   NRUN
       REAL        ALTIME,   CPTIME,   STIME
       LOGICAL     NLEND,    NLRES
       DIMENSION
     H   LABEL1(12),         LABEL2(12),         LABEL3(12),
     H   LABEL4(12),         LABEL5(12),         LABEL6(12),
     H   LABEL7(12),         LABEL8(12)
C
C
      COMMON /GRAFIX/ MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,
     1       IBLK,IWHT,IRED,IGRN,IBLU,IYEL,IMAG,ICYA,SRPORT
      INTEGER MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,SRPORT
      COMMON /MTINY/ MYNUM,NSLAV,NTASK,ISLMIN(128),ISLMAX(128)
      COMMON/BENINT/NBENSW,NBENOR,NBENCL,NBEN1,NBEN2,NBEN3,NBEN4,NBEN5
     1 ,NBEN6,NBEN7,NBEN8,NBEN9
C
         COMMON/COMTIM/ SNTIME(20,20),SNTDIF(20,20),TLOOP(20)
         REAL ZLST10/0.0/
         SAVE ZLST10
C
C  output channel for screen
         IOUT=6
C
C  sntime(timpnt,mynum+1) time point timpnt, processor number mynum
C  1-proc calc is in mynum=nslav, times in position 20
C
         IF(MYNUM .EQ. NSLAV) THEN
           INUM1=20
         ELSE
           INUM1=MYNUM+1
           IF(INUM1 .GT. 19) INUM1=19
         ENDIF
C
         DO 100 I=2,20
           ZTIME=SNTIME(I,INUM1)-SNTIME(I-1,INUM1)
           SNTDIF(I,INUM1)=ZTIME
C          print *,'time difference at point ',i,'=',ztime,' seconds'
 100     CONTINUE
         SNTDIF(1,INUM1)=SNTIME(1,INUM1)-ZLST10
         TLOOP(INUM1)=SNTIME(10,INUM1)-ZLST10
         ZLST10=SNTIME(10,INUM1)
C  patch up time differences due to insertion of point 11,15,16,17
         SNTDIF(11,INUM1)=SNTIME(11,INUM1)-SNTIME(19,INUM1)
         SNTDIF(15,INUM1)=SNTIME(15,INUM1)-SNTIME(11,INUM1)
         SNTDIF(5,INUM1)=SNTIME(5,INUM1)-SNTIME(16,INUM1)
         SNTDIF(17,INUM1)=SNTIME(17,INUM1)-SNTIME(6,INUM1)
         SNTDIF(7,INUM1)=SNTIME(7,INUM1)-SNTIME(17,INUM1)
C  patch up time differences due to insertion of point 18,19
         SNTDIF(18,INUM1)=SNTIME(18,INUM1)-SNTIME(4,INUM1)
         SNTDIF(20,INUM1)=SNTIME(20,INUM1)-SNTIME(2,INUM1)
         SNTDIF(3,INUM1)=SNTIME(3,INUM1)-SNTIME(20,INUM1)
C  patch up time differences due to insertion of point 12
         SNTDIF(12,INUM1)=SNTIME(12,INUM1)-SNTIME(3,INUM1)
C  patch up time differences due to insertion of point 14
         SNTDIF(4,INUM1)=SNTIME(4,INUM1)-SNTIME(14,INUM1)
C
C  monitor progress to control screen every ten steps
         IF(MYNUM .EQ. 0 .AND. MOD(NSTEP,10) .EQ. 0)
     1     WRITE(IOUT,50) NSLAV,NSTEP
 50      FORMAT(1X,I2,'-processor  step = ',I4)
         IF(MYNUM .EQ. NSLAV .AND. MOD(NSTEP,10) .EQ. 0)
     1     WRITE(IOUT,51)NSTEP
 51      FORMAT(31X,'1-processor  step = ',I4)
C
         END
C
C
         SUBROUTINE TMOUT(K,IOUT)
C
C  k is processor number (ie value of mynum) for which timing analysis
C  is to be printed
C  iout is output channel, =6 for screen and nout for paper
C-----------------------------------------------------------------------
       COMMON/COMBAS/
     +   ALTIME,   CPTIME,   NLEDGE,   NLEND,    NLRES,    NONLIN,
     +   NOUT,     NPRINT,   NREAD,    NREC,     NRESUM,   NSTEP,
     +   STIME,    LABEL1,   LABEL2,   LABEL3,   LABEL4,   LABEL5,
     +   LABEL6,   LABEL7,   LABEL8,   NDIARY,   NIN,      NPUNCH,
     +   NRUN
       REAL        ALTIME,   CPTIME,   STIME
       LOGICAL     NLEND,    NLRES
       DIMENSION
     H   LABEL1(12),         LABEL2(12),         LABEL3(12),
     H   LABEL4(12),         LABEL5(12),         LABEL6(12),
     H   LABEL7(12),         LABEL8(12)
C
      COMMON /MTINY/ MYNUM,NSLAV,NTASK,ISLMIN(128),ISLMAX(128)
      COMMON/BENINT/NBENSW,NBENOR,NBENCL,NBEN1,NBEN2,NBEN3,NBEN4,NBEN5
     1 ,NBEN6,NBEN7,NBEN8,NBEN9
C
         COMMON/COMTIM/ SNTIME(20,20),SNTDIF(20,20),TLOOP(20)
C
C  sntime(timpnt,mynum+1) time point timpnt, processor number mynum
C  1-proc calc is in mynum=nslav, measured times are in position 20
C
         IF(MYNUM .NE. 0) RETURN
         IF(K .EQ. NSLAV) THEN
           INUM1=20
         ELSE
           INUM1=K+1
           IF(INUM1 .GT. 19) INUM1=19
         ENDIF
C
C  printout at end for master and 1-proc only
         IF(NBEN6 .GE. 1) RETURN
C
C  calculate distribution of time to arith, comms, graph, i/o
         ZLOOP=TLOOP(INUM1)
         ZARITH=SNTDIF(20,INUM1)+SNTDIF(13,INUM1)
     1   +SNTDIF(4,INUM1)+SNTDIF(11,INUM1)+SNTDIF(16,INUM1)   
     2   +SNTDIF(6,INUM1)+SNTDIF(7,INUM1)+SNTDIF(8,INUM1)   
     3   +SNTDIF(9,INUM1)+SNTDIF(10,INUM1)+SNTDIF(18,INUM1)   
         ZCOMMS=SNTDIF(12,INUM1)+SNTDIF(14,INUM1)+SNTDIF(15,INUM1)
     1   +SNTDIF(5,INUM1)+SNTDIF(17,INUM1)+SNTDIF(19,INUM1)   
         ZGRAPH=SNTDIF(2,INUM1)+SNTDIF(3,INUM1)
         ZOUT=SNTDIF(1,INUM1)
C  print results
         WRITE(IOUT,991) K
 991     FORMAT(1X,'     loop timing for processor :',I4,/
     1             '     -------------------------------'/)
 1001    FORMAT(1X,'output time =',F10.3,' ms')
 1002    FORMAT(1X,'scaplt time =',F10.3,' ms')
 1003    FORMAT(1X,'movcur time =',F10.3,' ms')
 1012    FORMAT(1X,'snxptc time =',F10.3,' ms')
 1013    FORMAT(1X,'cnorm  time =',F10.3,' ms')
 1014    FORMAT(1X,'snxcd  time =',F10.3,' ms')
 1004    FORMAT(1X,'bef.eb time =',F10.3,' ms')
 1018    FORMAT(1X,'surcur time =',F10.3,' ms')
 1019    FORMAT(1X,'snxcd0 time =',F10.3,' ms')
 1011    FORMAT(1X,'stepe  time =',F10.3,' ms')
 1015    FORMAT(1X,'snxe12 time =',F10.3,' ms')
 1016    FORMAT(1X,'stepb3 time =',F10.3,' ms')
 1005    FORMAT(1X,'snxb3  time =',F10.3,' ms')
 1006    FORMAT(1X,'bextrp time =',F10.3,' ms')
 1017    FORMAT(1X,'snxbav time =',F10.3,' ms')
 1007    FORMAT(1X,'surden time =',F10.3,' ms')
 1008    FORMAT(1X,'emitel time =',F10.3,' ms')
 1009    FORMAT(1X,'accel  time =',F10.3,' ms')
 1010    FORMAT(1X,'ebjcls time =',F10.3,' ms')
 1051    FORMAT(1X,'-----------------------')
 1050    FORMAT(1X,'loop   time =',F10.3,' seconds')
C
 1052    FORMAT(1X,'arith  time =',F10.3,' s,  =',F6.3,'%')
 1053    FORMAT(1X,'comms  time =',F10.3,' s,  =',F6.3,'%')
 1055    FORMAT(1X,'graph  time =',F10.3,' s,  =',F6.3,'%')
 1056    FORMAT(1X,'output time =',F10.3,' s,  =',F6.3,'%')
 1054    FORMAT(/)
C
         WRITE(IOUT,1001) 1000.0*SNTDIF(1,INUM1)
         WRITE(IOUT,1002) 1000.0*(SNTDIF(2,INUM1)+SNTDIF(3,INUM1))
         WRITE(IOUT,1003) 1000.0*SNTDIF(20,INUM1)
         WRITE(IOUT,1012) 1000.0*SNTDIF(12,INUM1)
         WRITE(IOUT,1013) 1000.0*SNTDIF(13,INUM1)
         WRITE(IOUT,1014) 1000.0*SNTDIF(14,INUM1)
         WRITE(IOUT,1004) 1000.0*SNTDIF(4,INUM1)
         WRITE(IOUT,1018) 1000.0*SNTDIF(18,INUM1)
         WRITE(IOUT,1019) 1000.0*SNTDIF(19,INUM1)
         WRITE(IOUT,1011) 1000.0*SNTDIF(11,INUM1)
         WRITE(IOUT,1015) 1000.0*SNTDIF(15,INUM1)
         WRITE(IOUT,1016) 1000.0*SNTDIF(16,INUM1)
         WRITE(IOUT,1005) 1000.0*SNTDIF(5,INUM1)
         WRITE(IOUT,1006) 1000.0*SNTDIF(6,INUM1)
         WRITE(IOUT,1017) 1000.0*SNTDIF(17,INUM1)
         WRITE(IOUT,1007) 1000.0*SNTDIF(7,INUM1)
         WRITE(IOUT,1008) 1000.0*SNTDIF(8,INUM1)
         WRITE(IOUT,1009) 1000.0*SNTDIF(9,INUM1)
         WRITE(IOUT,1010) 1000.0*SNTDIF(10,INUM1)
         WRITE(IOUT,1051)
         WRITE(IOUT,1050) ZLOOP
         WRITE(IOUT,1051)
         WRITE(IOUT,1052) ZARITH,100.0*ZARITH/ZLOOP
         WRITE(IOUT,1053) ZCOMMS,100.0*ZCOMMS/ZLOOP
         WRITE(IOUT,1055) ZGRAPH,100.0*ZGRAPH/ZLOOP
         WRITE(IOUT,1056) ZOUT,100.0*ZOUT/ZLOOP
         WRITE(IOUT,1054)
C
         END
C
         SUBROUTINE ENDRUN
C
C 4.2  terminate the run
C
C---------------------------------------------------------------------
Cl                  c1.1.    basic system parameters
       COMMON/COMBAS/
     +   ALTIME,   CPTIME,   NLEDGE,   NLEND,    NLRES,    NONLIN,
     +   NOUT,     NPRINT,   NREAD,    NREC,     NRESUM,   NSTEP,
     +   STIME,    LABEL1,   LABEL2,   LABEL3,   LABEL4,   LABEL5,
     +   LABEL6,   LABEL7,   LABEL8,   NDIARY,   NIN,      NPUNCH,
     +   NRUN
       REAL        ALTIME,   CPTIME,   STIME
       LOGICAL     NLEND,    NLRES
       DIMENSION
     H   LABEL1(12),         LABEL2(12),         LABEL3(12),
     H   LABEL4(12),         LABEL5(12),         LABEL6(12),
     H   LABEL7(12),         LABEL8(12)
C       include 'chabas.inc'
C---------------------------------------------------------------------
Cl                  c1.2.    basic system character parameters
C     chabas introduces character type for labels in fortran77
       CHARACTER*48
     +   CHLAB1,   CHLAB2,   CHLAB3,   CHLAB4,   CHLAB5,   CHLAB6,
     +   CHLAB7,   CHLAB8,   CHLAB9,   CHLB10,   CHLB11,   CHLB12,
     +   CHLB13,   CHLB14,   CHLB15,   CHLB16
       CHARACTER*8
     +   CHRDAT,   CHRTIM,   CHDATO,   CHTIMO,   CHREFN
       COMMON/CHABAS/
     +   CHLAB1,   CHLAB2,   CHLAB3,   CHLAB4,   CHLAB5,   CHLAB6,
     +   CHLAB7,   CHLAB8,   CHLAB9,   CHLB10,   CHLB11,   CHLB12,
     +   CHLB13,   CHLB14,   CHLB15,   CHLB16,   CHRDAT,   CHRTIM,
     +   CHDATO,   CHTIMO,   CHREFN


C       include 'comddp.inc'
C--------------------------------------------------------------------
Cl                  c1.9.    development and diagnostic parameters
       COMMON/COMDDP/
     I   MAXDUM,   MXDUMP,   NADUMP,   NCLASS,   NPDUMP,   NPOINT,
     I   NSUB,     NVDUMP,
     L   NLCHED,   NLHEAD,   NLOMT1,   NLOMT2,   NLOMT3,   NLREPT
       LOGICAL
     L   NLCHED,   NLHEAD,   NLOMT1,   NLOMT2,   NLOMT3,   NLREPT
       DIMENSION
     I   NADUMP(20),         NPDUMP(20),         NVDUMP(20),
     L   NLHEAD(9),          NLOMT1(50),         NLOMT2(50),
     L   NLOMT3(50)
C---------------------------------------------------------------------
C
      COMMON /MTINY/ MYNUM,NSLAV,NTASK,ISLMIN(128),ISLMAX(128)
C
       DATA        ICLASS,   ISUB/4,   2/
                                       CALL EXPERT(ICLASS,ISUB,1)
C
C---------------------------------------------------------------------
Cl              1.         write restart coordinates
C
C     reset nlres and nlend for restart
         NLRES=.TRUE.
         NLEND=.FALSE.
C     output data to channel nledge
C        open(unit=nledge,file=chlab8,err=200,form='unformatted')
C        call record(nledge,1,iret)
C        close(unit=nledge)
C        callmesage('  *****restart coordinates written*****         ' )
C final times
         CALL BLINES(2)
C        call daytim
C        print *,' time for processor 0: n-processor run'
         CALL RUNTIM
         CALL PAGE
C
         RETURN
C---------------------------------------------------------------------
 200     CALLMESAGE('  *****error opening restart file*****         ' )
         CALLMESAGE('  *****run abandoned*****         ' )
         STOP
C---------------------------------------------------------------------
         END
C
         SUBROUTINE BENTIM(K)
C  assemble and calculate genesis dmmp benchmark timing results
C
C---------------------------------------------------------------------
Cl                  c2.2     physical state
       COMMON/COMSTT/
     R   B3    ,   BAV   ,   CD1   ,   CD2   ,   E1    ,   E2    ,
     R   P1    ,   P2    ,   Q1    ,   Q2    ,   REALTN,   TIMRUN
       DIMENSION
     R   B3(605,40),        BAV(605,40),       CD1(605,40),
     R   CD2(605,40),       E1(605,40),        E2(605,40),
     R   P1(20000),          P2(20000),          Q1(20000),
     R   Q2(20000)
C
C---------------------------------------------------------------------
Cl                  c3.1     numerical parameters
       COMMON/COMNUM/
     R   C1    ,   C2    ,   CD0   ,   CURANT,   DT    ,   DX1   ,
     R   DX1DX2,   DX1OX2,   DX2   ,   DX2OX1,   ELPERP,   HLFDX1,
     R   HLFDX2,   TCACO ,
     I   LMAX  ,   LMAXP ,   LMAXP2,   MMAX  ,   MMAXP ,   MMAXP2,
     I   NEMIT ,   NP
C
C---------------------------------------------------------------------
Cl                  c1.1.    basic system parameters
       COMMON/COMBAS/
     +   ALTIME,   CPTIME,   NLEDGE,   NLEND,    NLRES,    NONLIN,
     +   NOUT,     NPRINT,   NREAD,    NREC,     NRESUM,   NSTEP,
     +   STIME,    LABEL1,   LABEL2,   LABEL3,   LABEL4,   LABEL5,
     +   LABEL6,   LABEL7,   LABEL8,   NDIARY,   NIN,      NPUNCH,
     +   NRUN
       REAL        ALTIME,   CPTIME,   STIME
       LOGICAL     NLEND,    NLRES
       DIMENSION
     H   LABEL1(12),         LABEL2(12),         LABEL3(12),
     H   LABEL4(12),         LABEL5(12),         LABEL6(12),
     H   LABEL7(12),         LABEL8(12)
C---------------------------------------------------------------------
C
      COMMON /GRAFIX/ MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,
     1       IBLK,IWHT,IRED,IGRN,IBLU,IYEL,IMAG,ICYA,SRPORT
      INTEGER MASKSZ,MSPORT,SSPORT,GPORT,GBOOT,G_TASKID,SRPORT
      COMMON /MTINY/ MYNUM,NSLAV,NTASK,ISLMIN(128),ISLMAX(128)
      COMMON/BENCOM/BENT0,BENT1,BENT2,BENT3,BENT4,BENT5,BENT6
     1 ,BENT7,BENT8,BENT9,T1P,TNP,SPEDUP
      COMMON/BENINT/NBENSW,NBENOR,NBENCL,NBEN1,NBEN2,NBEN3,NBEN4,NBEN5
     1 ,NBEN6,NBEN7,NBEN8,NBEN9
      COMMON/BENARR/NPART(1000),NPRNUM(1000),NPART1(1000)
         COMMON/COMTIM/ SNTIME(20,20),SNTDIF(20,20),TLOOP(20)
      COMMON/READIN/NBENSH,NBEN4H
C
      INTEGER IBUFF(1000)
      REAL BUFF(1000)
      EQUIVALENCE(IBUFF(1),BUFF(1))
      CHARACTER*80 CHARS,BLANK,QUIT
      CHARACTER STRNG1*1,STRNG2*8,FILOUT*15,ADJLFT*8
      EXTERNAL FUNCTION ADJLFT
      DATA BLANK/' '/,QUIT/'q'/
C        save bencom
C
         DIMENSION ZTARR(2)
C
         IF(MYNUM .EQ. 0) THEN
C  master program
         IF(K .EQ. 0) THEN
C  initialise benchmark
           CALL SECOWA(BENT0,ZTARR)
C  set defaults
           NBENSW=0
           NBENOR=1
C  nbencl=0 plot dots as black, i.e. erase them
C  nbencl=1 plot dots as colours, i.e. normal plotting
           NBENCL=1
C  nben1=0 single display, don't plot mynum=nslav (e.g. in movie demo)
C  nben1=1 split display, plot mynum=nslav (e.g. when testing)
           NBEN1=1
C  nben2=1 selects psuedo calculation without communication
C       =0 normal calculation
           NBEN2=0
C  nben3=1,2,3,4 selects problem size
           NBEN3=1
C  nben4=0 omit 1-processor calculation
C       =1 perform 1-processor calculation
           NBEN4=1
C  control extent of output
C  nben6=0 full output including time analysis of main loop
C       =1 performance metrics only, i.e. normal benchmark output
           NBEN6=1
C
           NBENSW=0
C  get input from /readin/ common
           NBENSW=NBENSH
C
           IF(NBENSW .EQ. 0) THEN
C  fixed movie display on whole screen of muli-proc only
             NBENOR=0
             NBEN1=0
             NBEN2=0
             NBEN3=1
             NBEN4=1
C
           ELSEIF(NBENSW .GE. 1 .AND. NBENSW .LE. 4) THEN
             NBEN3=NBENSW
             NBEN2=0
             NBEN4=1
C  get input from /readin/ common
             NBEN4=NBEN4H
C
           ELSEIF(NBENSW .EQ. 99) THEN
C  for testing, allow setting of orbits & split display as required
           PRINT *,' type 1 for case=1, mesh= 75x33'
           PRINT *,' type 2         =2,     =150x33'
           PRINT *,' type 3         =3,     =300x33'
           PRINT *,' type 4         =4,     =600x33'
           NBEN3=1
           READ(*,'(a80)') CHARS
           IF(CHARS .EQ. QUIT) STOP
           IF(CHARS .NE. BLANK) READ(CHARS,'(i10)') NBEN3
             PRINT *,' type 0 for movie'
             PRINT *,' type 1 for orbits'
             PRINT *,' type q to quit'
             NBENOR=0
             READ(*,'(a80)') CHARS
             IF(CHARS .EQ. QUIT) STOP
             IF(CHARS .NE. BLANK) READ(CHARS,'(i10)') NBENOR
             PRINT *,' type 0: full screen display of multi-proc only'
             PRINT *,' type 1: split display with single-proc added'
             PRINT *,' type q to quit'
             NBEN1=1
             READ(*,'(a80)') CHARS
             IF(CHARS .EQ. QUIT) STOP
             IF(CHARS .NE. BLANK) READ(CHARS,'(i10)') NBEN1
             PRINT *,' type 0: proper calculation with communication'
             PRINT *,' type 1: artificial calculation with no comms.'
             PRINT *,' type q to quit'
             NBEN2=0
             READ(*,'(a80)') CHARS
             IF(CHARS .EQ. QUIT) STOP
             IF(CHARS .NE. BLANK) READ(CHARS,'(i10)') NBEN2
             PRINT *,' type 0: omit 1-processor check calculation'
             PRINT *,' type 1: perform 1-processor check calculation'
             PRINT *,' type q to quit'
             NBEN4=1
             READ(*,'(a80)') CHARS
             IF(CHARS .EQ. QUIT) STOP
             IF(CHARS .NE. BLANK) READ(CHARS,'(i10)') NBEN4
         PRINT *,' type 0: full output with timing analysis of loop'
         PRINT *,' type 1: benchmark performance metrics only'
         PRINT *,' type q to quit'
             NBEN6=1
             READ(*,'(a80)') CHARS
             IF(CHARS .EQ. QUIT) STOP
             IF(CHARS .NE. BLANK) READ(CHARS,'(i10)') NBEN6
             NBENSW=0
           ENDIF
C
           IBUFF(1)=NBENSW
           IBUFF(2)=NBENOR
           IBUFF(3)=NBEN1
           IBUFF(4)=NBEN2
           IBUFF(5)=NBEN3
           IBUFF(6)=NBEN4
           IBUFF(7)=NBEN6
C  broadcast value to slaves
           CALL BRDCINT(MSPORT,IBUFF,7)
C  open different output file for each case
           CLOSE(UNIT=NOUT)
           WRITE(STRNG1,66) NBEN3
 66        FORMAT(I1)
           WRITE(STRNG2,67) NSLAV
 67        FORMAT(I8)
           FILOUT='lpm1c'//STRNG1//'p'//ADJLFT(STRNG2)
           OPEN(UNIT=NOUT,FILE=FILOUT)
C
         ELSEIF(K .EQ. 1) THEN
C  called just before entering timestep loop
         IALPHA=2**(NBEN3-1)
         WRITE(6,1100) NBEN3,IALPHA,LMAX,MMAX,NSLAV,NRUN
         CALL HEADER(NOUT)
         WRITE(NOUT,1102)
         WRITE(NOUT,1101)
         WRITE(NOUT,1100) NBEN3,IALPHA,LMAX,MMAX,NSLAV,NRUN
 1102    FORMAT(
     3 ' this benchmark is the simulation of an electronic device'/
     4 ' using a particle-mesh (pm) method, often also called a'/
     5 ' particle-in-cell (pic) simulation. in each timestep the'/
     6 ' electric and magnetic fields on an (lmax x mmax) mesh are'/
     7 ' advanced explicitly in time using maxwell''s equations, and'/
     8 ' the particles (electrons) are advanced in the fields using'/
     9 ' newton''s equations. '//
     1 ' the benchmark is described as local because the time scale'/
     1 ' is such that the fields may be computed explicitly, using'/
     2 ' fields only local to each mesh point. four benchmark cases'/
     3 ' are provided (nben3=1,2,3,4), giving four problem sizes'/
     4 ' described by the size factor alpha=1,2,4,8 and mesh numbers'/
     5 ' (75*alpha,33). the number of particles at the end of the'/
     6 ' run of 1 picosecond is given empirically by'/
     7 '                  628*alpha**1.172.  '/)
 1101    FORMAT(
     8 ' as the number of mesh-points increases for the same physical'/
     9 ' dimension, the time-step must be reduced to satisfy the cfl'/
     1 ' stability criterion.  this effect has an important influence'/
     2 ' on the meaning of the performance metrics. the performance'/
     3 ' is expressed in several different metrics (and units) for'/
     4 ' comparison purposes.  as well as the traditional speedup and'/
     5 ' efficiency, we give the temporal (tstep/s), simulation'/
     6 ' (sim-ps/s), and benchmark (mflop/s(lpm1)) performance, which'/
     1 ' are much more meaningful and useful measures.'//
     2 ' parallelisation is by one-dimensional domain decomposition,'/
     3 ' in the first coordinate. each processor is responsible for'/
     4 ' a slab of space, and stores the mesh-ponts and coordinates'/
     5 ' of particles in its region of space. during each timestep'/
     6 ' particle coordinates are transferred between processors as'/
     7 ' the particles move from region to region.'/)
C .................................................................
C  open files for 1-processor reslts
           OPEN(11,FILE='res1p.size1')
           OPEN(12,FILE='res1p.size2')
           OPEN(13,FILE='res1p.size3')
           OPEN(14,FILE='res1p.size4')
C  start of calculational benchmark
C  reset and start racetrack
           IF(NBENSW .LT. 1 .OR. NBENSW .GT. 4) CALL MARKST(1)
C  synchronise start of multi and uni-processor runs
           CALL BARRI(NSLAV)
           CALL SECOWA(BENT1,ZTARR)
C .................................................................
         ELSEIF(K .EQ. 2) THEN
C  called at end of stepon each timestep
C  remember number of particles in this processor this step
           ISTEP=NSTEP+1
           IF(ISTEP .GT. 1000) ISTEP=1000
           IF(ISTEP .LT. 2) ISTEP=2
           NPART(1)=MYNUM
           NPART(ISTEP)=NP
           NPRNUM(1)=MYNUM
           NPRNUM(ISTEP)=MYNUM
C  no racetrack when benchmarking
           IF(NBENSW .GE. 1 .AND. NBENSW .LE.4) RETURN
C  update racetrack
           CALL MARKST(2)
C .................................................................
         ELSEIF(K .EQ. 3) THEN
C  end of calculational benchmark
C  bent3 is multi-processor end time
           CALL SECOWA(BENT3,ZTARR)
C  finish multiprocessor race
           CALL MARKST(3)
C  count number of particles in multi-proc run
C  assume that 1-proc ends last
C  each processor sends its own number of particles as barrier signal
C  and its time to execute
      BAVNP=0.0
      J1=ISLMIN(MYNUM+1)
      J2=ISLMAX(MYNUM+1)
      DO 810 J=J1,J2
        BAVNP=BAVNP+BAV(J,12)
 810  CONTINUE
      INNP=NP
      DO 800 I=1,NSLAV-1
        CALL RECVINT(MSPORT,0,IBUFF,3)
        INNP=INNP+IBUFF(1)
C  time in ibuff(2) not used        
        BAVNP=BAVNP+BUFF(3)
 800  CONTINUE
C  1-processor calculation omitted if nben4=0
      IF(NBEN4 .EQ. 1) THEN
C  wait for uni-processor(nslav) to finish
        CALL RECVINT(MSPORT,0,IBUFF,3)
C  bent4 is uni-processor end time
           CALL SECOWA(BENT4,ZTARR)
        IN1P=IBUFF(1)
        T1P=BUFF(2)
        BAV1P=BUFF(3)
C  write 1-processor result to file
        WRITE(NBEN3+10,*) IN1P,T1P,BAV1P
      ELSEIF(NBEN4 .EQ. 0) THEN
        IN1P=1
        T1P=0.0
        BAV1P=0.0
        READ(NBEN3+10,*) IN1P,T1P,BAV1P
      ENDIF
C
        ZFAC=1.0/LMAX
        BAV1P=BAV1P*ZFAC
        BAVNP=BAVNP*ZFAC
C
C  send continuation signal to all slaves
      CALL BRDCINT(MSPORT,IBUFF,1)
C
C  ################################################### 1
C
C  receive number particles each step from slaves
        DO 840 J=1,NSLAV
          CALL RECVINT(MSPORT,0,IBUFF,NRUN+1)
C
          NPART1(1)=0
          NPRNUM(1)=0
          DO 850 JJ=2,NRUN+1
            IF(IBUFF(1) .NE. NSLAV) THEN
              IF (IBUFF(JJ) .GT. NPART(JJ)) THEN
C             replace particle number if newprocessor has more
C             ibuff(jj) is # particles, ibuff(1) is processor mynum
                NPART(JJ)=IBUFF(JJ)
                NPRNUM(JJ)=IBUFF(1)
              ENDIF
            ELSE
              NPART1(JJ)=IBUFF(JJ)
            ENDIF
 850      CONTINUE
C
 840    CONTINUE
C
C  send continuation signal to all slaves
      CALL BRDCINT(MSPORT,IBUFF,1)
C
C  ################################################### 2
C
C  calculate average number particles per step
        ZNPAR=0.0
        ZNPAR1=0.0
        DO 860 JJ=2,NRUN+1
          ZNPAR=ZNPAR+NPART(JJ)
          ZNPAR1=ZNPAR1+NPART1(JJ)
 860    CONTINUE
        ZNPAR=ZNPAR/NRUN
        ZNPAR1=ZNPAR1/NRUN
        ZPARAT=ZNPAR1/ZNPAR
C
      IF(NBEN6 .GE. 1) GOTO 875
      WRITE(NOUT,872) INNP,IN1P,ZNPAR,ZNPAR1,ZPARAT
      WRITE(6,872) INNP,IN1P,ZNPAR,ZNPAR1,ZPARAT
 872  FORMAT(/,' particle numbers'/
     1         ' ----------------'/
     1 '  number of particles in last step:',I6,' (n-proc),',
     1 I6,' (1-proc)'//
     1 '  average number of particles per timestep',/,
     1       1X,'n-proc =',F12.3,4X,'1-proc =',F12.3,4X,
     1          'ratio =',F12.3)
C
      WRITE(NOUT,871)
      WRITE(NOUT,870)(J-1,NPRNUM(J),NPART(J),NPART1(J),J=1,NRUN+1)
      WRITE(NOUT,*)
      WRITE(6,*)
 870  FORMAT(1X,I6,3I9)
 871  FORMAT(///' critical processor data'/
     1          ' -----------------------'/
     2 ' crit.proc is processor with most particles that',
     3 ' determines timing'//,22X,
     2 '  number particles each timestep'/
     1 '   step',4X,'crit.proc',4X,'n-proc',4X,'1-proc')
 875  CONTINUE
C
C
C  ################################################### 3
C
C
C  receive tmanal analysis from nslav (1-proc)
          CALL RECVINT(MSPORT,0,SNTDIF(1,20),20)
          CALL RECVINT(MSPORT,0,TLOOP(20),1)
C  print out timing analysis for n-proc using proc-0 analysis
      CALL TMOUT(0,6)
      CALL TMOUT(0,NOUT)
C  print out timing analysis for 1-proc using proc-nslav analysis
      CALL TMOUT(NSLAV,6)
      CALL TMOUT(NSLAV,NOUT)
C
C  send continuation signal to all slaves
      CALL BRDCINT(MSPORT,IBUFF,1)
C
C  ################################################### 4
C
C  calculate benchmark performance numbers and output
         PRINT *
C        print *,'bent0=',bent0,'bent1=',bent1,'bent3=',bent3,
C    1           'bent4=',bent4
C  temporal performance
           TNP=BENT3-BENT1
           T1PERF=NRUN/T1P
           TNPERF=NRUN/TNP
           ZTMRAT=TNPERF/T1PERF
C  speedup and efficiency
           SPEDUP=T1P/TNP
           EFFPCT=100.0*SPEDUP/NSLAV
C  simulation performance
           ZTRUN=1.0E+12*NRUN*DT
           SIMR1P=ZTRUN/T1P
           SIMRNP=ZTRUN/TNP
           ZSMRAT=SIMRNP/SIMR1P
C benchmark performance
           IALPHA=2**(NBEN3-1)
           INEND=628*IALPHA**1.172
           ZFLOPM=46*LMAX*MMAX
           ZFLOPP=58*INEND
           ZFLOPT=ZFLOPM+ZFLOPP
           ZMFPS1=1.0E-06*ZFLOPT*NRUN/T1P
           ZMFPSN=1.0E-06*ZFLOPT*NRUN/TNP
           ZBNRAT=ZMFPSN/ZMFPS1
C  errors
           PCTNP=100.0*FLOAT(INNP-IN1P)/FLOAT(INNP)
           PCTBAV=100.0*(BAVNP-BAV1P)/BAVNP
         PRINT *
 1100    FORMAT(10X,'basic run parameters'/
     1          10X,'===================='//
     3   ' case number,          nben3 =',I4/
     3   ' problem size factor,  alpha =',I4/
     4   '     mesh points in z,  lmax =',I4/
     5   '     mesh points in r,  mmax =',I4/
     7   ' number of processors,   p   =',I4/
     8   ' number of timesteps,   nrun =',I4//
     1          10X,'===================='/)
         WRITE(NOUT,1002) IN1P,INNP,BAV1P,BAVNP,PCTNP,PCTBAV
 1002    FORMAT(' error check'/
     1          ' -----------'/
     2   ' because the simulation uses random numbers, the multi-',
     3   'processor'/
     4   ' calculation cannot be expected to give identical results',
     5   ' to the'/
     6   ' uni-processor calculation. however, the percentage',
     7   ' difference'/
     8   ' in particle number, np, and average b-field, bav, ',
     9   ' in the last'/
     1   ' timestep, should not exceed a few percent:'//
     6   '     number particles,   np  =',I9,' (1-proc)',I9,' (p-proc)'/
     6   '     average b-field,   bav  =',1PE9.2,' (1-proc)'
     6                                   ,1PE9.2,' (p-proc)'//
     2   '     % difference np =',0PF8.3,'      % difference bav =',
     3   0PF8.3/'calculations are accepted if differences < 10%'//)
C
         WRITE(6,1022) IN1P,INNP,BAV1P,BAVNP,PCTNP,PCTBAV
 1022    FORMAT(' error check'/
     1          ' -----------'/
     6   '     number particles,   np  =',I9,' (1-proc)',I9,' (p-proc)'/
     6   '     average b-field,   bav  =',1PE9.2,' (1-proc)'
     6                                   ,1PE9.2,' (p-proc)'//
     2   '     % difference np =',0PF8.3,'      % difference bav =',
     3   0PF8.3/'calculations are accepted if differences < 10%'//)
C
         ZTOL=10.0
         IF(ABS(PCTNP) .LE. ZTOL .AND. ABS(PCTBAV) .LE. ZTOL) THEN
         WRITE(6,1010) 
         WRITE(NOUT,1010) 
 1010    FORMAT(' $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'//
     1          '        benchmark calculation acceptable'/
     2          '            you may use the results',//
     3          ' $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'//)
         ELSE
         WRITE(6,1011) 
         WRITE(NOUT,1011) 
 1011    FORMAT(' $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'//
     1          '     benchmark calculation seriously in error'/
     2          '               no results reported',//
     3          ' $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'//)
         RETURN
         ENDIF
C
         WRITE(NOUT,1003) T1P,TNP,T1PERF,TNPERF,ZTMRAT
 1003    FORMAT( ' temporal performance'/
     1           ' --------------------'/
     2 ' temporal performance is the inverse of the execution time,'/
     3 ' here expressed in units of timestep per second (tstep/s).'/
     4 ' this is the fundamental metric of performance, because it'/ 
     5 ' is in absolute units and one can guarantee that the code with'/
     5 ' the highest temporal performance executes in the least time:'//
     2   '  uniprocessor   time,          t1p =',F12.4,' s'/
     4   '  multiprocessor time,          tnp =',F12.4,' s'/
     6   '                                -------------'/
     5   '  temporal perf. (1-proc) = t1p**-1 =',F12.4,' tstep/s'/
     5   '  temporal perf. (n-proc) = tnp**-1 =',F12.4,' tstep/s'/
     6   '                              ratio =',F12.4,//)
         WRITE(NOUT,1030) T1P,TNP,SPEDUP,EFFPCT
 1030    FORMAT( ' speedup and efficiency'/
     1           ' ----------------------'/
     2   ' speedup, sp, has the traditional definition of the ratio of'/
     3   ' 1-proc to n-proc. execution time, and efficiency, ep, is'/
     4   ' speedup per processor. because speedup is a relative'/ 
     5   ' measure, the program with the highest speedup may not'/ 
     6   ' execute in the least time! be warned.'//
     2   '   uniprocessor   time,  t1p =',F12.3,' s'/
     4   '   multiprocessor time,  tnp =',F12.3,' s'/
     6   '                             -------------'/
     7   '    speedup,    sp = t1p/tnp =',F12.3/
     8   '    efficiency, ep = sp/p    =',F12.3,'%'/
     9   '                             -------------'/)
         ZDT=1.0E+12*DT
         WRITE(NOUT,1001) ZDT,ZTRUN,TIMRUN,SIMR1P,SIMRNP,ZSMRAT
 1001    FORMAT(' simulation performance'/
     1          ' ----------------------'/
     2   ' this metric measures the amount of simulated time computed'/
     3   ' in one real wall-clock second. it is the most meaningful'/
     4 ' metric for a simulation because it is what the user actually'/
     5   ' wishes to maximise. for this benchmark, the units are '/
     6   ' simulated picosecond per second (sim-ps/s). in this metric'/
     7   ' larger problems with more mesh points run slower (which in'/
     8   ' fact they do), although they generate more speedup and'/
     9   ' mflop/s! this metric also includes the fact problems with'/
     1   ' a smaller space step often must use a smaller timestep,'/
     2   ' and therefore take more timesteps to cover the same amount'/
     3   ' of simulated time '//
     2   '    timestep,   dt =',F12.3,' ps'/
     3   '    simulated time  =  nrun*dt =',F10.3,' sim-ps;',
     4   '  requested =',F8.3,' ns'/
     5   '    simulation performance(1-proc) =',F12.3,' sim-ps/s'/
     6   '    simulation performance(n-proc) =',F12.3,' sim-ps/s'/
     6   '                             ratio =',F12.3,//)
         WRITE(NOUT,1013)
         WRITE(NOUT,1012) ZFLOPM,ZFLOPP,ZFLOPT,ZMFPS1,ZMFPSN,ZBNRAT
 1013    FORMAT(' benchmark performance'/
     1          ' ---------------------'/
     2 ' this metric is calculated from the nominal number of'/
     3 ' floating-point operations needed to perform the benchmark'/
     4 ' on a single processor.  for the one-nanosecond benchmark'/
     5 ' setup here, the average number of floating-point operations'/
     6 ' per timestep is defined to be:'/
     5 '         f_b(alpha) = 46*75*33*alpha + 58*628*alpha**1.172'/
     6 ' where the size factor alpha=1,2,4,8 for cases nben3=1,2,3,4.'/
     7 ' the first term above is the work to update the fields on the'/
     7 ' mesh, and the second term is the work to move the particles.'/
     7 ' then the benchmark performance is'/
     8 '         r_b(alpha,p) = f_b(alpha)/tp(alpha,p)'/
     9 ' performance calculated in this way has the units '/
     1 ' mflop/s(lpm1). different parallel implementations may,'/
     2 ' in fact, perform more or fewer operations than the above, but'/
     3 ' they are only credited with the number given by the formula.'/
     4 ' because f_b is fixed for all codes, we can quarantee that the'/
     5 ' code with the highest benchmark performance executes in the'/
     6 ' least time.'/)
 1012    FORMAT(
     2   '    floating-point operations per timestep:'/
     3   '       mesh =',E10.3,'  particles =',E10.3,
     3   '  total =',E10.3,' flop',/
     4   '    floating-point operations per second (all steps):'/
     5 '       benchmark performance(1-proc) =',F12.3,' mflop/s(lpm1)'/
     6 '       benchmark performance(n-proc) =',F12.3,' mflop/s(lpm1)'/
     6 '                               ratio =',F12.3,//)
C
         WRITE(6,1040)
         WRITE(6,1041) TNP,T1P,NRUN,TNPERF,T1PERF,SPEDUP,EFFPCT,
     1                 SIMRNP,SIMR1P,ZMFPSN,ZMFPS1
         WRITE(NOUT,1040)
         WRITE(NOUT,1041) TNP,T1P,NRUN,TNPERF,T1PERF,SPEDUP,EFFPCT,
     1                 SIMRNP,SIMR1P,ZMFPSN,ZMFPS1
 1040    FORMAT(
     1 ' **********************************************************'/
     1 ' *                  performance summary                   *'/
     2 ' **********************************************************'/
     3 ' *             particle-mesh (pic) simulation             *'/
     3 ' *       of one nanosecond of electronic device time      *'/
     3 ' *         parallelised by 1d domain decomposition        *'/
     3 ' *--------------------------------------------------------*'/
     3 ' *                                                        *')
 1041    FORMAT(
     3 ' *                     n-proc      1-proc                 *'/
     3 ' *   elap. time :',2F12.3,              ' s               *'/
     3 ' *   numb. step :',I6,                  ' tstep           *'/
     3 ' *     temporal :',2F12.3,              ' tstep/s         *'/
     4 ' *     speedup  :',F12.3,   '                             *'/
     5 ' *   efficiency :',F12.3,   ' %                           *'/
     6 ' *   simulation :',2F12.3,              ' sim-ps/s        *'/
     7 ' *   benchmark  :',2F12.3,              ' mflop/s(lpm1)   *'/
     3 ' *                                                        *'/
     3 ' *--------------------------------------------------------*'/
     3 ' *   tstep/s    -  timestep per second                    *'/
     3 ' *   sim-ps/s   -  simulated picosec per second           *'/
     3 ' *   mflop/s    -  10**6 floating-point op. per second    *'/
     2 ' **********************************************************'//)
C
         IF(NBENSW .GE. 1 .AND. NBENSW .LE. 4) THEN
C  plot all particles at end of benchmark run on split screen
           NBEN1=1
           CALL SCAPLT(2)
         ENDIF
C
         CALL BARRI(NSLAV)
         CALL CLEAR_SCREEN(0)
         CALL BARRI(NSLAV)
C  set to full screen
         NBEN1=0
         CALL SNPFLD(1) 
         CALL SNPFLD(2) 
C ...............................................................
         ELSEIF(K .EQ. 4) THEN
C  tidy up at end of program, this is last action of program
C  close files for 1-processor reslts
           CLOSE(11)
           CLOSE(12)
           CLOSE(13)
           CLOSE(14)
C  make sure all processors leave together
           PRINT *,' ******************************'
           PRINT *,' Output for all 4 cases are sent'
           PRINT *,' to different files,'
           PRINT *,' This Benchmark Output File is:'
           PRINT *,FILOUT
           PRINT *,' copy it now from another window'
           PRINT *,' if you want it somewhere else'
           PRINT *
           PRINT *,'    cp ',FILOUT,'  yourfilename'
           PRINT *
C          print *,' Control c to finish'
           PRINT *,' ******************************'
C          read(*,'(a80)') chars
           ISTOP=0
           IF(CHARS .EQ. QUIT) ISTOP=1
           IBUFF(1)=ISTOP
           CALL BRDCINT(MSPORT,IBUFF,1)
           IF(ISTOP .EQ. 1) STOP
           CALL BARRI(NSLAV)
         ENDIF
C
         ELSE
C  program for slaves
C
         IF(K .EQ. 0) THEN
C  initialise benchmark
C  set defaults 
           NBENSW=0
           NBENOR=1
           NBENCL=1 
           NBEN1=1 
           NBEN2=0
           NBEN3=1
C  read in values from master
           CALL RECVINT(MSPORT,0,IBUFF,7) 
           NBENSW=IBUFF(1)
           NBENOR=IBUFF(2)
           NBEN1=IBUFF(3)
           NBEN2=IBUFF(4)
           NBEN3=IBUFF(5)
           NBEN4=IBUFF(6)
           NBEN6=IBUFF(7)
C ...........................................................
         ELSEIF(K .EQ. 1) THEN
           IF(NBEN4 .EQ. 0 .AND. MYNUM .EQ. NSLAV) NRUN=1
C  start of calculational benchmark
C  reset and start racetrack
           IF(NBENSW .LT. 1 .OR. NBENSW .GT. 4) CALL MARKST(1)
C  synchronise start of multi and uni-processor runs
           CALL BARRI(NSLAV)
           CALL SECOWA(BENT1,ZTARR)
C ............................................................
         ELSEIF(K .EQ. 2) THEN
C  called at end of stepon each timestep
C  remember number of particles in this processor this step
           ISTEP=NSTEP+1
           IF(ISTEP .GT. 1000) ISTEP=1000
           IF(ISTEP .LT. 2) ISTEP=2
           NPART(1)=MYNUM
           NPART(ISTEP)=NP
C  no racetrack when benchmarking
           IF(NBENSW .GE. 1 .AND. NBENSW .LE. 4) RETURN
C  update racetrack
           CALL MARKST(2)
C ............................................................
         ELSEIF(K .EQ. 3) THEN
C  end of calculational benchmark
C  finish uniprocessor race
           CALL SECOWA(BENT4,ZTARR)
           CALL MARKST(3)
C  number of particles, np, time and bav sent as barrier signal
      BAVNP=0.0
      J1=ISLMIN(MYNUM+1)
      J2=ISLMAX(MYNUM+1)
      DO 8101 J=J1,J2
       BAVNP=BAVNP+BAV(J,12)
 8101 CONTINUE
      IBUFF(1)=NP
      BUFF(2)=BENT4-BENT1
      BUFF(3)=BAVNP
      IF(NBEN4 .EQ. 0 .AND. MYNUM .EQ. NSLAV) GOTO 830
      CALL SENDINT(MSPORT,0,IBUFF,3)
 830  CONTINUE
C
C  wait for continuation signal
      CALL RECVINT(MSPORT,0,IBUFF,1)
C
C  ################################################# 1
C
C  send number particles in each step to master
      CALL SENDINT(MSPORT,0,NPART,NRUN+1)
C
C  master (proc0) works out which is critical processor
C  and prints critical number of particles
C
C  wait for continuation signal
      CALL RECVINT(MSPORT,0,IBUFF,1)
C
C  ################################################# 2
C
C  master prints average number of critical particles/step
C
C  ################################################# 3
C
C  send tmanal timing analysis of 1-proc (#nslav) to master
      IF(MYNUM .EQ. NSLAV) THEN
        CALL SENDINT(MSPORT,0,SNTDIF(1,20),20)
        CALL SENDINT(MSPORT,0,TLOOP(20),1)
      ENDIF
C
C  master prints out timing analysis
C
C  wait for continuation signal
      CALL RECVINT(MSPORT,0,IBUFF,1)
C
C  ################################################# 4
C
         IF(NBENSW .GE. 1 .AND. NBENSW .LE. 4) THEN
C  plot all particles at end of benchmark run on split screen
           NBEN1=1
           CALL SCAPLT(2)
         ENDIF
C  wait for show-field signal
           CALL BARRI(NSLAV)  
C  wait for clear-screen to finish
           CALL BARRI(NSLAV)  
C  set to full screen
           NBEN1=0
           IF(.FALSE.) GOTO 205
           CALL SNPFLD(1) 
           CALL SNPFLD(2) 
 205       CONTINUE
C ................................................................
         ELSEIF(K .EQ. 4) THEN
C  tidy up at end of program, this is last action of program
C  make sure all processors leave sn together
           CALL RECVINT(MSPORT,0,IBUFF,1)
           ISTOP=IBUFF(1)
           IF(ISTOP .EQ. 1) STOP
           CALL BARRI(NSLAV)
         ENDIF
C
C  end program for slaves
         ENDIF
C
         END
C
         FUNCTION ADJLFT(STRING)
C  removes leading blanks from string
         CHARACTER*8 ADJLFT,STRING
         CHARACTER ST1*8/'        '/,BLANK*1/' '/
C
C  isw=0 means leading blank, isw=1 means enclosed blank
         ISW=0
         I=1
         DO 100 J=1,8
           IF(STRING(J:J) .NE. BLANK .OR. ISW .EQ. 1) THEN
             ST1(I:I)=STRING(J:J)
             J=J+1
             ISW=1
           ENDIF
 100     CONTINUE
         ADJLFT=ST1

         END

      SUBROUTINE INIT( PSI, PSIDOT, RANDOM, NCOLOR)  
C     ---------------------------------------------

      INTEGER VSIZE, NCOLOR
      COMMON /VECLEN/ VSIZE

      INTEGER SEED, INNODE 
      DOUBLE PRECISION N2
      LOGICAL  STORED   
      COMMON / RANDOM / N2, SEED, INNODE, STORED

      DOUBLE PRECISION  PSI(VSIZE), PSIDOT(VSIZE), RANDOM(VSIZE)

C  @@@@  Communication Structure  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C  @                                                                  @
      CALL INITND
      IF( INNODE .EQ. 0) PRINT *, 'initnode finished'
C  @                                                                  @
C  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      CALL INITSH

      IF (NCOLOR .EQ. 3) THEN
        CALL INISU3 
      ELSE
        PRINT *, ' ERROR ! invalid value of ncolor -', NCOLOR,
     *           ' - in subroutine init'
        STOP
      ENDIF

C  @@@@  Communication Structure  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C  @                                                                  @
      IF( INNODE .EQ. 0) PRINT *, 'initsu finished'
C  @                                                                  @
C  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      CALL INITPD( PSI, PSIDOT, RANDOM)
      CALL INIPSI( PSI, PSIDOT)

      END

      SUBROUTINE INIPSI( PSI, PSIDOT)
C     --------------------------------

      INTEGER VSIZE
      COMMON /VECLEN/ VSIZE
      DOUBLE PRECISION  PSI( VSIZE ), PSIDOT( VSIZE )

C     -------------------------------------------------------------------
C     |  Initialise {psi} at t = -(1/2):                                |
C     |                                                                 |
C     |      {psi}  =  {z1 + i.z2}/omega  -  half.h * {psidot}          |
C     |                                                                 |
C     |  where z1, z2 are normally distributed with std.dev = SQRT(2).  |
C     |                                                                 |
C     |  N.B.1   !! We assume that 'omega' = 1. !!                      |
C     |  N.B.2   !! Need {psidot} to be defined already !!              |
C     -------------------------------------------------------------------
      INTEGER  NSWEEP
      DOUBLE PRECISION     H,  HALFH,  MQUARK,  MSQ 
      COMMON / PARAMS / H,  HALFH,  MQUARK,  MSQ,  NSWEEP

      CALL RANDV ( PSI )
      CALL ADDSCV ( PSI, PSI, - HALFH, PSIDOT )
      END

      SUBROUTINE DVEC (SIGN, USITES, U, DU)
C     -------------------------------------

      INCLUDE 'qcd2.inc'

      INTEGER  SIGN, USITES
      DOUBLE PRECISION  U( VSIZE ), DU( VSIZE ), V( VSIZE ),
     *      USHIFT( VSIZE )

      INTEGER NINIT
      PARAMETER ( NINIT = NSITES * NCOLOR**(NCOLOR-1) )
      DOUBLE PRECISION     GAUGE ( NINIT, 4, 0:1 )
      COMMON / LINKS / GAUGE

      INTEGER     I, TDIR,  XDIR,  YDIR,  ZDIR,  EVEN,  ODD,
     *            PSENSE,  NSENSE,  PLUS,  MINUS,  RE,  IM,  VSITES
      PARAMETER ( TDIR = 1,    XDIR = 2,    YDIR = 3,    ZDIR = 4,
     *            EVEN = 0,     ODD = 1,   PSENSE= 0,   NSENSE= 1,
     *            PLUS = 0,   MINUS = 1,      RE = 1,      IM = 2 )

C     -----------------------------------------------------------------------
C     |       Performs the [matrix] * {vector} product :                    |
C     |                                                                     |
C     |              {Du} = +/- [D] {u}                                     |
C     |                                                                     |
C     |  [D]         is the Dirac matrix                                    |
C     |  {u}, {Du}   are fermion vectors (defined only at even or odd sites)|
C     |  sign      = 'plus' or 'minus' (the sign on the rhs of above eqn)   |
C     |  usites    = 'odd'  or 'even'  (the parity of the sites at which    |
C     |                                                   {u} is defined).  |
C     |                                                                     |
C     |  Explanation                                                        |
C     |  -----------                                                        |
C     |      [D] only has non-zero elements between sites at opposite ends  |
C     |  of the same link.                                                  |
C     |      Consider a general site 'i'.  Let '(i + mu)' represent the site|
C     |  at the end of the link emerging from site 'i' in the POSITIVE  'mu'|
C     |  direction,  and '(i - mu)' represent the site at the end of the    |
C     |  NEGATIVE 'mu' link.  Then, {Du} at site 'i' is the sum of 8 terms  |
C     |  (one for each link from 'i'):                                      |
C     |                                                                     |
C     |                                                                     |
C     |  {Du}i  =  SUM  D(i,i+mu) * u(i+mu)   +   SUM  D(i,i-mu) * u(i-mu)  |
C     |         +ve dirns                      -ve dirns                    |
C     |             mu                             mu                       |
C     |                                                                     |
C     |                                                                     |
C     |       Each term in the sum is evaluated (for all sites 'i') by a    |
C     |  single call to DVECDIR.   DVECDIR contains a loop over sites,      |
C     |  which may be vectorised.                                           |
C     |---------------------------------------------------------------------|
C     |  Negative directions                                                |
C     |  -------------------                                                |
C     |                                                                     |
C     |       v (i) = D (i,j) * u (j),   where site j = (i-mu).             |
C     |                                                                     |
C     |                    u(j)             v(i)                            |
C     |                      <---- D(i,j) -----                             |
C     |                      j                i                             |
C     |                                                                     |
C     |       In this case :                                                |
C     |               D(i,j) = - herm. conj. [ gauge(j,i) ],                |
C     |  so the relevant gauge matrix is associated with the site 'j' at    |
C     |  the end of the link (where u (j) is defined).                      |
C     |       To vectorise over sites, the elements of {u}, {v} and         |
C     |  [gauge] must be aligned (i.e. corresponding elements stored at     |
C     |  corresponding positions).  Hence:                                  |
C     |                                                                     |
C     |  (1) Call DVECDIR to evaluate :                                     |
C     |                                                                     |
C     |         'vshifted (j)'  =  - herm.conj. [gauge(j,i)] * u(j)         |
C     |                                                                     |
C     |    for all 'usites' j (in DVECDIR).  (N.B. By 'usites' we mean      |
C     |    the sites, even or odd, at which vector {u} is defined).         |
C     |      Now the result for site 'i',  v (i),  is held in the vector    |
C     |    {vshifted} at a position corresponding to site 'j'.              |
C     |                                                                     |
C     |  (2) Shift all the 'vshifted (j)' in the positive direction         |
C     |    (along the link) to the corresponding sites 'i':                 |
C     |    vshifted (j)  -->  v (i)    (using SHIFTVEC).                    |
C     |                                                                     |
C     |  (3) Accumulate {v} in {Du}.                                        |
C     |                                                                     |
C     |---------------------------------------------------------------------|
C     |  Positive directions                                                |
C     |  -------------------                                                |
C     |                                                                     |
C     |       v (i) = D (i,j) * u (j),   where site j = (i+mu).             |
C     |                                                                     |
C     |                    v(i)             u(j)                            |
C     |                      ----- D(i,j) ---->                             |
C     |                      i                j                             |
C     |                                                                     |
C     |       In this case,  D(i,j) = gauge(i,j),  so the appropriate       |
C     |   gauge matrix is associated with site 'i'  (at the start of the    |
C     |   link, the same as v (i)).                                         |
C     |       To vectorise over sites, the elements of {u}, {v} and         |
C     |  [gauge] must be aligned (i.e. corresponding elements stored at     |
C     |  corresponding positions).  Hence:                                  |
C     |                                                                     |
C     |  (1) Shift all the u (j) in the negative direction (along the link) |
C     |    to the corresponding sites 'i':    u (j) --> ushifted (i)        |
C     |    (using SHIFTVEC).                                                |
C     |                                                                     |
C     |  (2) Perform                                                        |
C     |                 v(i)  =  gauge(i,j) * ushifted(i)                   |
C     |                                                                     |
C     |    for all 'vsites' i (in DVECDIR).  (N.B. 'vsites' means the       |
C     |    sites, even or odd, at which vector {v} is defined).             |
C     |      The result v (i)  for site 'i' is now held at the correct      |
C     |    position in vector {v}, so no further shift is necessary.        |
C     |                                                                     |
C     |  (3) Accumulate {v} in {Du}.                                        |
C     |                                                                     |
C     |---------------------------------------------------------------------|
C     |  Communications                                                     |
C     |  --------------                                                     |
C     |       When a vector is shifted in one of the dimensions that are    |
C     |  distributed over several processors (viz. x, y or z), the 'edge    |
C     |  sites in that direction have to be shifted to and from the         |
C     |  neighbour processors in that direction.  Eg, for a +x shift of     |
C     |  vector u (t,x,y,z..), the 'edge', u (t,segx,y,z..) for all t,y,z.. |
C     |  has to be moved TO the +x neighbour, and the 'edge' u (t,1,y,z..)  |
C     |  is input FROM the -x neighbour.  These edge communications are     |
C     |  INITIATED by calls to  SEND,  but they do not have to be           |
C     |  COMPLETED until the corresponding RECEIVE.                         |
C     |  This allows edge communications to be overlapped with internal     |
C     |  shifts.                                                            |
C     -----------------------------------------------------------------------



C     -------------------------------
C     |   Positive directed links   |
C     -------------------------------
      VSITES = 1 - USITES

C------ + t direction :

      CALL  SHIFTV ( U, USITES, TDIR, NSENSE, USHIFT )
      CALL  DVDIR ( PSENSE, GAUGE (1, TDIR, VSITES), USHIFT, DU )

C------ - t direction :

      CALL  DVDIR ( NSENSE, GAUGE (1, TDIR, USITES), U, USHIFT )
      CALL  SHIFTV ( USHIFT, USITES, TDIR, PSENSE, V )
      DO 20 I = 1, VSIZE
 20     DU(I) = DU(I) + V(I)

C------ + x direction

      CALL  SHIFTV ( U, USITES, XDIR, NSENSE, USHIFT )
C     CALL  blshft ( u, usites, xdir, nsense, ushift )

      CALL  DVDIR ( PSENSE, GAUGE (1, XDIR, VSITES), USHIFT, V )
      DO 120 I = 1, VSIZE
 120    DU(I) = DU(I) + V(I)

C------ + y direction

      CALL  SHIFTV ( U, USITES, YDIR, NSENSE, USHIFT )
C     CALL  blshft ( u, usites, ydir, nsense, ushift )

      CALL  DVDIR ( PSENSE, GAUGE (1, YDIR, VSITES), USHIFT, V )
      DO 220 I = 1, VSIZE
 220    DU(I) = DU(I) + V(I)

C------ + z direction

C     CALL  shiftv ( u, usites, zdir, nsense, ushift )
      CALL  BLSHFT ( U, USITES, ZDIR, NSENSE, USHIFT )

      CALL  DVDIR ( PSENSE, GAUGE (1, ZDIR, VSITES), USHIFT, V )
      DO 320 I = 1, VSIZE
 320    DU(I) = DU(I) + V(I)


C     -------------------------------
C     |   Negative directed links   |
C     -------------------------------

C------ - x direction :

      CALL  DVDIR ( NSENSE, GAUGE (1, XDIR, USITES), U, USHIFT )

      CALL  SHIFTV ( USHIFT, USITES, XDIR, PSENSE, V )
C     CALL  blshft ( ushift, usites, xdir, psense, v )

      DO 420 I = 1, VSIZE
 420    DU(I) = DU(I) + V(I)

C------ - y direction :

      CALL  DVDIR ( NSENSE, GAUGE (1, YDIR, USITES), U, USHIFT )

      CALL  SHIFTV ( USHIFT, USITES, YDIR, PSENSE, V )
C     CALL  blshft ( ushift, usites, ydir, psense, v )

      DO 520 I = 1, VSIZE
 520    DU(I) = DU(I) + V(I)

C------ - z direction :

      CALL  DVDIR ( NSENSE, GAUGE (1, ZDIR, USITES), U, USHIFT )

C     CALL  shiftv ( ushift, usites, zdir, psense, v )
      CALL  BLSHFT ( USHIFT, USITES, ZDIR, PSENSE, V )

      DO 620 I = 1, VSIZE
 620    DU(I) = DU(I) + V(I)


C------ Result has now been accumulated in 'Du'.  All that remains is to 
C------ scale 'Du' by  +/-(1/2).

      IF  (SIGN  .EQ.  PLUS)  THEN
        DO 700 I =1, VSIZE
 700      DU(I) =   0.5D0 * DU(I)
      ELSE 
        DO 720 I =1, VSIZE
 720      DU(I) =  -0.5D0 * DU(I)
      ENDIF

      END

C     *******************************
      DOUBLE PRECISION FUNCTION DRAND(SEED)
C     *******************************
C
C
C     DOUBLE  PRECISION  FUNCTION  DRAND RETURNS PSEUDO RANDOM NUMBERS,
C     HOMOGENEOUSLY  DISTRIBUTED  IN  THE INTEVAL [0,1].  IT  USES  THE
C     LINEAR CONGRUENCE METHOD.  THE  PERIOD OF THE GENERATOR IS 2**23.
C     IF SEED IS NOT EQUAL TO ZERO, SEED IS USED  AS  A NEW START VALUE
C     FOR THE ALGORITHM; OTHERWISE DRAND RETURNS THE NEXT RANDOM NUMBER
C     OF THE SEQUENCE. THE  SPECTRAL  PROPERTIES  OF THE GENERATOR HAVE
C     NOT BEEN TESTED.
C
C
C     CALLS DBLE, MOD
C
C
C     LATEST REVISION - JULY 12, 1989; E.KEHL
C
C
      INTEGER SEED,A,B,M,X
C
      DOUBLE PRECISION NORM
C
      SAVE X
      DATA X/0/
C
      DATA NORM/ 0.83886070000000000E+07 /
      DATA M/ 8388608 /
C
      DATA A,B/129,1/
C
C
      IF( SEED .LT. 0 ) SEED = - SEED
      IF( SEED .NE. 0 ) X = SEED
      IF( SEED .GT. M ) THEN
          SEED = MOD(SEED,M) + 1
          X    = SEED
      ENDIF
C
      IC = 0
   10 X = MOD( A * X + B , M )
C
      DRAND = DBLE(X) / NORM

      IF( DRAND .GE. 1.D0 .OR. DRAND .LE. 0.D0 ) THEN
          IC = IC + 1
          IF( IC .GT. 1 ) THEN
              PRINT *,'ERROR IN DRAND'
              STOP
          ENDIF
          GOTO 10
      ENDIF
C
      RETURN
      END

      SUBROUTINE INIT( PSI, PSIDOT, RANDOM, NCOLOR)  
C     ---------------------------------------------

      INTEGER VSIZE, NCOLOR
      COMMON /VECLEN/ VSIZE

      DOUBLE PRECISION  PSI(VSIZE), PSIDOT(VSIZE), RANDOM(VSIZE)

      CALL INITSH

      IF (NCOLOR .EQ. 3) THEN
        CALL INISU3 
      ELSE
        PRINT *, ' ERROR ! invalid value of ncolor -', NCOLOR,
     *           ' - in subroutine init'
        STOP
      ENDIF

      PRINT *, 'initsu finished'

      CALL INITPD( PSI, PSIDOT, RANDOM)
      CALL INIPSI( PSI, PSIDOT)

      END

      SUBROUTINE OUTPUT( PSI, PSIDOT, TEMP, DV, NLATT, LASTSW)
C     --------------------------------------------------------

      INTEGER NLATT, VSIZE
      COMMON /VECLEN/ VSIZE
      DOUBLE PRECISION  PSI(VSIZE), PSIDOT(VSIZE), TEMP(VSIZE)
      DOUBLE PRECISION  DV(VSIZE)
      LOGICAL LASTSW

C     --------------------------------------------------------------------
C     |    Calculate and output the KE, PE, and total E for the current  |
C     |  timestep.                                                       |
C     |    The quantities are evaluated at integer time, i.e. at the     |
C     |  time at which {psidot} is defined.   {psi} is defined at a      |
C     |  time (h/2) earlier, and so has to be extrapolated forward.      |
C     --------------------------------------------------------------------

      INTEGER  NSWEEP
      DOUBLE PRECISION     H,  HALFH,  MQUARK,  MSQ
      COMMON / PARAMS / H,  HALFH,  MQUARK,  MSQ,  NSWEEP

      INTEGER  FLOPS, NITER
      DOUBLE PRECISION     MFLOPS, TIME
      COMMON / RESULT / TIME, FLOPS, NITER

      INTEGER  COUNT
      DOUBLE PRECISION  AVTIME, MXTIME, MNTIME, KE, PE, SCPROD
      SAVE AVTIME, MXTIME, MNTIME, COUNT
      DATA COUNT, AVTIME, MXTIME, MNTIME /-1, 0.0D0, 0.0D0, 1.0D9/



C     ----------------------------------------------
C     |  KE  =  ( psidot, F, psidot ) -- exactly   |
C     ----------------------------------------------

      CALL FVEC (PSIDOT, TEMP, DV)
      KE = SCPROD (PSIDOT, TEMP ) / NLATT

C     --------------------------------------------------------------------
C     |  PE  =  (omega * |psi|) **2     (we take omega = 1).             |
C     |  Have to extrapolate {psi} (t=-1/2) forward by half a timestep.  |
C     --------------------------------------------------------------------

      CALL ADDSCV (TEMP, PSI, HALFH, PSIDOT)
      PE = SCPROD  (TEMP, TEMP) / NLATT

      MFLOPS = FLOPS / TIME * 1.0D-6

C     --------------------------------------
C     |   Output results for this sweep    |
C     --------------------------------------

      WRITE(6,99)
     *       ' ', KE,          PE,          (KE + PE),
     *            NITER,       TIME,         MFLOPS
99    FORMAT(A,  F10.6,  3X,  F10.6,  2X,  F11.6,  3X,
     *            I5,     2X,  F13.6,  3X,  F13.6)

      WRITE(8,99)
     *       ' ', KE,          PE,          (KE + PE),
     *            NITER,       TIME,         MFLOPS


C------ form average over sweeps and output if this is last sweep

      IF( COUNT .GE. 0) THEN
        AVTIME = AVTIME + TIME
        IF( TIME .GT. MXTIME) MXTIME = TIME
        IF( TIME .LT. MNTIME) MNTIME = TIME
      END IF
      COUNT = COUNT + 1

      IF(LASTSW) THEN
        AVTIME = AVTIME / COUNT
        MFLOPS = MFLOPS * TIME / AVTIME
        WRITE(8, '(//A, I4, A// 2(A, F13.6, A/))')
     *       ' Averages over', COUNT, ' cycles' ,
     *       ' maximum time is', MXTIME, ' s' ,
     *       ' minimum time is', MNTIME, ' s'
        WRITE(8, '( 2(A, F13.3, A/))')
     *       ' Average time is       ', AVTIME, ' s' ,
     *       ' Average performance is', MFLOPS, ' Mflop/s'
      END IF
 
      END

      SUBROUTINE INITPD( PSI, PSIDOT, RANDOM)  
C     ---------------------------------------

      INTEGER VSIZE
      COMMON /VECLEN/ VSIZE

      DOUBLE PRECISION  PSI(VSIZE), PSIDOT(VSIZE), RANDOM(VSIZE)

C     --------------------------------------------------------------------
C     |  Initialise the fermion vector  {psidot}  at t = 0 .             |
C     |  The correct distribution is obtained by solving :               |
C     |                                                                  |
C     |               [-D + m] {psidot}  =  {z1 + i.z2}                  |
C     |                                                                  |
C     |  where z1, z2 are normally distributed with std.dev. SQRT (2).   |
C     |  [D] is the Dirac matrix, which is a function of the gauge       |
C     |  fields (see the introduction).                                  |
C     |                                                                  |
C     |    This is solved for {psidot} using Conjugate Gradient (CG)     |
C     |  iteration.  However, CG can only solve for hermitian matrices,  |
C     |  so need to multiply both sides by  hc.[-D + m] = [ D + m],      |
C     |  and solve :                                                     |
C     |                                                                  |
C     |           [-D*D + m*m] {psidot}  =  [D + m] {z1 + i.z2}          |
C     |                                                                  |
C     |  N.B. !! Need the gauge fields U to be defined already !!        |
C     --------------------------------------------------------------------

      INTEGER     TDIR,  XDIR,  YDIR,  ZDIR,  EVEN,  ODD,
     *            PSENSE,  NSENSE,  PLUS,  MINUS,  RE,  IM
      PARAMETER ( TDIR = 1,    XDIR = 2,    YDIR = 3,    ZDIR = 4,
     *            EVEN = 0,     ODD = 1,   PSENSE= 0,   NSENSE= 1,
     *            PLUS = 0,   MINUS = 1,      RE = 1,      IM = 2 )

      INTEGER  NSWEEP
      INTEGER  MAXIT, SIGFIG
      DOUBLE PRECISION     H,  HALFH,  MQUARK,  MSQ
      COMMON / PARAMS / H,HALFH,MQUARK,MSQ,NSWEEP,MAXIT,SIGFIG

      INTEGER SEED, INNODE 
      DOUBLE PRECISION N2
      LOGICAL  STORED   
      COMMON / RANDOM / N2, SEED, INNODE, STORED

C     ---------------------------------------------------------------------
C     |(i)                                                                |
C     |                 {random} = [D] {z1 + i.z2}                        |
C     |                                                                   |
C     |  {z1 + i.z2}  is put in  {psidot}  for temporary storage.  It is  |
C     |  defined at ODD sites, so  {random}  is defined at EVEN sites.    |
C     ---------------------------------------------------------------------

      CALL RANDV (PSIDOT)                   
      CALL DVEC (PLUS, ODD, PSIDOT, RANDOM)
C  @@@@  Communication Structure  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C  @                                                                  @
      IF( INNODE .EQ. 0) PRINT *, 'Initial Dvec finished'
C  @                                                                  @
C  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                             
C     ---------------------------------------------------------------------
C     |(ii)                                                               |
C     |                 {random} = {random} + m {z1 + i.z2}               |
C     |                                                                   |
C     |  where {z1 + i.z2} is defined on EVEN sites this time and so is   |
C     |  a different random vector.  (Again it is put in  {psidot}  for   |
C     |  temporary storage.                                               |
C     |    Therefore,                                                     |
C     |                 {random} = [D + m] {z1 + i.z2}                    |
C     |                                                                   |
C     |  defined at even sites.                                           |
C     ---------------------------------------------------------------------

      CALL RANDV (PSIDOT)
      CALL ADDSCV (RANDOM, RANDOM, MQUARK, PSIDOT)

C     ----------------------------------------
C     |(iii)                                 |
C     |  Solve    [F] {psidot} = {random}    |
C     ----------------------------------------

      CALL SOLVE (PSIDOT, RANDOM)

      END

      SUBROUTINE FVEC (V, FV, DV)  
C     ---------------------------

      INTEGER VSIZE
      COMMON /VECLEN/ VSIZE

      DOUBLE PRECISION   V(VSIZE), FV(VSIZE), DV(VSIZE)

C     ----------------------------------------------------------
C     |  Performs the [matrix] * {fermion.vector} product :    |
C     |                                                        |
C     |              {Fv} = [F] {v}                            |
C     |                   = ( -[D][D] + m.sq ) {v}             |
C     |                                                        |
C     |  where {v} and {Fv} are defined on EVEN sites.         |
C     ----------------------------------------------------------

      INTEGER     TDIR,  XDIR,  YDIR,  ZDIR,  EVEN,  ODD,
     *            PSENSE,  NSENSE,  PLUS,  MINUS,  RE,  IM
      PARAMETER ( TDIR = 1,    XDIR = 2,    YDIR = 3,    ZDIR = 4,
     *            EVEN = 0,     ODD = 1, PSENSE= 0, NSENSE= 1,
     *            PLUS = 0,   MINUS = 1,      RE = 1,      IM = 2 )
      INTEGER  NSWEEP
      DOUBLE PRECISION     H,  HALFH,  MQUARK,  MSQ 
      COMMON / PARAMS / H,  HALFH,  MQUARK,  MSQ,  NSWEEP


      CALL DVEC   ( PLUS, EVEN, V,  DV )
      CALL DVEC   ( MINUS, ODD, DV, FV )
      CALL ADDSCV ( FV,  FV, MSQ, V )
      END

      SUBROUTINE COPVEC (V, U)  
C     -------------------------
      INTEGER VSIZE
      COMMON /VECLEN/ VSIZE
      DOUBLE PRECISION   U(VSIZE), V(VSIZE)

C     ------------------------------- 
C     |        Set {v} = {u}        | 
C     ------------------------------- 
      INTEGER I

      DO 8  I = 1, VSIZE
        V (I) = U (I) 
   8  CONTINUE
      END

      SUBROUTINE RANDS5 ( X ) 
C     -----------------------
      DOUBLE PRECISION     X (6)
C     ---------------------------------------------------------
C     |  Returns a random unit vector x (6), with uniform     |
C     |   distribution over the unit 5-sphere (S5)            |
C     ---------------------------------------------------------
      INTEGER  SEED
      DOUBLE PRECISION     N2,  RAND
      LOGICAL  STORED
      COMMON / RANDOM / N2, SEED, STORED
      INTEGER  I
      DOUBLE PRECISION     L, LSQ


C------ Generate 'x' uniformly distributed inside a 6-cube (with sides [-1,1])

  1   CONTINUE
        LSQ = 0.0D0
        DO 8  I = 1, 6
          X(I) = (2.0D0 * RAND (SEED)) - 1.0D0
          LSQ  = LSQ + (X(I) * X(I))
  8     CONTINUE


C------ Accept 'x' if it inside the unit 5-sphere (only 8% probability!).
C------ Otherwise generate a new 'x' :

      IF  ((LSQ .GT. 1.0D0) .OR. (LSQ .LT. 1.0D-6))  GO TO 1


C------ 'x' is now uniformly distributed INSIDE the unit 5-sphere (S5).
C------ Normalise it to length 1, so it is uniformly distributed ON S5 :

      L = SQRT (LSQ)
      DO 18  I = 1, 6
        X(I) = X(I) / L
 18   CONTINUE
      END

      SUBROUTINE INITSH
C     --------------------
C     ---------------------------------------------------
C     |    Set up address arrays for vector shifts.     |
C     ---------------------------------------------------
      INCLUDE 'qcd2.inc'

      INTEGER     XSIZE,  YSIZE,  ZSIZE
      PARAMETER ( XSIZE  =  SEGT * SEGY * SEGZ * NCOLOR,
     *            YSIZE  =  SEGT * SEGX * SEGZ * NCOLOR,
     *            ZSIZE  =  SEGT * SEGX * SEGY * NCOLOR )

      INTEGER  POST (VSIZE, 0:1),  NEGT (VSIZE, 0:1), 
     *         POSX (VSIZE),      NEGX (VSIZE),
     *         POSY (VSIZE),      NEGY (VSIZE),
     *         POSZ (VSIZE),      NEGZ (VSIZE)
      COMMON / ISHIFT / POST, POSX, POSY, POSZ, NEGT, NEGX, NEGY, NEGZ 

      INTEGER  BEGX( XSIZE), ENDX( XSIZE), BEGY( YSIZE), ENDY( YSIZE),
     *         BEGZ( ZSIZE), ENDZ( ZSIZE)
      COMMON / ENDS / BEGX, ENDX, BEGY, ENDY, BEGZ, ENDZ

      INTEGER  I, T, X, Y, Z, PAR, NDEST, PDEST, SOURCE, NFINAL
      PARAMETER ( NFINAL = NCMPLX * NCOLOR )

      INTEGER  DUMMY, COUNT
      INTEGER  FLAT, PARITY

      PARITY (T,X,Y,Z) = MOD (T + X + Y + Z, 2)
      FLAT (T,X,Y,Z,I) = (T+1)/2 + (SEGT/2) * ((X-1) + SEGX * 
     *                   ((Y-1) + SEGY * ((Z-1) + SEGZ * (I-1)))) 

      DO 1000 I = 1, NFINAL
C     ---------------
C     |   t shifts  |
C     ---------------
                DO 80  Z = 1, SEGZ
                  DO 70  Y = 1, SEGY
                    DO 60  X = 1, SEGX

                      PAR    =  PARITY (1, X, Y, Z)
                      SOURCE =    FLAT (1, X, Y, Z,I)
                      PDEST   =    FLAT ( 2, X, Y, Z,I)
                      POST (SOURCE, PAR) = PDEST
                      NDEST   =    FLAT ( SEGT, X, Y, Z,I)
                      NEGT (SOURCE, PAR) = NDEST

                      DO 50  T = 2, (SEGT-1)
                        SOURCE =    FLAT (T, X, Y, Z,I)
                        PDEST   =    FLAT ((T+1), X, Y, Z,I)
                        PAR    =  PARITY (T, X, Y, Z) 
                        POST (SOURCE, PAR) = PDEST
                        NDEST   =    FLAT ((T-1), X, Y, Z,I)
                        NEGT (SOURCE, PAR) = NDEST
 50                   CONTINUE

                      PAR    =  PARITY (SEGT, X, Y, Z)
                      SOURCE =    FLAT (SEGT, X, Y, Z,I)
                      PDEST   =    FLAT ( 1, X, Y, Z,I)
                      POST (SOURCE, PAR) = PDEST
                      NDEST   =    FLAT ( (SEGT-1), X, Y, Z,I)
                      NEGT (SOURCE, PAR) = NDEST

 60                 CONTINUE
 70               CONTINUE
 80             CONTINUE

C     ---------------
C     |   x shifts  |
C     ---------------
C  Following line is inserted to workround compile bug
                DUMMY = 0

                DO 180  Z = 1, SEGZ
                  DO 170  Y = 1, SEGY
                    DO 160  T = 1, (SEGT-1), 2

                      COUNT = (T+1)/2 + SEGT/2 * ( (Y-1) + SEGY * 
     *                        ( (Z-1) + SEGZ * (I-1) ))
                      SOURCE =  FLAT (T, 1, Y, Z,I)
                      BEGX( COUNT) = SOURCE
                      PDEST   =  FLAT (T, 2, Y, Z,I)
                      POSX (SOURCE) = PDEST
                      NDEST   =  FLAT (T, SEGX, Y, Z,I)
                      NEGX (SOURCE) = NDEST

                      DO 150  X = 2, (SEGX-1)
                        SOURCE =  FLAT (T, X, Y, Z,I)
                        PDEST   =  FLAT (T, (X+1), Y, Z,I)
                        POSX (SOURCE) = PDEST
                        NDEST   =  FLAT (T, (X-1), Y, Z,I)
                        NEGX (SOURCE) = NDEST
 150                  CONTINUE

                      SOURCE =  FLAT (T, SEGX, Y, Z,I)
                      ENDX( COUNT) = SOURCE
                      PDEST   =  FLAT (T, 1, Y, Z,I)
                      POSX (SOURCE) = PDEST
                      NDEST   =  FLAT (T, (SEGX-1), Y, Z,I)
                      NEGX (SOURCE) = NDEST

 160                CONTINUE
 170              CONTINUE
 180            CONTINUE

C     ---------------
C     |   y shifts  |
C     ---------------
C  Following line is inserted to workround compile bug
                DUMMY = 0

                DO 280  Z = 1, SEGZ
                  DO 270  X = 1, SEGX
                    DO 260  T = 1, (SEGT-1), 2

                      COUNT = (T+1)/2 + SEGT/2 * ( (X-1) + SEGX * 
     *                        ( (Z-1) + SEGZ * (I-1) ))
                      SOURCE =  FLAT (T, X, 1, Z,I)
                      BEGY( COUNT) = SOURCE
                      PDEST   =  FLAT (T, X, 2, Z,I)
                      POSY (SOURCE) = PDEST
                      NDEST   =  FLAT (T, X, SEGY, Z, I)
                      NEGY (SOURCE) = NDEST

                      DO 250  Y = 2, (SEGY-1)
                        SOURCE =  FLAT (T, X, Y, Z,I)
                        PDEST   =  FLAT (T ,X, (Y+1), Z,I)
                        POSY (SOURCE) = PDEST
                        NDEST   =  FLAT (T ,X, (Y-1), Z,I)
                        NEGY (SOURCE) = NDEST
 250                  CONTINUE

                      SOURCE =  FLAT (T, X, SEGY, Z,I)
                      ENDY( COUNT) = SOURCE
                      PDEST   =  FLAT (T, X, 1, Z,I)
                      POSY (SOURCE) = PDEST
                      NDEST   =  FLAT (T, X, (SEGY-1), Z,I)
                      NEGY (SOURCE) = NDEST


 260                CONTINUE
 270              CONTINUE
 280            CONTINUE

C     ---------------
C     |   z shifts  |
C     ---------------
C  Following line is inserted to workround compile bug
                DUMMY = 0

                DO 380  Y = 1, SEGY
                  DO 370  X = 1, SEGX
                    DO 360  T = 1, (SEGT-1), 2

                      COUNT = (T+1)/2 + SEGT/2 * ( (X-1) + SEGX * 
     *                        ( (Y-1) + SEGY * (I-1) ))
                      SOURCE =  FLAT (T, X, Y, 1,I)
                      BEGZ( COUNT) = SOURCE
                      PDEST   =  FLAT (T, X, Y, 2,I )
                      POSZ (SOURCE) = PDEST
                      NDEST   =  FLAT (T, X, Y, SEGZ, I )
                      NEGZ (SOURCE) = NDEST

                      DO 350  Z = 2, (SEGZ-1)
                        SOURCE =  FLAT (T, X, Y, Z,I)
                        PDEST   =  FLAT (T, X, Y, (Z+1),I) 
                        POSZ (SOURCE) = PDEST
                        NDEST   =  FLAT (T, X, Y, (Z-1),I) 
                        NEGZ (SOURCE) = NDEST
 350                  CONTINUE

                      SOURCE =  FLAT (T, X, Y, SEGZ,I)
                      ENDZ( COUNT) = SOURCE
                      PDEST   =  FLAT (T, X, Y, 1,I )
                      POSZ (SOURCE) = PDEST
                      NDEST   =  FLAT (T, X, Y, (SEGZ-1),I )
                      NEGZ (SOURCE) = NDEST

 360                CONTINUE
 370              CONTINUE
 380            CONTINUE

 1000 CONTINUE

      END

      SUBROUTINE SUBVEC (DIFF, U, V)  
C     ------------------------------
      INTEGER VSIZE
      COMMON /VECLEN/ VSIZE
      DOUBLE PRECISION  DIFF(VSIZE), U(VSIZE), V(VSIZE)

C     -------------------------------- 
C     |      {diff} = {u} - {v}      | 
C     --------------------------------
      INTEGER I

      DO 8  I = 1, VSIZE
        DIFF (I) = U (I) - V (I)
   8  CONTINUE
      END

      SUBROUTINE DVDIR (SENSE, GAUGE, U, V)
C     ---------------------------------------

      INCLUDE    'qcd2.inc'

      INTEGER     SENSE
      DOUBLE PRECISION    GAUGE ( NSITES/2, NCOLOR, NCOLOR, NCMPLX )
      DOUBLE PRECISION    U ( NSITES/2, NCOLOR, NCMPLX ),
     *                    V ( NSITES/2, NCOLOR, NCMPLX )

C     -----------------------------------------------------------------------
C     |  Calculates :                                                       |
C     |                                                                     |
C     |          v (i) = D (i,j) * u (j),                                   |
C     |                                                                     |
C     |  for all sites 'i' at which {v} is defined (i.e. all even or odd    |
C     |  sites), for a particular link direction and sense.                 |
C     |                                                                     |
C     |  'sense'  =  sense of the link (ij)                                 |
C     |              (positive = 'psense', negative = 'nsense'              |
C     |                                                                     |
C     |        This subroutine is called with the arrays {u}, {v} and       |
C     |  [gauge] all aligned, such that the corresponding elements,         |
C     |  v (i), gauge (i,j) and u (j), are stored at the same array         |
C     |   positions.   Thus the inner loop over sites can be VECTORISED !   |
C     |                                                                     |
C     -----------------------------------------------------------------------
      INTEGER     TDIR,  XDIR,  YDIR,  ZDIR,  EVEN,  ODD,
     *            PSENSE,  NSENSE,  PLUS,  MINUS,  RE,  IM
      PARAMETER ( TDIR = 1,    XDIR = 2,    YDIR = 3,    ZDIR = 4,
     *            EVEN = 0,     ODD = 1,   PSENSE= 0,   NSENSE= 1,
     *            PLUS = 0,   MINUS = 1,      RE = 1,      IM = 2 )
      INTEGER  SITE,  I

      IF  (SENSE  .EQ.  PSENSE) THEN
C     --------------------------------
C     -----------------------------------------------------------------------
C     |  Positive sense link                                                |
C     |  -------------------                                                |
C     |       v (i) = D (i,j) * u (j),   where site j = (i+mu).             |
C     |                                                                     |
C     |       In this case,  D(i,j) = gauge(i)  (only that segment of       |
C     |  the total gauge field array corresponding to the given link        |
C     |  direction and sense is passed in).   Also, the {u} vector          |
C     |  that is input has been shifted so that the sites are aligned:      |
C     |  u (i) = 'real' u (j).   Thus, we calculate:                        |
C     |                                                                     |
C     |       v (i) = gauge (i) * u (i)     for all sites 'i'               |
C     -----------------------------------------------------------------------
          DO 110  I = 1, NCOLOR
            DO 100  SITE = 1, NSITES/2

              V (SITE, I, RE) =
     *                       GAUGE (SITE, I, 1, RE) * U (SITE, 1, RE)       
     *                     - GAUGE (SITE, I, 1, IM) * U (SITE, 1, IM)
     *                     + GAUGE (SITE, I, 2, RE) * U (SITE, 2, RE)
     *                     - GAUGE (SITE, I, 2, IM) * U (SITE, 2, IM)
     *                     + GAUGE (SITE, I, 3, RE) * U (SITE, 3, RE)
     *                     - GAUGE (SITE, I, 3, IM) * U (SITE, 3, IM)

              V (SITE, I, IM) =
     *                       GAUGE (SITE, I, 1, RE) * U (SITE, 1, IM)
     *                     + GAUGE (SITE, I, 1, IM) * U (SITE, 1, RE)
     *                     + GAUGE (SITE, I, 2, RE) * U (SITE, 2, IM)
     *                     + GAUGE (SITE, I, 2, IM) * U (SITE, 2, RE)
     *                     + GAUGE (SITE, I, 3, RE) * U (SITE, 3, IM)
     *                     + GAUGE (SITE, I, 3, IM) * U (SITE, 3, RE)

 100        CONTINUE
 110      CONTINUE

        ELSE
C       ----
C     -----------------------------------------------------------------------
C     |  Negative sense link                                                |
C     |  -------------------                                                |
C     |       v (i) = D (i,j) * u (j),   where site j = (i-mu).             |
C     |                                                                     |
C     |       In this case,  D(i,j) = - herm.conj [ gauge(j,i) ]            |
C     |                             = - herm.conj [ gauge (j) ]             |
C     |                                                                     |
C     |  since only that segment of the total gauge field array             |
C     |  corresponding to the given link direction and sense is passed      |
C     |  in.   Also, the {v} vector that is input has been shifted so       |
C     |  that the sites are aligned:   v (j) = 'real' v (i).                | 
C     |       Thus, we calculate:                                           |
C     |                                                                     |
C     |  v (j)  =  - herm.conj [ gauge (j) ] * u (j)      for all sites 'j' |
C     -----------------------------------------------------------------------
          DO 210  I = 1, NCOLOR
            DO 200  SITE = 1, NSITES/2

              V (SITE, I, RE) =
     *                  - (  GAUGE (SITE, 1, I, RE) * U (SITE, 1, RE)       
     *                     + GAUGE (SITE, 1, I, IM) * U (SITE, 1, IM)
     *                     + GAUGE (SITE, 2, I, RE) * U (SITE, 2, RE)
     *                     + GAUGE (SITE, 2, I, IM) * U (SITE, 2, IM)
     *                     + GAUGE (SITE, 3, I, RE) * U (SITE, 3, RE)
     *                     + GAUGE (SITE, 3, I, IM) * U (SITE, 3, IM) )

              V (SITE, I, IM) =
     *                     - GAUGE (SITE, 1, I, RE) * U (SITE, 1, IM)
     *                     + GAUGE (SITE, 1, I, IM) * U (SITE, 1, RE)
     *                     - GAUGE (SITE, 2, I, RE) * U (SITE, 2, IM)
     *                     + GAUGE (SITE, 2, I, IM) * U (SITE, 2, RE)
     *                     - GAUGE (SITE, 3, I, RE) * U (SITE, 3, IM)
     *                     + GAUGE (SITE, 3, I, IM) * U (SITE, 3, RE)

 200        CONTINUE
 210      CONTINUE
      ENDIF

      END

      DOUBLE PRECISION FUNCTION SCPROD (U, V)
C     -----------------------------
      INTEGER VSIZE
      COMMON /VECLEN/ VSIZE
      DOUBLE PRECISION   U(VSIZE),  V(VSIZE)

C     -------------------------------------------------------------------
C     |  Returns the REAL part of the hermitian scalar product :        |
C     |                                                                 |
C     |                   scprod = (u+, v)                              |
C     |                                                                 |
C     |  where {u} and {v} are fermion vectors.                         |
C     -------------------------------------------------------------------
      INTEGER  I
      DOUBLE PRECISION   SUM

      SUM = 0.0D0
      DO 8  I = 1, VSIZE
        SUM = SUM + (U (I) * V (I))
   8  CONTINUE

      SCPROD = SUM
      END

C     *******************
      REAL FUNCTION GETCL()
C     *******************

      INTEGER FIRST
      DOUBLE PRECISION TIMEI, TIME
      SAVE TIMEI, FIRST
      DATA FIRST/0/

      IF (FIRST .EQ. 0) THEN

         CALL TIMER (TIMEI)
         GETCL = 0.0
         FIRST = 1

      ELSE

	 CALL timer(TIME)
         GETCL = (TIME - TIMEI) 

      ENDIF

      END
